Package: ATACseqQC
Type: Package
Title: ATAC-seq Quality Control
Version: 1.37.0
Author: Jianhong Ou, Haibo Liu, Feng Yan, Jun Yu, Michelle Kelliher,
        Lucio Castilla, Nathan Lawson, Lihua Julie Zhu
Maintainer: Jianhong Ou <jou@morgridge.org>
Description: ATAC-seq, an assay for Transposase-Accessible Chromatin
        using sequencing, is a rapid and sensitive method for chromatin
        accessibility analysis. It was developed as an alternative
        method to MNase-seq, FAIRE-seq and DNAse-seq. Comparing to the
        other methods, ATAC-seq requires less amount of the biological
        samples and time to process. In the process of analyzing
        several ATAC-seq dataset produced in our labs, we learned some
        of the unique aspects of the quality assessment for ATAC-seq
        data.To help users to quickly assess whether their ATAC-seq
        experiment is successful, we developed ATACseqQC package
        partially following the guideline published in Nature Method
        2013 (Greenleaf et al.), including diagnostic plot of fragment
        size distribution, proportion of mitochondria reads, nucleosome
        positioning pattern, and CTCF or other Transcript Factor
        footprints.
Depends: R (>= 3.5.0), BiocGenerics, S4Vectors
Imports: BSgenome, Biostrings, ChIPpeakAnno, IRanges, GenomicRanges,
        GenomicAlignments, GenomeInfoDb, GenomicScores, graphics, grid,
        limma, Rsamtools (>= 1.31.2), randomForest, rtracklayer, stats,
        motifStack, preseqR, utils, KernSmooth, edgeR, BiocParallel
Suggests: BiocStyle, knitr, BSgenome.Hsapiens.UCSC.hg19,
        TxDb.Hsapiens.UCSC.hg19.knownGene, phastCons100way.UCSC.hg19,
        MotifDb, trackViewer, testthat, rmarkdown
License: GPL (>= 2)
VignetteBuilder: knitr
RoxygenNote: 7.3.2
biocViews: Sequencing, DNASeq, ATACSeq, GeneRegulation, QualityControl,
        Coverage, NucleosomePositioning, ImmunoOncology
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/ATACseqQC
git_branch: devel
git_last_commit: a1d815a
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-29 20:24:42 UTC; biocbuild

# ATACseqQC

[![platforms](http://bioconductor.org/shields/availability/devel/ATACseqQC.svg)](http://bioconductor.org/packages/devel/bioc/html/ATACseqQC.html)
[![build](http://bioconductor.org/shields/build/devel/bioc/ATACseqQC.svg)](http://bioconductor.org/packages/devel/bioc/html/ATACseqQC.html)

ATAC sequencing Quality Control


ATAC-seq, an assay for Transposase-Accessible Chromatin using 
sequencing, is a rapid and sensitive method for chromatin accessibility 
analysis. It was developed as an alternative method to MNase-seq, FAIRE-seq 
and DNAse-seq. Comparing to the other methods, ATAC-seq requires less amount 
of the biological samples and time to process. In the process of analyzing 
several ATAC-seq dataset produced in our labs, we learned some of the unique 
aspects of the quality assessment for ATAC-seq data.To help users to quickly 
assess whether their ATAC-seq experiment is successful, we developed 
ATACseqQC package partially following the guideline published in Nature 
Method 2013 (Greenleaf et al.), including diagnostic plot of fragment size 
distribution, proportion of mitochondria reads, nucleosome positioning 
pattern, and CTCF or other Transcript Factor footprints.

## Installation

To install this package, start R and enter:

```r
library(BiocManager)
BiocManager::install("ATACseqQC")
```

## Documentation

To view documentation of ATACseqQC, start R and enter:
```r
browseVignettes("ATACseqQC")
```

#' Detect peak positions
#'
#' Detect the peaks positions and valley positions. The algorithm is modified
#' from github::dgromer/peakdet
#'
#' @param y A vector of numeric where to search peaks
#' @param delta A numeric of length 1, defining the local threshold
#' for peak detection. If it is set to 0, the delta will be set to
#' 1/10 of the range of y.
#' @param silence logical(1). 
#' If false, echo the delta value when delta is set as 0.
#'
#' @return A list with peakpos and valleypos. Both peakpos and valleypos are
#' vectors of numeric which indicate the positions of peak or valley.
#'

peakdet <- function(y, delta=0, silence=TRUE){
    peakpos <- NULL
    valleypos <- NULL
    stopifnot(delta>=0)
    if(delta==0){
        ry <- quantile(y, c(0, .25, .75, 1))[2:3]
        delta <- diff(ry)/10
        if(!silence){
            message("auto set delta = ", prettyNum(delta))
        }
    }
    minpos <- 1
    maxpos <- 1
    lookformax <- TRUE

    for(i in seq_along(y)){
        if (y[i] > y[maxpos]){
            maxpos <- i
        }
        if (y[i] < y[minpos]){
            minpos <- i
        }

        if (lookformax){
            if (y[i] < y[maxpos] - delta){
                peakpos <- c(peakpos, maxpos)
                minpos <- i
                lookformax <- FALSE
            }
        }else{
            if (y[i] > y[minpos] + delta){
                valleypos <- c(valleypos, minpos)
                maxpos <- i
                lookformax <- TRUE
            }
        }
    }

    list(peakpos = peakpos, valleypos = valleypos)
}

#' Distance of potential nucleosome dyad
#' @description Calculate the distance of potential nucleosome dyad and the linear model for V.
#' @param vPlotOut The output of \link{vPlot}.
#' @param fragLenRanges  A numeric vector (length=3) for fragment size of nucleosome free and mono-nucleosome.
#' Default c(60, 180, 250).
#' @param draw Plot the results or not. Default TRUE.
#' @param ... Prameters could be passed to plot.
#' @return an invisible list with distance of nucleosome and the linear model.
#' @importFrom stats loess.smooth lm
#' @importFrom graphics abline
#' @export
#' @author Jianhong Ou
#' @seealso \link{vPlot}
#' @examples 
#'bamfile <- system.file("extdata", "GL1.bam",
#'                        package="ATACseqQC")
#'library(MotifDb)
#'CTCF <- query(MotifDb, c("CTCF"))
#'CTCF <- as.list(CTCF)
#'library(BSgenome.Hsapiens.UCSC.hg19)
#'vp <- vPlot(bamfile, pfm=CTCF[[1]],
#'      genome=Hsapiens,
#'      min.score="95%", seqlev="chr1",
#'      draw=FALSE)
#'distanceDyad(vp)
#'      
distanceDyad <- function(vPlotOut, fragLenRanges=c(60, 180, 250), draw=TRUE, ...){
  stopifnot(length(fragLenRanges)==3)
  stopifnot(is(fragLenRanges, "numeric"))
  if(!identical(colnames(vPlotOut), c("distanceToBindingSite", "FragmentLength"))){
    stop("vPlotOut must be the output of vPlot.")
  }
  vPlotOut <- vPlotOut[vPlotOut$FragmentLength>=fragLenRanges[1] & 
                         vPlotOut$FragmentLength<=fragLenRanges[3], , drop=FALSE]
  if(length(unique(vPlotOut$distanceToBindingSite))<300){
    return(c(distanceNucl=NA, bindingWidth=NA))
  }
  data4nucl <- vPlotOut[vPlotOut$FragmentLength>=fragLenRanges[2] & 
                          vPlotOut$FragmentLength<=fragLenRanges[3], , drop=FALSE]
  data4nucl$FragmentLength <- 1
  data4nucl$distanceToBindingSite <- abs(data4nucl$distanceToBindingSite)
  data4nucl <- rowsum(data4nucl$FragmentLength, data4nucl$distanceToBindingSite)
  delta <- diff(range(data4nucl[, 1]))/4
  data4nucl <- tryCatch(loess.smooth(as.numeric(rownames(data4nucl)), data4nucl[, 1], 
                                     span=1/10, evaluation = length(data4nucl)),
                        error=function(e) NULL)
  if(length(data4nucl)==2){
    data4nucl.peak <- peakdet(data4nucl$y, delta = delta)
    if(length(data4nucl.peak$peakpos)>0){
      data4nucl.peak$x <- data4nucl$x[data4nucl.peak$peakpos]
      data4nucl.peak$y <- data4nucl$x[data4nucl.peak$peakpos]
      data4ncul.peak <- data4nucl.peak$x[which.max(data4nucl.peak$y)]
    }else{
      data4ncul.peak <- max(data4nucl$x)
    }
  }else{
    data4ncul.peak <- max(data4nucl$x)
  }
  
  distanceNucl <- c(-1 * data4ncul.peak, data4ncul.peak)
  
  data4bw.bk.1 <- data4bw <- vPlotOut[vPlotOut$distanceToBindingSite > -250 & 
                                        vPlotOut$distanceToBindingSite < 250,, drop=FALSE]
  data4bw$FragmentLength <- floor(data4bw$FragmentLength/10)*10 + 5
  data4bw <- split(data4bw$distanceToBindingSite, data4bw$FragmentLength)
  data4bw <- lapply(data4bw, table)
  data4bw.names <- unique(unlist(sapply(data4bw, names), use.names = FALSE))
  data4bw <- do.call(cbind, lapply(data4bw, function(.ele) .ele[match(data4bw.names, names(.ele))]))
  data4bw[is.na(data4bw)] <- 0
  data4bw <- as.data.frame(data4bw)
  data4bw.names <- as.numeric(data4bw.names)
  suppressWarnings({
    data4bw <- lapply(data4bw, function(.ele){
      .ele <- tryCatch(loess.smooth(data4bw.names, .ele, span=1/10, evaluation = length(data4bw.names)),
                       error=function(e) NULL)
      if(length(.ele)==0){
        return(NULL)
      }
      .peak <- peakdet(.ele$y)
      .valley <- .ele$x[.peak$valleypos]
      vl <- .valley[.valley < 0]
      vr <- .valley[.valley > 0]
      if(length(vl)) {
        vl <- vl[which.max(vl)]
        #if(vl < distanceNucl[1]) return(NULL)
      }else{
        return(NULL)
      }
      if(length(vr)){
        vr <- vr[which.min(vr)]
        #if(vr > distanceNucl[2]) return(NULL)
      }else{
        return(NULL)
      }
      c(vl=vl, vr=vr)
    })
  })
  data4bw <- do.call(cbind, data4bw)
  data4bw <- data4bw[, apply(data4bw, 2, function(.ele) !any(is.na(.ele)))]
  data4bw.colsum <- colSums(data4bw)
  data4bw.mean <- mean(abs(data4bw))
  data4bw <- data4bw[, abs(data4bw.colsum) < data4bw.mean/5, drop=FALSE]
  data4bw <- colMeans(abs(data4bw))
  data4bw <- data4bw[seq.int(which.max(data4bw))]
  
  if(length(data4bw)>=3){
    data4bw <- data.frame(x=data4bw, y=as.numeric(names(data4bw)))
    lm <- lm(y ~ 0+x, data4bw) ## cross zero
    if(summary(lm)$r.squared>.9){
      coefficient <- summary(lm)$coefficients[1]
      ## rotate matrix
      coefficients <- coefficient + seq(-0.5, .5, by = 0.02)
      angels <- -atan(coefficients)
      data4bw.bk.rot <- lapply(angels, function(angel){
        R <- matrix(c(cos(angel), sin(angel), -sin(angel), cos(angel)), nrow = 2)
        data4bw.bk <- data4bw.bk.1
        data4bw.bk$distanceToBindingSite <- abs(data4bw.bk$distanceToBindingSite)
        data4bw.bk <- t(R %*% t(as.matrix(data4bw.bk)))
        data4bw.bk <- round(data4bw.bk, digits = 0)
        list(a=data4bw.bk, b=sum(data4bw.bk[, 2]==0))
      })
      data4bw.bk.rot.min <- which.min(sapply(data4bw.bk.rot, function(.ele) .ele$b))
      data4bw.bk.rot.min <- data4bw.bk.rot.min[which.min(abs(data4bw.bk.rot.min-25))]
      coefficient <- coefficients[data4bw.bk.rot.min]
      data4bw.bk <- data4bw.bk.rot[[data4bw.bk.rot.min]]$a
      data4bw.bk <- sapply(split(data4bw.bk[, 1], data4bw.bk[, 2]), mean, na.rm=FALSE)
      data4bw.bk <- tryCatch(loess.smooth(x=as.numeric(names(data4bw.bk)), y=data4bw.bk, 
                                 span=1/10, evaluation = length(data4bw.bk)),
                             error=function(e) NULL)
      if(length(data4bw.bk)==2){
        data4bw.bk <- as.data.frame(data4bw.bk)
        data4bw.bk.peak <- peakdet(data4bw.bk$y)
        if(length(data4bw.bk.peak$valleypos)>0){
          data4bw.bk.bottom <- min(data4bw.bk$x[data4bw.bk.peak$valleypos])
        }else{
          data4bw.bk.bottom <- 0
        }
        if(length(data4bw.bk.peak$peakpos)>0){
          zero <- which(data4bw.bk$x==data4bw.bk.bottom)
          data4bw.bk.peak <- data4bw.bk.peak$peakpos[which.min(abs(data4bw.bk.peak$peakpos - zero))]
          if(data4bw.bk.peak<zero){
            Apoint <- data4bw.bk.peak
            Bpoint <- data4bw.bk.peak + zero
          }else{
            Apoint <- zero - (data4bw.bk.peak - zero) 
            Bpoint <- data4bw.bk.peak
          }
          Apoint <- max(c(1, Apoint))
          Bpoint <- min(c(Bpoint, nrow(data4bw.bk)))
          data4bw.bk <- data4bw.bk[Apoint:Bpoint, ]
        }
        q50 <- quantile(data4bw.bk$y, probs = .25)
        data4bw.bk.left <- data4bw.bk[data4bw.bk$x<data4bw.bk.bottom & data4bw.bk$y<q50, "x"]
        data4bw.bk.right <- data4bw.bk[data4bw.bk$x>data4bw.bk.bottom & data4bw.bk$y<q50, "x"]
        if(length(data4bw.bk.left)>0 && length(data4bw.bk.right)>0){
          bindingWidth <- max(data4bw.bk.right) - min(data4bw.bk.left)
        }else{
          bindingWidth <- NA
        }
      }else{
        bindingWidth <- NA
      }
    }else{
      coefficient <- NA
      bindingWidth <- NA
    }
  }else{
    lm <- NA
    coefficient <- NA
    bindingWidth <- NA
  }
  
  if(draw){
    plot(vPlotOut, ...)
    #lines(data4nucl, col="red")
    abline(v=distanceNucl, col="red", lty="dotdash")
    if(!is.na(coefficient)){
      abline(a=0, b=-1*coefficient, col="red", lty="dotdash")
      abline(a=0, b=coefficient, col="red", lty="dotdash")
      if(!is.na(bindingWidth)){
        abline(a=bindingWidth, b=coefficient, col="red", lty="dotdash")
        abline(a=-bindingWidth, b=coefficient, col="red", lty="dotdash")
        abline(a=bindingWidth, b=-coefficient, col="red", lty="dotdash")
        abline(a=-bindingWidth, b=-coefficient, col="red", lty="dotdash")
      }
    }
  }
  return(invisible(list(distanceNucl=diff(distanceNucl), lm=lm, bindingWidth=bindingWidth)))
}

#' Plotting Saturation curves
#' @description Plotting the saturation curves.
#' @param subsamplingPeakFiles A character vector containing peak files from peak
#' calling tools, such as MACS2. Currently only MACS2 output is supported.
#' @param subsamplingSizes A named vector of integers, which are the sizes of 
#' subsamples for peak calling. The names of subsamplingPeakFiles should be identical
#' to the basenames of subsamplingPeakFiles.
#' @param sep A character vector of length 1L, which is the column separator used 
#' in peak files.
#' @param header A boolean (TRUE or FASLE) vector of length 1L, showing whether 
#' there are column headers in the peak files.
#' @param fdr A decimal between 0 and 1, a cutoff of statistical significance of 
#' peak detection.
#' @param fdrCol An integer, column index for fdr.
#' @param startCol An integer, column index for start positions of peak regions.
#' @param endCol An integer, column index for end positions of peak regions.
#' @param skipLines An integer, the number of lines (comments or instruction) to 
#' skip when peak files are read into R.
#' @param peakCaller A character vector of length 1L contatining the name of the 
#' peak caller used to generate the peak files, such as "MACS2". Currently only 
#' MACS2 output (XXX.narrowPeak or XXX.broadPeak) is support.
#' @param outPrefix A character vector of length 1L, the file prefix for outputting
#' saturation plots.
#' @param span An integer, the span parameter for loess smoothing to fit a smoothed 
#' saturation curve.
#' @param degree An integer, the degree of local polynomial used for loess.
#' @importFrom utils read.delim
#' @importFrom stats loess.smooth
#' @importFrom grDevices dev.off pdf
#' @importFrom graphics lines
#' @return  A data frame of three columns:
#' subsamplingSizes, the number of subsampled fragments;
#' numPeaks, the number of peaks with fdr less than a given threshold when a given
#' number of fragmetns are subsampled;
#' breadth, the total breadth of peaks with fdr less than a given threshold for 
#' give subsampling when a given number of fragmetns are subsampled.
#' @export
#' @author Haibo Liu
#' @examples 
#' if(interactive()){
#' }


saturationPlot <- function(subsamplingPeakFiles, subsamplingSizes, sep="\t", 
                           header=FALSE, fdr=0.05, fdrCol=9, startCol=2, 
                           endCol=3, skipLines=1, peakCaller="MACS2", outPrefix, span=2, degree=2)
{
    ## make sure subsamplingPeakFiles positionally match subsamplingSizes
    if(is.null(names(subsamplingSizes)) || ! identical(subsamplingPeakFiles,names(subsamplingSizes)))
    {
        stop("Subsampling peak file names should match the name of subsamplingSize!")
    }
    
    peaks<- lapply(subsamplingPeakFiles, function(.ele){
        read.delim(file=.ele, sep=sep, header=header, as.is=TRUE, skip=skipLines)
    })
    
    names(peaks) <- subsamplingPeakFiles
    
    ## saturation plotting based on the number of peak regions
    numPeaks <- sapply(peaks, function(.ele){
        if (peakCaller =="MACS2")
        {
            npeaks <- sum(10^(-.ele[fdrCol]) <= fdr)  
        }
        npeaks
    }, simplify = TRUE)
    names(numPeaks) <- names(peaks)
    
    
    ## saturation plotting based on the total breadth of peak region 
    breadth <- sapply(peaks, function(.ele){
        sum(.ele[endCol] - .ele[startCol] + 1)
    }, simplify = TRUE)
    names(breadth) <- names(peaks)
    
    peakStat <- data.frame(subsamplingSizes=subsamplingSizes, numPeaks =numPeaks, breadth=breadth)
    
    ## changing scales of x and y for plotting
    subsamplingSizes <- subsamplingSizes/10^6
    numPeaks <- numPeaks/10^3
    breadth <- breadth/10^6
    
    ## plotting saturation curves based on the number of peaks and the overall peak breadth
    pdf(paste0(outPrefix, " peak number-based saturation plot.pdf"), width=5, height=5)
    plot(x= subsamplingSizes, y= numPeaks, pch=16, xlab=expression(Effective~fragments~x~10^6),
         ylab=expression(Peaks~x~10^3))
    lines(loess.smooth(x=subsamplingSizes, y=numPeaks, span = span, degree = degree,
                       family =  "gaussian", evaluation = 50))
    dev.off()
    
    pdf(paste0(outPrefix, " peak breadth-based saturation plot.pdf"), width=5, height=5)
    plot(x= subsamplingSizes, y= breadth, pch=16, xlab=expression(Effective~fragments~x~10^6),
         ylab=expression(Total~peak~breadth~(Mb)))
    lines(loess.smooth(x=subsamplingSizes, y=breadth, span = span, degree = degree,
                       family =  "gaussian", evaluation = 50))
    dev.off()
    
    return(invisible(peakStat))
}

#' @title shift read for 5'end
#' @description shift reads for 5'ends
#' @param x an object of GAlignments
#' @param positive integer(1). the size to be shift for positive strand
#' @param negative integer(1). the size to be shift for negative strand
#' @return an object of GAlignments
#' @import S4Vectors
#' @importFrom GenomicAlignments cigar qwidth sequenceLayer cigarNarrow 
#' cigarQNarrow cigarWidthAlongQuerySpace
#' @importFrom Biostrings DNAStringSet PhredQuality
#' @author Jianhong Ou
shiftReads <- function(x, positive=4L, negative=5L){
  strds <- as.character(strand(x)) == "-"
  ns <- ifelse(strds, negative, positive)
  ## fix soft-clipping
  cigars <- cigar(x)
  mcols(x)$seq <- sequenceLayer(mcols(x)$seq, cigars, 
                                from="query", 
                                to="query-after-soft-clipping")
  mcols(x)$qual <- sequenceLayer(mcols(x)$qual, cigars, 
                                 from="query", 
                                 to="query-after-soft-clipping")
  cigars <- as.character(cigarNarrow(cigars))
  cigar_width <- cigarWidthAlongQuerySpace(cigars)
  seq_width <- width(mcols(x)$seq)
  withInsertionsAt5Ends <- which(cigar_width!=seq_width)
  if(length(withInsertionsAt5Ends)>0){
    ## clip from 3'end
    mcols(x)$seq[withInsertionsAt5Ends] <- 
      substr(mcols(x)$seq[withInsertionsAt5Ends], 
             start= (seq_width+1-cigar_width)[withInsertionsAt5Ends],
             stop = seq_width[withInsertionsAt5Ends])
    mcols(x)$qual[withInsertionsAt5Ends] <- 
      substr(mcols(x)$qual[withInsertionsAt5Ends], 
             start= (seq_width+1-cigar_width)[withInsertionsAt5Ends],
             stop = seq_width[withInsertionsAt5Ends])
  }
  cigars <- cigarQNarrow(cigars, 
                         start=ifelse(strds, 1, positive+1), 
                         end=ifelse(strds, -negative-1, -1))
  x@cigar <- as.character(cigars)
  x@start <- x@start + attributes(cigars)$rshift
  
  width.x <- qwidth(x)
  if(length(mcols(x)$isize)==length(x)){
    mcols(x)$isize <- sign(mcols(x)$isize) * 
      (abs(mcols(x)$isize) - positive - negative)
  }
  ##x end will auto matic change if the cigar changed.
  mcols(x)$seq[strds] <- DNAStringSet(substr(mcols(x)$seq[strds], 1,
                                             width.x[strds]))
  mcols(x)$qual[strds] <- PhredQuality(substr(mcols(x)$qual[strds], 1,
                                              width.x[strds]))
  mcols(x)$seq[!strds] <- DNAStringSet(substr(mcols(x)$seq[!strds],
                                              ns[!strds]+1,
                                              nchar(mcols(x)$seq[!strds])))
  mcols(x)$qual[!strds] <- PhredQuality(substr(mcols(x)$qual[!strds],
                                               ns[!strds]+1,
                                               nchar(mcols(x)$qual[!strds])))
  x
}

test_that("shiftReads works not correct", {
  gal <- GAlignments(seqnames=Rle("chr1", 6), pos=1:6,
    cigar=c("47M", "50M", "50M", "50M", "50M", "50M"),
    strand=Rle(strand(c("+", "-", "+", "-")), c(1, 2, 2, 1)),
    qname=tail(letters, 6),
    qual=PhredQuality(c(
      "CCCFFFFFHHHHHJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ",
      "JJJJJJJHHJJJJIJJIIIJIIIIIIIJJJIJJIJIHFHHHHFFFFFCCC",
      "FFFFFFGHHHHJJJJJJJIJIIJJJIHG@JJJJJJJHHHFFHFDEDFCB@",
      "@CCFFFFEHGGFHGIGGIJIJJJIJJJJJJJJIJJJJJJJJJIGJIJJIJ",
      "CC@FFFFFHHHHHJJJJIIJGIIJJIIGIJIJJJIIJGHHJIJJIJJIJE",
      "DHHIIIIJIHJJJJHIIIGJJGIJJJIJIIIIIIGIGHHHHHFFFFFCCC"
    )),
    isize=c(180, -180, -265, 265, 185, -185))
  mcols(gal)$seq=DNAStringSet(c(
    "ATTTAGCTGACTCGCCACACTCCACGGAAGCAATATGAAATGATCTG",
    "GACATCGTACTACACGACACGTACTACGTTGTAGCCCACTTCCACTATGT",
    "TGAATCTCTCAGGACTCAGCAGCAGCCCACCCCCTCAACGACCTCTCCAT",
    "GACCAAGTCCGCCTCTCAGCCTCACGTTCTTAAGCAGCATCTAAGCAAAA",
    "GCAGCAGCCCACCCCCTCAACGACCTCTCCATTGGCCAGAATCTGGGACA",
    "AAAGCCACTGCCCCTCAGACCGCAGTTGCGAGTAGCACGAGGATCTGGGG"
  ))
  shifted <- ATACseqQC:::shiftReads(gal, positive=4L, negative=5L)
  shifted2 <- ATACseqQC:::shiftReads(gal, positive=5L, negative=4L)
  ns <- as.character(strand(gal))=="+"
  expect_equal(start(shifted)[ns], start(gal)[ns]+4)
  expect_equal(end(shifted)[!ns], end(gal)[!ns]-5)
  expect_equal(width(shifted)[ns], width(gal)[ns]-4)
  expect_equal(width(shifted)[!ns], width(gal)[!ns]-5)
  expect_equal(abs(mcols(shifted)$isize), abs(mcols(gal)$isize)-9)
  expect_equal(width(mcols(shifted)$seq), qwidth(shifted))
  expect_equal(width(mcols(shifted)$qual), qwidth(shifted))
  expect_equal(start(shifted2)[ns], start(gal)[ns]+5)
  expect_equal(end(shifted2)[!ns], end(gal)[!ns]-4)
  expect_equal(width(shifted2)[ns], width(gal)[ns]-5)
  expect_equal(width(shifted2)[!ns], width(gal)[!ns]-4)
  expect_equal(abs(mcols(shifted2)$isize), abs(mcols(gal)$isize)-9)
})

#' Calculating duplication frequency
#' @description Calculating the frequency of read duplication based on alignment
#' status determined by rname, strand, pos, cigar, mrnm, mpos and isize. 
#' @param bamFile A character vector of length 1L containing the name of a BAM file.
#' Only a BAM file with duplication reads are meaningful for estimating the library
#' complexity. For example, a raw BAM file output by aligners, or a BAM file with 
#' mitochondrial reads removed.
#' @param index A character vector of length 1L containing the name of a BAM index file.
#' @importFrom Rsamtools ScanBamParam scanBamFlag scanBam testPairedEndBam
#' @export
#' @return A two-column matrix of integers. The 1st column is the frequency 
#' j = 1,2,3,.... The 2nd column is the number of genomic regions with the same 
#' fequency (j) of duplication. The frequency column is in ascending order.
#' @author Haibo Liu
#' @examples 
#' bamFile <- system.file("extdata", "GL1.bam", package = "ATACseqQC")
#' freq <- readsDupFreq(bamFile)

readsDupFreq <- function(bamFile, index = bamFile){
    if(!testPairedEndBam(bamFile)){
        stop("This is not Paired-End BAM file.")
    }
    
    param <-ScanBamParam(what=c("rname", "strand", "cigar", "pos", "mrnm", "mpos", "isize"),
                         flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                          isUnmappedQuery = FALSE,
                                          isNotPassingQualityControls = FALSE))
    
    bam <- scanBam(bamFile, index=index, param=param, asMate=FALSE)
    
    lst <- lapply(names(bam[[1]]), function(.elt) {
        do.call(c, unname(lapply(bam, "[[", .elt)))
    })
    
    names(lst) <- names(bam[[1]])
    rm("bam")
    df <- do.call(data.frame, lst)
    rm("lst")
    df <-df[!is.na(df$isize) & df$isize >0, ]
    freqByPos <-
        as.data.frame(table(paste(df$rname, df$strand, df$cigar,
                                  df$pos, df$mrnm, df$isize, df$mpos,
                                  sep="_")))
    rm("df")
    freqByDuplication <- as.data.frame(table(freqByPos$Freq))
    freqByDuplication$Var1 <- as.numeric(as.character(freqByDuplication$Var1))
    freqByDuplication <- as.matrix(freqByDuplication)
    
    if (nrow(freqByDuplication) <= 3)
    {
        warning("There is not much information for estimating library complexity.\n",
             "Are you sure that you used a BAM file without remove duplication reads?", 
             call. = FALSE)
    }
    return(freqByDuplication)
}

#' @title shift 5' ends for single end reads
#' @description shift the GAlignmentsLists by 5' ends. 
#' All reads aligning to the positive strand will be offset by +4bp, 
#' and all reads aligning to the negative strand will be offset -5bp by default.
#' @param gal An object of 
#' \link[GenomicAlignments:GAlignments-class]{GAlignments}.
#' @param positive integer(1). the size to be shift for positive strand
#' @param negative integer(1). the size to be shift for negative strand
#' @param outbam file path to save shift reads. 
#' If missing, no file will be write.
#' @return An object of 
#' \link[GenomicAlignments:GAlignments-class]{GAlignments} with 5' end 
#' shifted reads.
#' @author Jianhong Ou
#' @export
#' @import S4Vectors
#' @import GenomicRanges
#' @importFrom Rsamtools mergeBam
#' @importFrom rtracklayer export
#' @examples
#' bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
#' tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' which <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
#' gal <- readBamFile(bamfile, tag=tags, 
#'                    what=c("qname", "flag", "mapq", "seq", "qual"),
#'                    which=which, asMates=FALSE, bigFile=TRUE)
#' objs <- shiftGAlignments(gal)
#' export(objs, "shift.bam")
shiftGAlignments <- function(gal, positive=4L, negative=5L, outbam){
  stopifnot(is.integer(positive))
  stopifnot(is.integer(negative))
  stopifnot(is(gal, "GAlignments"))
  if(length(gal)==0){
    ## big file mode
    meta <- metadata(gal)
    if(!all(c("file", "param") %in% names(meta))){
      stop("length of gal could not be 0.")
    }
    ow <- getOption("warn")
    on.exit(options(warn = ow))
    options(warn=-1)
    chunk <- 100000
    index <- ifelse(length(meta$index)>0, meta$index, meta$file)
    bamfile <- BamFile(meta$file, index=index, 
                       yieldSize=chunk, asMates = meta$asMates)
    outfile <- NULL
    open(bamfile)
    on.exit(close(bamfile))
    df4Duplicates <- NULL
    while (length(chunk0 <- readGAlignments(bamfile, param=meta$param))) {
      metadata(chunk0)$df4Duplicates <- df4Duplicates
      gal1 <- shiftGAlignments(chunk0, positive = positive, negative = negative)
      if(length(metadata(gal1)$df4Duplicates)){
        df4Duplicates <- read.csv(metadata(gal1)$df4Duplicates)
      }
      outfile <- c(tempfile(fileext = ".bam"), outfile)
      exportBamFile(gal1, outfile[1])
      rm(gal1)
    }
    close(bamfile)
    on.exit()
    if(length(outfile)>1){
      mergedfile <- mergeBam(outfile, 
                             destination=tempfile(fileext = ".bam"), 
                             indexDestination=TRUE,
                             header=meta$file)
      unlink(outfile)
      unlink(paste0(outfile, ".bai"))
    }else{
      if(length(outfile)==1){
        mergedfile <- outfile
      }else{
        stop("Can not get any proper mapped reads from  your inputs.")
      }
    }
    if(!missing(outbam)){
      file.rename(from=mergedfile, to=outbam)
      file.rename(from=paste0(mergedfile, ".bai"), 
                  to=paste0(outbam, ".bai"))
      gal1 <- GAlignments()
      meta$file <- outbam
      meta$asMates <- FALSE
      metadata(gal1) <- meta
    }else{
      gal1 <- readGAlignments(mergedfile, param = meta$param)
      mcols(gal1)$MD <- NULL
      names(gal1) <- mcols(gal1)$qname
      gal1 <- gal1[order(names(gal1))]
      unlink(mergedfile)
      unlink(paste0(mergedfile, ".bai"))
    }
    return(gal1)
  }
  stopifnot(length(gal)>0)
  mcols(gal)$mrnm <- NULL
  mcols(gal)$mpos <- NULL
  mcols(gal)$MC <- NULL
  checkDup <- FALSE
  if(length(metadata(gal)$keepDuplicates)){
    if(!metadata(gal)$keepDuplicates){
      checkDup <- TRUE
    }
  }else{
    checkDup <- TRUE
  }
  if(checkDup){
    if(length(metadata(gal)$df4Duplicates)){
      df0 <- metadata(gal)$df4Duplicates
    }else{
      df0 <- NULL
    }
    df <- DataFrame(seqnames=seqnames(gal), 
                    cigar=cigar(gal), 
                    start=start(gal))
    df <- rbind(df0, df)
    dupids <- duplicated(df)
    if(length(df0)) {
      df1 <- dupids[-seq.int(nrow(df0))]
    }else{
      df1 <- dupids
    }
    if(any(df1)){
      tobeRemoved <- which(df1)
      gal <- gal[-tobeRemoved]
      df <- df[-(tobeRemoved+nrow(df0)), , drop=FALSE]
      if(nrow(df)){
        df4Duplicates <- tempfile()
        write.csv(df, df4Duplicates, row.names = FALSE)
        rm(df)
        metadata(gal)$df4Duplicates <- df4Duplicates
      }
    }
  }
  gal <- shiftReads(gal, 
                    positive=positive,
                    negative=negative)
  names(gal) <- mcols(gal)$qname
  if(length(gal)<1){
    return(gal)
  }
  ## till now, gal must have names and flag
  stopifnot(length(mcols(gal)$flag)>0)
  stopifnot(length(names(gal))>0)
  mcols(gal)$mrnm <- NULL
  mcols(gal)$mpos <- NULL
  mcols(gal)$MC <- NULL
  if(!(missing(outbam))){
    tryCatch(exportBamFile(gal, outbam),
             error=function(e){
               message(e)
             })
  }
  return(gal)
}

#' @title fragment size distribution
#' @description estimate the fragment size of bams
#' @param bamFiles A vector of characters indicates the file names of bams.
#' @param index The names of the index file of the 'BAM' file being processed;
#'        This is given without the '.bai' extension.
#' @param bamFiles.labels labels of the bam files, used for pdf file naming.
#' @param ylim numeric(2). ylim of the histogram.
#' @param logYlim numeric(2). ylim of log-transformed histogram for the insert.
#' @return Invisible fragment length distribution list.
#' @importFrom Rsamtools ScanBamParam scanBamFlag scanBam idxstatsBam
#' @importFrom graphics axis par
#' @import GenomicRanges
#' @export
#' @author Jianhong Ou
#' @examples
#' bamFiles <- dir(system.file("extdata", package="ATACseqQC"), "GL.*.bam$", full.names=TRUE)
#' bamFiles.labels <- sub(".bam", "", basename(bamFiles))
#' fragSizeDist(bamFiles, bamFiles.labels)

fragSizeDist <- function(bamFiles, bamFiles.labels, index=bamFiles, ylim=NULL,
                         logYlim=NULL){
  opar <- par(c("fig", "mar"))
  on.exit(par(opar))
  pe <- mapply(testPairedEndBam, bamFiles, index)
  if(any(!pe)){
    stop(paste(bamFiles[!pe], collapse = ", "), 
         "is not Paired-End file.")
  }
  summaryFunction <- function(seqname, seqlength, bamFile, ind, ...) {
    param <-
      ScanBamParam(what=c('isize'),
                   which=GRanges(seqname, IRanges(1, seqlength)),
                   flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                    isUnmappedQuery=FALSE,
                                    isNotPassingQualityControls = FALSE))
    table(abs(unlist(sapply(scanBam(bamFile, index=ind, ..., param=param), 
                            `[[`, "isize"), use.names = FALSE)))
  }

  idxstats <- unique(do.call(rbind, mapply(function(.ele, .ind)
    idxstatsBam(.ele, index = .ind)[, c("seqnames", "seqlength")],
    bamFiles, index, SIMPLIFY=FALSE)))
  ## fix the issue that idxstatsBam return values with "*"
  idxstats <- idxstats[idxstats[, "seqnames"]!="*", , drop=FALSE]
  seqnames <- as.character(idxstats[, "seqnames"])
  seqlen <- as.numeric(idxstats[, "seqlength"])
  seqlen <- checkMaxChrLength(seqlen)
  fragment.len <-
    mapply(function(bamFile, ind)
      summaryFunction(seqname=seqnames, seqlength=seqlen, bamFile, ind), 
                         bamFiles, index, SIMPLIFY=FALSE)

  names(fragment.len) <- bamFiles.labels

  minor.ticks.axis <- function(ax,n=9,t.ratio=0.5,mn,mx,...){

    lims <- par("usr")
    lims <- if(ax %in% c(1,3)) lims[1:2] else lims[3:4]

    major.ticks <- pretty(lims,n=5)
    if(missing(mn)) mn <- min(major.ticks)
    if(missing(mx)) mx <- max(major.ticks)

    major.ticks <- major.ticks[major.ticks >= mn & major.ticks <= mx]

    labels <- sapply(major.ticks,function(i)
      as.expression(bquote(10^ .(i)))
    )
    axis(ax,at=major.ticks,labels=labels,
         las=ifelse(ax %in% c(2, 4), 2, 1), ...)

    n <- n+2
    minors <- log10(pretty(10^major.ticks[1:2],n))-major.ticks[1]
    minors <- minors[-c(1,n)]

    minor.ticks = c(outer(minors,major.ticks,`+`))
    minor.ticks <- minor.ticks[minor.ticks > mn & minor.ticks < mx]


    axis(ax,at=minor.ticks,tcl=par("tcl")*t.ratio,labels=FALSE)
  }

  null <- mapply(function(frag.len, frag.name){
    x <- 1:1010
    frag.len <- frag.len[match(x, names(frag.len))]
    frag.len[is.na(frag.len)] <- 0
    y <- frag.len / sum(frag.len)
    y <- as.numeric(y)
    names(y) <- x
    par(mar=c(5, 5, 4, 2) +.1)
    plot(x, y*10^3, main=paste(frag.name, "fragment sizes"),
         xlim=c(0, 1010), ylim=ylim,
         xlab="Fragment length (bp)",
         ylab=expression(Normalized ~ read ~ density ~ x ~ 10^-3),
         type="l")
    par(fig=c(.4, .95, .4, .95), new=TRUE)
    plot(x, log10(y), xlim=c(0, 1010), ylim=logYlim,
         xlab="Fragment length (bp)", ylab="Norm. read density",
         type="l", yaxt="n")
    minor.ticks.axis(2)
    par(opar)
  }, fragment.len, names(fragment.len))

  return(invisible(fragment.len))
}

test_that("fragSizeDist works not correct", {
  gal <- GAlignments(seqnames=Rle("chr1", 2020), pos=rep(1L, 2020),
                     cigar=rep("10M", 2020),
                     strand=Rle(strand(rep(c("+", "-"), 1010))), 
                     isize=rep(seq.int(1010), each=2) * c(1, -1),
                     qname=rep(seq.int(1010), each=2),
                     flag=rep(c(99, 147), 1010))
  seqlengths(gal) <- c("chr1"=2000)
  tmpfile <- "test.bam"
  export(gal, tmpfile)
  size <- fragSizeDist(tmpfile, "test")
  expect_true(all(size$test==2))
  expect_equal(length(size$test), 1010)
})

#' @title max PWM scores for sequences
#' @description calculate the maximal PWM scores for each given sequences
#' @param pwm A Position Weight Matrix represented as a numeric matrix
#'            with row names A, C, G and T.
#' @param subject Typically a \link[Biostrings:DNAString-class]{DNAString} object.
#'            A \link[IRanges:Views-class]{Views} object on
#'            a \link[Biostrings:DNAString-class]{DNAString} subject,
#'            a \link[Biostrings:MaskedXString-class]{MaskedDNAString} object,
#'            or a single character string, are also supported.
#'            IUPAC ambiguity letters in \code{subject} are ignored (i.e.
#'            assigned weight 0) with a warning.
#' @importFrom Biostrings DNAString PWMscoreStartingAt
#' @return a numeric vector
#' @author Jianhong

pwmscores <- function(pwm, subject){
  len <- length(subject)
  subject <- split(subject,
                   rep(seq_len(ceiling(len/1e5)), each=1e5)[seq_len(len)])
  motif.len <- ncol(pwm)
  score <- lapply(subject, function(.subject){
    .len <- length(.subject)
    .subject <- DNAString(paste(as.character(.subject), collapse=""))
    s <- PWMscoreStartingAt(pwm = pwm, subject = .subject,
                            starting.at = seq.int(80 * .len - motif.len))
    s <- split(s, rep(seq_len(.len), each=80)[seq_along(s)])
    s <- lapply(s, function(.ele) max(.ele[seq_len(80-motif.len)]))
    unname(unlist(s[order(as.numeric(names(s)))]))
  })
  unname(unlist(score[order(as.numeric(names(score)))]))
}

#' @title shift 5' ends
#' @description shift the GAlignmentsLists by 5' ends. 
#' All reads aligning to the positive strand will be offset by +4bp, 
#' and all reads aligning to the negative strand will be offset -5bp by default.
#' @param gal An object of \link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList}.
#' @param positive integer(1). the size to be shift for positive strand
#' @param negative integer(1). the size to be shift for negative strand
#' @param outbam file path to save shift reads. If missing, no file will be write.
#' @param slidingWindowSize The width of each tile when the input is big file.
#' By default 50e6, the memory cost will be about 6GB for each thread for a 5GB bam file.
#' Increase the value will increase the memory cost but may speed up the process.
#' @param BPPARAM The parallel parameters used by BiocParrallel.
#' @return An object of \link[GenomicAlignments:GAlignments-class]{GAlignments} with 5' end 
#' shifted reads. The PCR duplicated will be removed unless there is metadata
#' keepDuplicates set to TRUE.
#' @author Jianhong Ou
#' @export
#' @import S4Vectors
#' @import GenomicRanges
#' @importFrom Rsamtools mergeBam bamWhich `bamWhich<-` filterBam bamTag
#' `bamTag<-`
#' @importFrom rtracklayer export
#' @importFrom utils read.csv write.csv combn txtProgressBar setTxtProgressBar
#' @importFrom BiocParallel bptry bplapply
#' @examples
#' bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
#' tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' which <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
#' gal <- readBamFile(bamfile, tag=tags, which=which, asMates=TRUE)
#' objs <- shiftGAlignmentsList(gal)
#' export(objs, "shift.bam")
#' \dontrun{
#'   bamfile <- 'a.big.file.bam'
#'   tags <- c("NM", "MD")
#'   which <- GRanges(c('chr1:1-249250621:*', 'chr2:1-243199373:*'))
#'   gal <- readBamFile(bamfile, tag=tags, which=which, 
#'   asMates=TRUE, bigFile=TRUE)
#'   library(BiocParallel)
#'   BPPARAM <- MulticoreParam(workers = 2, progress=TRUE)
#'   objs <- shiftGAlignmentsList(gal, BPPARAM = BPPARAM,
#'    outbam="shift.bam")
#' }
shiftGAlignmentsList <- function(gal, positive=4L, negative=5L, outbam,
                                 BPPARAM = NULL,
                                 slidingWindowSize = 50e6){
    stopifnot(is.integer(positive))
    stopifnot(is.integer(negative))
    stopifnot(is(gal, "GAlignmentsList"))
    if(length(gal)==0){
      ## big file mode
      meta <- metadata(gal)
      if(!all(c("file", "param") %in% names(meta))){
        stop("length of gal could not be 0.")
      }
      ow <- getOption("warn")
      on.exit(options(warn = ow))
      options(warn=-1)
      index <- ifelse(length(meta$index)>0, meta$index, meta$file)
      bamW <- bamWhich(meta$param)
      bamW <- as(bamW, "GRanges")
      bamW <- slidingWindows(bamW,
                             width=slidingWindowSize,
                             step=slidingWindowSize)
      bamW <- unlist(bamW)
      rmBam <- function(bam, bai=paste0(bam, ".bai")){
        unlink(bam)
        if(file.exists(bai[1])) unlink(bai)
      }
      mposTag <- vapply(combn(LETTERS, 2, simplify = FALSE), function(.ele){
        paste(.ele, collapse = '')
      }, FUN.VALUE = character(1L))
      if(any(!mposTag %in% bamTag(meta$param))){
        mposTag <- mposTag[!mposTag %in% bamTag(meta$param)][1]
      }else{
        stop('Can not find a proper tag to save mpos! Please remove some tags.')
      }
      processBamByTile <- function(meta, i, bamW, rmBam, mposTag){
        sbp <- meta$param
        bamWhich(sbp) <- bamW[i]
        destination <- tempfile(fileext = ".bam")
        null <- filterBam(file=meta$file, index = index,
                          destination=destination,
                          indexDestination=TRUE,
                          param=sbp)
        chunk <- 1000000
        bamfile <- BamFile(destination,
                           index=destination,
                           yieldSize=chunk,
                           asMates = meta$asMates)
        open(bamfile)
        on.exit({
          close(bamfile)
          rmBam(destination)
          })
        outfile <- NULL
        SE <- GAlignments()
        df4Duplicates <- NULL
        while (length(chunk0 <-
                      readGAlignmentsList(bamfile, param=sbp))) {
          isSE <- lengths(chunk0)==1
          if(sum(isSE)){
            SE <- c(SE, unlist(chunk0[isSE]))
            chunk0 <- chunk0[!isSE]
            ## pair SE
            SE <- split(SE, mcols(SE)$qname)
            isSE <- lengths(SE)==1
            chunk0 <- c(chunk0, SE[!isSE])
            SE <- SE[isSE]
            SE <- unlist(SE)
            if(length(chunk0)==0){
              next
            }
          }
          startpos <- vapply(start(chunk0), min,
                             FUN.VALUE = integer(1L))
          chunk0 <- chunk0[order(startpos)]
          metadata(chunk0)$df4Duplicates <- df4Duplicates
          gal1 <- shiftGAlignmentsList(chunk0, positive = positive, 
                                       negative = negative)
          rm(chunk0)
          gc(verbose=FALSE)
          if(length(metadata(gal1)$df4Duplicates)){
            df4Duplicates <- read.csv(metadata(gal1)$df4Duplicates)
          }
          if(length(mcols(gal1)$mpos)!=length(gal1)){
            stop("Can not get mpos info from the reads.")
          }
          mcols(gal1)[, mposTag] <- mcols(gal1)$mpos
          outfile <- c(tempfile(fileext = ".bam"), outfile)
          if(length(meta$header)>0) metadata(gal1)$header <- meta$header
          exportBamFile(gal1, outfile[1])
          rm(gal1)
          gc(verbose=FALSE)
        }
        close(bamfile)
        rmBam(destination)
        on.exit()
        if(length(SE)>0){
          singleEnds <- 
            tempfile(fileext = paste0('.',
                                      as.character(seqnames(SE[1])),
                                      '.bam'))
          SE <- renameMcol(SE, "mrnm", tagNewName=mposTag)
          mcols(SE)$isize[is.na(mcols(SE)$isize)] <- 0
          exportBamFile(SE, singleEnds)
          rm(SE)
          gc(verbose=FALSE)
        }else{
          singleEnds <- NULL
        }
        return(list(outfile=outfile,
                    singleEnds = singleEnds))
      }
      if(is.null(BPPARAM)){
        pb <- txtProgressBar(max = length(bamW), style = 3)
        res <- lapply(
          seq_along(bamW),
          function(i){
            .res <- processBamByTile(meta=meta,
                                     i=i,
                                     bamW=bamW,
                                     rmBam=rmBam,
                                     mposTag=mposTag)
            setTxtProgressBar(pb, i)
            .res
            })
        close(pb)
      }else{
        retryBatch <- 3
        retry <- TRUE
        res <- list()
        while(retryBatch>0){
          retryBatch <- retryBatch - 1
          if(any(retry)){
            res <- bptry(bplapply(seq_along(bamW),
                                  processBamByTile,
                                  meta=meta, bamW=bamW,
                                  rmBam=rmBam, mposTag=mposTag,
                                  BPREDO = res,
                                  BPPARAM = BPPARAM))
            retry <- vapply(res, FUN = function(.ele){
              is(.ele, 'bperror')
            }, FUN.VALUE = logical(1L))
          }else{
            retryBatch <- -1
          }
        }
      }
      options(warn = ow)
      on.exit()
      getRes <- function(res, key){
        unlist(lapply(res, function(.ele) .ele[[key]]))
      }
      outfile <- getRes(res, 'outfile')
      SE <- getRes(res, 'singleEnds')
      SE <- SE[lengths(SE)>0]
      if(length(SE)){
        SE_chr <- vapply(
          strsplit(SE, split = '.', fixed = TRUE),
          FUN = function(.ele){
            .ele[length(.ele)-1]
          },
          FUN.VALUE = character(1L)
        )
        SE <- split(SE, SE_chr)
        param <- meta$param
        bamTag(param) <- c(bamTag(param), mposTag)
        SE_outfile <- lapply(SE, function(se){
          chr_SE <- lapply(se, readGAlignments, param=param)
          chr_SE <- unlist(GAlignmentsList(chr_SE))
          mcols(chr_SE)$mrnm <- NULL
          chr_SE <- renameMcol(chr_SE, mposTag, tagNewName="mrnm")
          rmBam(se)
          this_outfile <- NULL
          if(length(chr_SE)){
            chr_SE <- split(chr_SE, mcols(chr_SE)$qname)
            isSE <- lengths(chr_SE)==1
            chunk0 <- chr_SE[!isSE]
            rm(chr_SE)
            if(length(chunk0)){
              startpos <- vapply(start(chunk0), min,
                                 FUN.VALUE = integer(1L))
              chunk0 <- chunk0[order(startpos)]
              gal1 <- shiftGAlignmentsList(chunk0, positive = positive,
                                           negative = negative)
              rm(chunk0)
              gc(verbose=FALSE)
              if(length(gal1)){
                if(length(mcols(gal1)$mpos)!=length(gal1)){
                  stop("Can not get mpos info from the reads.")
                }
                mcols(gal1)[, mposTag] <- mcols(gal1)$mpos
                this_outfile <- tempfile(fileext = ".bam")
                if(length(meta$header)>0) metadata(gal1)$header <- meta$header
                exportBamFile(gal1, this_outfile)
              }
              rm(gal1)
              gc(verbose=FALSE)
            }
          }
          return(this_outfile)
        })
        outfile <- c(outfile, unlist(SE_outfile))
      }
      
      if(length(outfile)>1){
        BAI <- paste0(outfile[1], ".bai")
        mergedfile <- mergeBam(outfile, 
                               destination=tempfile(fileext = ".bam"), 
                               indexDestination=file.exists(BAI),
                               header=meta$file)
        rmBam(outfile)
      }else{
        if(length(outfile)==1){
          mergedfile <- outfile
        }else{
          stop("Can not get any proper mapped reads from  your inputs.")
        }
      }
      if(!missing(outbam)){
        file.copy(from=mergedfile, to=outbam)
        gal1 <- GAlignments()
        meta$file <- outbam
        if(file.exists(paste0(mergedfile[1], ".bai"))){
          file.copy(from=paste0(mergedfile, ".bai"), 
                    to=paste0(outbam, ".bai"))
          meta$index <- outbam
        }else{
          meta$index <- NULL
        }
        meta$asMates <- FALSE
        ## add mpos tag to the bamTag to let the readBamFile known
        meta$mposTag <- mposTag
        bamTag(meta$param) <- c(bamTag(meta$param), mposTag)
        metadata(gal1) <- meta
      }else{
        param <- meta$param
        bamTag(param) <- c(bamTag(param), mposTag)
        gal1 <- readGAlignments(mergedfile, param = param)
        mcols(gal1)$MD <- NULL
        names(gal1) <- mcols(gal1)$qname
        gal1 <- gal1[order(names(gal1))]
        gal1 <- renameMcol(gal1, mposTag, tagNewName="mpos")
        rmBam(mergedfile)
      }
      return(gal1)
    }
    stopifnot(length(gal)>0)
    stopifnot(all(elementNROWS(gal)<3))
    ## move the 5'end
    ## first reads is 5'end
    gal1 <- unlist(gal)
    gp <- rep(seq_along(gal), elementNROWS(gal))
    k <- width(gal1) <= max(c(positive, negative))
    if(any(k)){
      gal <- gal[-gp[k]]
      gal1 <- unlist(gal)
    }
    gp <- rep(1, length(gal1))
    gp1 <- rep(seq_along(gal), elementNROWS(gal))
    gp[duplicated(gp1)] <- 2
    mcols(gal1)$MD <- NULL
    id2 <- which(gp==2)
    id1 <- id2-1
    checkDup <- FALSE
    if(length(metadata(gal)$keepDuplicates)){
      if(length(mcols(gal1)$isize)>0 && !metadata(gal)$keepDuplicates){
        checkDup <- TRUE
      }
    }else{
      checkDup <- TRUE
    }
    if(checkDup){
      if(length(metadata(gal)$df4Duplicates)){
        df0 <- metadata(gal)$df4Duplicates
      }else{
        df0 <- NULL
      }
      df <- DataFrame(seqnames=seqnames(gal1), 
                      cigar=cigar(gal1), 
                      start=start(gal1), 
                      isize=mcols(gal1)$isize)
      df <- rbind(df0, df)
      dupids <- duplicated(df)
      df2 <- dupids[id2+nrow(df0)]
      df1 <- dupids[id1+nrow(df0)]
      if(any(df1 & df2)){
        tobeRemoved <- sort(c(id2[df1 & df2], id1[df1 & df2]))
        gal1 <- gal1[-tobeRemoved]
        gp <- gp[-tobeRemoved]
        id2 <- which(gp==2)
        id1 <- id2-1
        df <- df[-(tobeRemoved+nrow(df0)), , drop=FALSE]
        if(nrow(df)){
          df4Duplicates <- tempfile()
          write.csv(df, df4Duplicates, row.names = FALSE)
          rm(df)
          metadata(gal1)$df4Duplicates <- df4Duplicates
        }
      }
    }
    gal1 <- shiftReads(gal1, 
                       positive=positive,
                       negative=negative)
    names(gal1) <- mcols(gal1)$qname
    mcols(gal1)$mpos[gp==2] <- start(gal1)[id1]
    mcols(gal1)$mpos[id1] <- start(gal1)[id2]
    if(length(mcols(gal1)$MC)>0){
      mcols(gal1)$MC[gp==2] <- cigar(gal1[id1])
      mcols(gal1)$MC[id1] <- cigar(gal1[id2])
    }
    gal1 <- gal1[!is.na(mcols(gal1)$mpos)] ## remove the single ends
    if(length(gal1)<1){
      message("Only single end reads")
      return(gal1)
    }
    ## till now, gal1 must have mrnm, mpos, names and flag
    stopifnot(length(mcols(gal1)$mrnm)>0)
    stopifnot(length(mcols(gal1)$mpos)>0)
    stopifnot(length(mcols(gal1)$flag)>0)
    stopifnot(length(names(gal1))>0)
    if(!(missing(outbam))){
      tryCatch(exportBamFile(gal1, outbam),
               error=function(e){
                 message(e)
               })
    }
    return(gal1)
}

test_that("shiftGAlignmentsList works not correct", {
  bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
  tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
  which <- GRanges('chr1:1-249250621:*')
  gal <- readBamFile(bamfile, tag=tags, which=which, asMates=TRUE)
  objs1 <- shiftGAlignmentsList(gal)
  gal <- readBamFile(bamfile, tag=tags, which=which, asMates=TRUE,
                     bigFile = TRUE)
  objs2 <- shiftGAlignmentsList(gal)
  x <- paste(mcols(objs1)$qname, start(objs1), end(objs1))
  y <- paste(mcols(objs2)$qname, start(objs2), end(objs2))
  objs2 <- objs2[match(x, y)]
  expect_equal(cigar(objs1), cigar(objs2))
  expect_equal(mcols(objs1)$seq, mcols(objs1)$seq)
  expect_equal(mcols(objs1)$qual, mcols(objs1)$qual)
  expect_equal(mcols(objs1)$mpos, mcols(objs1)$mpos)
})

#' plot ATAC-seq footprints infer factor occupancy genome wide
#' @description Aggregate ATAC-seq footprint for a given motif generated
#'              over binding sites within the genome.
#' @param bamfiles A vector of characters indicates the file names of bams.  
#' All the bamfiles will be pulled together.
#' @param index The names of the index file of the 'BAM' file being processed;
#'        This is given without the '.bai' extension.
#' @param pfm A Position frequency Matrix represented as a numeric matrix
#'        with row names A, C, G and T.
#' @param genome An object of \link[BSgenome:BSgenome-class]{BSgenome}.
#' @param min.score The minimum score for counting a match.
#'                  Can be given as a character string containing a
#'                  percentage (e.g. "95%") of the highest possible
#'                  score or as a single number.
#'                  See \link[Biostrings]{matchPWM}.
#' @param bindingSites A object of \link[GenomicRanges:GRanges-class]{GRanges} indicates
#' candidate binding sites (eg. the output of fimo). The GRanges object must have
#' score column in the metadata column.
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param upstream,downstream numeric(1) or integer(1).
#'        Upstream and downstream of the binding region for
#'        aggregate ATAC-seq footprint.
#' @param maxSiteNum numeric(1). Maximal number of predicted binding sites.
#'        if predicted binding sites is more than this number, top maxSiteNum binding
#'        sites will be used.
#' @param anchor "cut site" or "fragment center". If "fragment center" is used, 
#'        the input bamfiles must be paired-end.
#' @param group Group information for the bamfiles. Default by strand. Otherwise,
#'              a factor or vector of characters with same length of bamfiles. The
#'              group is limited to 2 groups.
#' @param ... xlab, legTitle, xlim or ylim could be used by \link{plotFootprints}
#' @importFrom stats cor.test
#' @importFrom ChIPpeakAnno featureAlignedSignal reCenterPeaks
#' @importFrom GenomicAlignments readGAlignments
#' @importFrom Biostrings matchPWM maxScore
#' @importFrom Rsamtools ScanBamParam testPairedEndBam scanBamHeader
#' @import GenomeInfoDb
#' @import GenomicRanges
#' @import IRanges
#' @import S4Vectors
#' @return an invisible list of matrixes with the signals for plot.
#' It includes:
#'  - signal    mean values of coverage for positive strand and negative strand
#'              in feature regions
#'  - spearman.correlation    spearman correlations of cleavage counts in the 
#'              highest 10-nucleotide-window and binding prediction score.
#'  - bindingSites    predicted binding sites.
#' @export
#' @references Chen, K., Xi, Y., Pan, X., Li, Z., Kaestner, K., Tyler, J.,
#' Dent, S., He, X. and Li, W., 2013.
#' DANPOS: dynamic analysis of nucleosome position and occupancy by sequencing.
#' Genome research, 23(2), pp.341-351.
#' @author Jianhong Ou, Julie Zhu
#' @examples
#'
#'bamfile <- system.file("extdata", "GL1.bam",
#'                        package="ATACseqQC")
#'library(MotifDb)
#'CTCF <- query(MotifDb, c("CTCF"))
#'CTCF <- as.list(CTCF)
#'library(BSgenome.Hsapiens.UCSC.hg19)
#'factorFootprints(bamfile, pfm=CTCF[[1]],
#'                 genome=Hsapiens,
#'                 min.score="95%", seqlev="chr1",
#'                 upstream=100, downstream=100)
#'##### Using user defined binding sites #####
#'bds <- readRDS(system.file("extdata", "jolma2013.motifs.bindingList.95.rds",
#'                           package="ATACseqQC"))
#'bindingSites <- bds[["Hsapiens-jolma2013-CTCF"]]
#'seqlev <- "chr1" #seqlevels(bindingSites)
#'ff <- factorFootprints(bamfile, pfm=CTCF[[1]],
#'                 bindingSites=bindingSites,
#'                 seqlev=seqlev,
#'                 upstream=100, downstream=100)
#'##### normalize the plot by distal signals #####
#'library(motifStack)
#'Profile <- lapply(ff$signal, function(.ele) colMeans(.ele, na.rm = TRUE))
#'pfm <- new('pfm', mat=as.matrix(CTCF[[1]]), name='CTCF')
#'plotFootprints(Profile=c(Profile[["+"]], Profile[["-"]]),
#'               Mlen=ff$Mlen,
#'               motif=pfm,
#'               segmentation=ff$Profile.segmentation,
#'               reNormalizeByDistalSig=TRUE)
#'
factorFootprints <- function(bamfiles, index=bamfiles, pfm, genome, 
                             min.score="95%", bindingSites,
                             seqlev=paste0("chr", c(1:22, "X", "Y")),
                             upstream=100, downstream=100,
                             maxSiteNum=1e6, anchor="cut site",
                             group="strand",
                             ...){
  #stopifnot(length(bamfiles)==4)
  if(!missing(genome)) stopifnot(is(genome, "BSgenome"))
  stopifnot(all(round(colSums(pfm), digits=4)==1))
  stopifnot(upstream>10 && downstream>10)
  stopifnot(is.numeric(maxSiteNum))
  stopifnot(all(seqlev %in% names(getBamTargets(bamfiles[1], index[1]))))
  maxSiteNum <- ceiling(maxSiteNum[1])
  stopifnot(maxSiteNum>1)
  anchor <- match.arg(anchor, choices = c("cut site", "fragment center"))
  if(length(group) == 1){
    if(group!="strand"){
      stop("If length of group is 1, it must be strand.")
    }
    groupFlag <- TRUE
  }else{
    stopifnot(length(group)==length(bamfiles))
    group <- as.factor(group)
    if(length(levels(group))!=2){
      stop("The length of levels of group must be 2.")
    }
    groupFlag <- FALSE
  }
  if(anchor=="fragment center"){
    null <- mapply(function(.bam, .index){
      suppressMessages(pe <- testPairedEndBam(.bam, .index))
      if(!pe){
        stop("If anchor is fragment center, the bamfiles must be paired end reads.")
      }
    }, bamfiles, index)
  }
  if(missing(bindingSites)){
      pwm <- motifStack::pfm2pwm(pfm)
      maxS <- maxScore(pwm)
      if(!is.numeric(min.score)){
        if(!is.character(min.score)){
          stop("'min.score' must be a single number or string")
        }else{
          nc <- nchar(min.score)
          if (substr(min.score, nc, nc) == "%"){
            min.score <- substr(min.score, 1L, nc - 1L)
          }else{
            stop("'min.score' can be given as a character string containing a percentage",
                 "(e.g. '85%') of the highest possible score")
          }
          min.score <- maxS * as.double(min.score)/100
        }
      }else{
        min.score <- min.score[1]
      }
      predefined.score <- maxS * as.double(0.85)
      suppressWarnings({
        mt <- tryCatch(matchPWM(pwm, genome, min.score = min(predefined.score, min.score), 
                                with.score=TRUE,
                                exclude=paste0("^", names(genome)[!names(genome) %in% seqlev], "$")),
                       error=function(e){
                         message(e)
                         stop("No predicted binding sites available by giving seqlev. ")
                       })
      })
      if (min.score <= predefined.score){
        mt$userdefined <- TRUE
      } else {
        mt$userdefined <- FALSE
        mt$userdefined[mt$score >= min.score] <- TRUE
      }
      if(length(mt)>maxSiteNum){## subsample
        mt$oid <- seq_along(mt)
        mt <- mt[order(mt$score, decreasing = TRUE)]
        mt <- mt[seq.int(maxSiteNum)]
        mt <- mt[order(mt$oid)]
        mt$oid <- NULL
      }
      subsampleNum <- min(10000, maxSiteNum)
      if(length(mt)>subsampleNum && sum(mt$userdefined)<subsampleNum){## subsample 
          set.seed(seed = 1)
          mt.keep <- seq_along(mt)[!mt$userdefined]
          n <- subsampleNum-sum(mt$userdefined)
          if(length(mt.keep)>n){
              mt.keep <- mt.keep[order(mt[mt.keep]$score, decreasing = TRUE)]
              mt.keep <- mt.keep[seq.int(n)]
              mt.keep <- sort(mt.keep)
              mt.keep <- seq_along(mt) %in% mt.keep
              mt <- mt[mt$userdefined | mt.keep]
          }
      }
  }else{
      stopifnot(is(bindingSites, "GRanges"))
      stopifnot(all(!is.na(seqlengths(bindingSites))))
      stopifnot(length(bindingSites)>1)
      stopifnot(length(bindingSites$score)==length(bindingSites))
      mt <- bindingSites
      mt$userdefined <- TRUE
  }
  if(sum(mt$userdefined)<2){
    stop("less than 2 binding sites by input min.score")
  }
  seqlevelsStyle(mt) <- checkBamSeqStyle(bamfiles[1], index[1])[1]
  wid <- ncol(pfm)
  #mt <- mt[seqnames(mt) %in% seqlev]
  seqlevels(mt) <- seqlev
  if(any(is.na(seqlengths(mt)))){
    error_msg <- seqlengths(mt)[is.na(seqlengths(mt))]
    error_msg <- paste(names(error_msg), collapse=", ")
    stop("There is NA values in seqlengths for the given seqlev. ",
         "The lines of the NA values are: ",
         error_msg,
         ". Please remove those seq levels from the input and try again.")
  }
  seqinfo(mt) <- Seqinfo(seqlev, seqlengths = seqlengths(mt))
  ## read in bam file with input seqlev specified by users
  which <- as(seqinfo(mt), "GRanges")
  #param <- ScanBamParam(which=which)
  if(anchor=="cut site"){
    bamIn <- mapply(function(.b, .i) {
      seqlevelsStyle(which) <- checkBamSeqStyle(.b, .i)[1]
      param <- ScanBamParam(which=which)
      readGAlignments(.b, .i, param = param)
      }, bamfiles, index, SIMPLIFY = FALSE)
  }else{
    bamIn <- mapply(function(.b, .i) {
      seqlevelsStyle(which) <- checkBamSeqStyle(.b, .i)[1]
      param <- ScanBamParam(which=which)
      readGAlignmentPairs(.b, .i, param = param)
      }, bamfiles, index, SIMPLIFY = FALSE)
  }
  bamIn <- lapply(bamIn, as, Class = "GRanges")
  bamIn <- split(bamIn, group)
  bamIn <- lapply(bamIn, function(.ele){
    if(!is(.ele, "GRangesList")) .ele <- GRangesList(.ele)
    .ele <- unlist(.ele)
    #seqlevelsStyle(.ele) <- seqlevelsStyle(genome)[1]
    if(anchor=="cut site"){
      ## keep 5'end as cutting sites
      promoters(.ele, upstream=0, downstream=1)
    }else{
      ## keep fragment center
      reCenterPeaks(.ele, width=1)
    }
  })
  libSize <- lengths(bamIn)
  if(groupFlag){
    libFactor <- mapply(bamIn, libSize, FUN=function(.ele, .libSize){
      coverageSize <- sum(as.numeric(width(reduce(.ele, ignore.strand=TRUE))))
      .libSize / coverageSize
    })
  }else{
    libFactor <- libSize/mean(libSize)
  }
  
  
  if(groupFlag){
    ## split into positive strand and negative strand
    bamIn <- split(bamIn[[1]], strand(bamIn[[1]]))
    ## get coverage
    cvglist <- sapply(bamIn, coverage)
    cvglist <- cvglist[c("+", "-")]
    cvglist <- lapply(cvglist, function(.ele)
      .ele[names(.ele) %in% seqlev])
    ## coverage of mt, must be filtered, otherwise too much
    cvgSum <- cvglist[["+"]] + cvglist[["-"]] ## used for filter mt
  }else{
    ## it was splitted by groups
    ## get coverage
    cvglist <- sapply(bamIn, coverage)
    cvglist <- lapply(cvglist, function(.ele)
      .ele[names(.ele) %in% seqlev])
    ## coverage of mt, must be filtered, otherwise too much
    cvgSum <- cvglist[[1]] + cvglist[[2]] ## used for filter mt
  }
  
  mt.s <- split(mt, seqnames(mt))
  seqlev <- intersect(names(cvgSum), names(mt.s))
  cvgSum <- cvgSum[seqlev]
  mt.s <- mt.s[seqlev]
  ## too much if use upstream and downstream, just use 3*wid maybe better.
  mt.s.ext <- promoters(mt.s, upstream=wid, downstream=wid+wid)
  stopifnot(all(lengths(mt.s.ext)==lengths(mt.s)))
  mt.v <- Views(cvgSum, mt.s.ext)
  mt.s <- mt.s[viewSums(mt.v)>0] 
  mt <- unlist(mt.s)
  mt.ids <- promoters(reCenterPeaks(mt, width=1),
                      upstream=upstream+floor(wid/2),
                      downstream=downstream+ceiling(wid/2)+1)
  mt.ids <- paste0(as.character(seqnames(mt.ids)), ":", start(mt.ids), "-", end(mt.ids))
  sigs <- featureAlignedSignal(cvglists=cvglist,
                              feature.gr=reCenterPeaks(mt, width=1),
                              upstream=upstream+floor(wid/2),
                              downstream=downstream+ceiling(wid/2),
                              n.tile=upstream+downstream+wid)
  mt <- mt[match(rownames(sigs[[1]]), mt.ids)]
  cor <- lapply(sigs, function(sig){
      sig.colMeans <- colMeans(sig)
      ## calculate correlation of footprinting and binding score
      windows <- slidingWindows(IRanges(1, ncol(sig)), width = wid, step = 1)[[1]]
      # remove the windows with overlaps of motif binding region
      windows <- windows[end(windows)<=upstream | start(windows)>=upstream+wid]
      sig.windowMeans <- viewMeans(Views(sig.colMeans, windows))
      windows.sel <- windows[which.max(sig.windowMeans)][1]
      highest.sig.windows <- 
          rowMeans(sig[, start(windows.sel):end(windows.sel)])
      predictedBindingSiteScore <- mt$score
      if(length(predictedBindingSiteScore) == length(highest.sig.windows)){
        suppressWarnings({
          cor <- cor.test(x = predictedBindingSiteScore, 
                          y = highest.sig.windows, 
                          method = "spearman")
        })
      }else{
        cor <- NA
      }
      cor
  })
  sigs <- lapply(sigs, function(.ele) .ele[mt$userdefined, ])
  mt <- mt[mt$userdefined]
  mt$userdefined <- NULL
  ## segmentation the signals
  if(groupFlag){
    ## x2 because stranded.
    Profile <- lapply(sigs, function(.ele) colMeans(.ele, na.rm = TRUE)*2/libFactor[1])
  }else{
    Profile <- mapply(sigs, libFactor, FUN = function(.ele, .libFac){
      colMeans(.ele, na.rm = TRUE)/.libFac
    }, SIMPLIFY = FALSE)
  }
  ## upstream + wid + downstream
  Profile.split <- lapply(Profile, function(.ele){
    list(upstream=.ele[seq.int(upstream)],
         binding=.ele[upstream+seq.int(wid)],
         downstream=.ele[upstream+wid+seq.int(downstream)])
  })
  optimalSegmentation <- function(.ele){
    .l <- length(.ele)
    short_abun <- cumsum(.ele)/seq.int(.l)
    long_abun <- cumsum(rev(.ele))/seq.int(.l)
    long_abun <- rev(long_abun)
    short_abun <- short_abun[-length(short_abun)]
    long_abun <- long_abun[-1]
    ##long_abun should always greater than short_abun
    long_abun <- long_abun - short_abun
    long_abun[long_abun<0] <- 0
    cov_diff <- numeric(length(short_abun))
    for(i in seq_along(.ele)){
      cov_diff_tmp <- .ele
      cov_diff_tmp <- cov_diff_tmp-short_abun[i]
      cov_diff_tmp[-seq.int(i)] <- cov_diff_tmp[-seq.int(i)] - long_abun[i]
      cov_diff[i] <- mean(cov_diff_tmp^2)
    }
    .ids <- which(cov_diff==min(cov_diff, na.rm = TRUE))
    data.frame(pos=.ids, short_abun=short_abun[.ids], long_abun=long_abun[.ids])
  }
  Profile.seg <- lapply(Profile.split, function(.ele){
    ups <- optimalSegmentation(.ele$upstream)
    downs <- optimalSegmentation(rev(.ele$downstream))
    ## find the nearest pair
    .min <- c(max(rbind(ups, downs)), 0, 0)
    for(i in seq.int(nrow(ups))){
      for(j in seq.int(nrow(downs))){
        tmp <- sum(abs(ups[i, -1] - downs[j, -1]))
        if(tmp < .min[1]){
          .min <- c(tmp, i, j)
        }
      }
    }
    c(colMeans(rbind(ups[.min[2], ], downs[.min[3], ])), binding=mean(.ele$binding, na.rm=TRUE))
  })
  Profile.seg <- colMeans(do.call(rbind, Profile.seg))
  Profile.seg[3] <- Profile.seg[2]+Profile.seg[3]
  names(Profile.seg)[2:3] <- c("distal_abun", "proximal_abun")
  tryCatch({ ## try to avoid the error when plotting.
    args <- list(...)
    if(groupFlag){
      args$Profile <- c(Profile[["+"]], Profile[["-"]])
      args$legLabels <- c("For. strand", "Rev. strand")
    }else{
      args$Profile <- c(Profile[[1]], Profile[[2]])
      args$legLabels <- names(Profile)
    }
    args$ylab <- ifelse(anchor=="cut site", "Cut-site probability", "reads density (arbitrary unit)")
    args$Mlen <- wid
    args$motif <- pwm2pfm(pfm)
    args$segmentation <- Profile.seg
    do.call(plotFootprints, args = args)
  }, error=function(e){
    message(e)
  })
  return(invisible(list(signal=sigs, 
                        spearman.correlation=cor, 
                        bindingSites=mt,
                        Mlen=wid,
                        estLibSize=libSize,
                        Profile.segmentation=Profile.seg)))
}

pwm2pfm <- function(pfm, name="motif"){
  if(!all(round(colSums(pfm), digits=4)==1)){
    return(NULL)
  }
  new("pfm", mat=as.matrix(pfm), name=name)
}

getBamTargets <- function(bamfile, index){
  header <- scanBamHeader(bamfile, index=index)
  header[[1]]$targets
}
checkBamSeqStyle <- function(bamfile, index){
  which <- getBamTargets(bamfile, index)
  seqlevelsStyle(names(which))
}

test_that("factorFootprints works not correct", {
  if(interactive()){
    set.seed(0)
    fa <- sample(c("A", "C", "G", "T"), 500, replace = TRUE)
    rg <- 245:255
    fa[rg] <- "A"
    fa <- c(">chr1", paste(fa, collapse = ""))
    dir.create("unknownGenome")
    writeLines(fa, con = file.path("unknownGenome", "chr1.fa"))
    seedsFile <- c("Package: BSgenome.unknown",
                   "Title: Full genome for test use",
                   "Description: Full genome sequences for test use.",
                   "Version: 0.0.1",
                   "organism: unknown",
                   "common_name: unknown",
                   "provider: unknown",
                   "provider_version: unknown",
                   "release_date: Apr. 2017",
                   "release_name: unknown",
                   "source_url: http://test.org",
                   "organism_biocview: unknown",
                   "BSgenomeObjname: unknown",
                   "seqnames: \"chr1\"",
                   "SrcDataFiles: chr1.fa from code",
                   "PkgExamples: genome$chr1",
                   "seqs_srcdir: unknownGenome")
    writeLines(seedsFile, con = "genome.seed")
    
    forgeBSgenomeDataPkg("genome.seed")
    
    install.packages("BSgenome.unknown", repos = NULL, type = "source")
    on.exit({
      remove.packages("BSgenome.unknown")
      unlink(c("test.bam", "test.bam.bai", "BSgenome.unknown", "unknownGenome", "genome.seed"),
             recursive = TRUE)
    })
    library("BSgenome.unknown")
    genome <- BSgenome.unknown
    
    gal <- GAlignments(seqnames=Rle("chr1", 50), 
                       pos=as.integer(c(seq(150, 240, by=10), seq(200, 245, by=5), seq(205, 245, by=10),
                                        seq(255, 295, by=10), seq(255, 300, by=5), seq(260, 350, by=10))),
                       cigar=rep("10M", 50),
                       strand=Rle(strand("+"), 50))
    seqlengths(gal) <- c("chr1"=1000)
    tmpfile <- "test.bam"
    export(gal, tmpfile)
    pfm <- matrix(rep(c(1, 0, 0, 0), 10), nrow=4)
    rownames(pfm) <- c("A", "C", "G", "T")
    ffp <- factorFootprints(tmpfile, index=tmpfile, pfm, genome, 
                            min.score="95%", seqlev="chr1", 
                            upstream=100, downstream=100)
    expect_equal(ffp$estLibSize, 50)
    expect_true(all(colMeans(ffp$signal[["-"]])==0))
    expect_equal(sum(colMeans(ffp$signal[["+"]])), 50)
  }
})

#' Mapping quality control
#' @description Check the mapping rate, PCR duplication rate,
#' and mitochondria reads contamination.
#' @param bamfile character(1). File name of bam.
#' @param index character(1). File name of index file.
#' @param mitochondria character(1). Sequence name of mitochondria.
#' @param outPath character(1). File name of cleaned bam.
#' @param doubleCheckDup logical(1). Double check duplicates or not if there is no tags for that.
#' @return A list of quality summary.
#' @author Jianhong Ou
#' @export
#' @importFrom S4Vectors FilterRules
#' @importFrom Rsamtools BamFile scanBamFlag ScanBamParam scanBam bamFlagAsBitMatrix filterBam idxstatsBam testPairedEndBam scanBamHeader
#' @import GenomicRanges
#' @examples
#' bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
#' bamQC(bamfile, outPath=NULL)
bamQC <- function(bamfile, index=bamfile, mitochondria="chrM",
                  outPath=sub(".bam", ".clean.bam", 
                              basename(bamfile)),
                  doubleCheckDup=FALSE){
  stopifnot(length(bamfile)==1)
  stopifnot(is.character(bamfile))
  isPE <- testPairedEndBam(file = bamfile, index = index)
  flag <- scanBamFlag(isSecondaryAlignment = FALSE)
  file <- BamFile(file = bamfile, index = index)
  file.targets <- scanBamHeader(files = file, what="targets")$targets
  if(length(file.targets)<1) return(NA)
  file.targets <- checkMaxChrLength(file.targets)
  file.targets <- GRanges(names(file.targets), IRanges(rep(1, length(file.targets)), file.targets))
  qname <- NULL
  M1 <- NULL
  M_DISTINCT <- NULL
  M2 <- NULL
  isMitochondria <- Rle()
  isDuplicate <- Rle()
  isProperPair <- Rle()
  isUnmappedQuery <- Rle()
  hasUnmappedMate <- Rle()
  isNotPassingQualityControls <- Rle()
  lenQs <- NULL
  mapqs <- NULL
  for(i in seq_along(file.targets)){
    if(isPE){
      param <- ScanBamParam(what=c("qname", "flag", 
                                   "cigar", "pos", "qwidth",
                                   "mapq", "isize"),
                            flag = flag,
                            which = file.targets[i])
    }else{
      param <- ScanBamParam(what=c("qname", "flag", 
                                   "cigar", "pos", "qwidth",
                                   "mapq"),
                            flag = flag,
                            which = file.targets[i])
    }
    res <- scanBam(file, param = param)[[1L]]
    if(length(res[["qname"]])==0){
      next()
    }
    if(all(res[["qname"]]=="*")){
      next()
    }
    lenQ <- length(res[["qname"]])
    mapq <- as.data.frame(table(res[["mapq"]]))
    if(length(mapqs)>0){
      mapqs <- rbind(mapqs, mapq)
      mapqs <- rowsum(mapqs$Freq, group = mapqs$Var1)
      mapqs <- data.frame(Var1=row.names(mapqs), Freq=mapqs[, 1])
    }else{
      mapqs <- mapq
    }
    qname <- c(qname, res[["qname"]])
    isMitochondria <- c(isMitochondria, rep(as.character(seqnames(file.targets))[i] %in% mitochondria, lenQ))
    isDup <- 
      as.logical(bamFlagAsBitMatrix(res[["flag"]], "isDuplicate"))
    isProperPair <- c(isProperPair, as.logical(bamFlagAsBitMatrix(res[["flag"]], "isProperPair")))
    isUnmappedQuery <- c(isUnmappedQuery, as.logical(bamFlagAsBitMatrix(res[["flag"]], "isUnmappedQuery")))
    hasUnmappedMate <- c(hasUnmappedMate, as.logical(bamFlagAsBitMatrix(res[["flag"]], "hasUnmappedMate")))
    isNotPassingQualityControls <- c(isNotPassingQualityControls, 
                                     as.logical(bamFlagAsBitMatrix(res[["flag"]], "isNotPassingQualityControls")))
    res$mapq <- NULL
    res <- as.data.frame(res, stringsAsFactors=FALSE)
    
    ## PCR Bottlenecking Coefficient 1 (PBC1) = M1/M_DISTINCT where
    ## M1: number of genomic locations where exactly one read maps uniquely
    ## M_DISTINCT: number of distinct genomic locations to which some read maps uniquely
    ## PCR Bottlenecking Coefficient 2 (PBC2) = M1/M2 where
    ## number of genomic locations where only one read maps uniquely
    ## number of genomic locations where two reads map uniquely
    ## Non-Redundant Fraction (NRF) = 
    ## Number of distinct uniquely mapping reads (i.e. after removing duplicates) / Total number of reads. 
    dupRate <- sum(isDup)/lenQ
    if(isPE){
      isPaired <- as.logical(bamFlagAsBitMatrix(res$flag, "isPaired"))
      res.se <- res[!isPaired, ]
      res.pe <- res[isPaired, ]
      isFirstMateRead <- as.logical(bamFlagAsBitMatrix(res.pe$flag, "isFirstMateRead"))
      isSecondMateRead <- as.logical(bamFlagAsBitMatrix(res.pe$flag, "isSecondMateRead"))
      firstMate <- res.pe[isFirstMateRead, ]
      secondMate <- res.pe[isSecondMateRead, ]
      rm(res.pe)
      mates.qname <- intersect(firstMate$qname, secondMate$qname)
      res.se <- rbind(res.se, 
                      firstMate[!firstMate$qname %in% mates.qname, ],
                      secondMate[!secondMate$qname %in% mates.qname, ])
      firstMate <- firstMate[match(mates.qname, firstMate$qname), ]
      secondMate <- secondMate[match(mates.qname, secondMate$qname), ]
      if(dupRate==0 & doubleCheckDup){
        ## need to double check duplicate rate
        ## PE, remove the fragments with same cigar and positions.
        mates <- cbind(firstMate[, c("pos", "cigar", "isize")], 
                       secondMate[, c("pos", "cigar", "isize")])
        duplicated.qname <- firstMate[duplicated(mates), "qname"]
        rm(mates)
        duplicated.qname <- c(duplicated.qname, res.se[duplicated(res.se), "qname"])
        isDup <- res$qname %in% duplicated.qname
      }
      
      pos <- cbind(firstMate[, c("pos", "isize")], 
                     secondMate[, c("pos", "isize")])
      rm(firstMate)
      rm(secondMate)
      if(nrow(res.se)>0){
        res.se.cp <- res.se[, c("pos", "isize")]
        res.se.cp$pos <- NA
        res.se.cp$isize <- NA
        pos <- rbind(pos, cbind(res.se[, c("pos", "isize")], res.se.cp))
        rm(res.se)
        rm(res.se.cp)
      }
    }else{ ## SE
      if(dupRate==0 & doubleCheckDup){
        ## need to double check duplicate rate
        ## SE, remove the reads with same cigar and positions.
        isDup <- duplicated(res[, c("cigar", "pos", "qwidth")])
      }
      pos <- res[, c("pos", "qwidth")]
    }
    if(dupRate == 0 & doubleCheckDup){
      dupRate <- sum(isDup)/lenQ
    }
    rm(res)
    gc(reset=TRUE)
    M_DISTINCT <- c(M_DISTINCT, nrow(unique(pos)))
    pos.dup <- duplicated(pos) | duplicated(pos, fromLast = TRUE)
    M1 <- c(M1, sum(!pos.dup))
    pos.dup <- pos[pos.dup, , drop=FALSE]
    pos.dup <- as.data.frame(pos.dup)
    pos.dup <- do.call(paste, as.list(pos.dup))
    stats <- table(pos.dup)
    dup.stats <- table(stats)
    M2 <- c(M2, ifelse("2" %in% names(dup.stats), dup.stats[["2"]], 0))
    isDuplicate <- c(isDuplicate, isDup)
    lenQs <- c(lenQs, lenQ)
  }
  
  totalQNAMEs <- length(unique(qname))
  M1 <- sum(M1)
  NRF <- M1/totalQNAMEs
  PBC1 <- M1/sum(M_DISTINCT)
  M2 <- max(c(1, sum(M2))) ## avoid x/0
  PBC2 <- M1/M2
  
  lenQs <- sum(lenQs)
  mitRate <- sum(isMitochondria)/lenQs
  dupRate <- sum(isDuplicate)/lenQs
  properPairRate <- sum(isProperPair)/lenQs
  unmappedRate <- sum(isUnmappedQuery)/lenQs
  hasUnmappedMateRate <- sum(hasUnmappedMate)/lenQs
  badQualityRate <- sum(isNotPassingQualityControls)/lenQs
  
  if(length(outPath)){
    keepQNAME <- qname[(!as.logical(isMitochondria)) & (!as.logical(isDuplicate)) & 
                         as.logical(isProperPair) & (!as.logical(isNotPassingQualityControls))]
    filter <- FilterRules(list(qn = function(x){ 
      x$qname %in% keepQNAME}))
    filterBam(file = bamfile, 
              index = index,
              destination = outPath,
              filter = filter,
              indexDestination = TRUE)
  }
  return(list(totalQNAMEs=totalQNAMEs,
              duplicateRate=dupRate,
              mitochondriaRate=mitRate,
              properPairRate=properPairRate,
              unmappedRate=unmappedRate,
              hasUnmappedMateRate=hasUnmappedMateRate,
              notPassingQualityControlsRate=badQualityRate,
              nonRedundantFraction=NRF,
              PCRbottleneckCoefficient_1=PBC1,
              PCRbottleneckCoefficient_2=PBC2,
              MAPQ=mapqs,
              idxstats=idxstatsBam(file=bamfile, index=index)))
}

test_that("bamQC works not correct", {
  gal <- GAlignments(seqnames=Rle(c("chr1", "chrM"), c(990, 10)), 
                     pos=c(rep(c(1L, 241L), 491L) + rep(seq.int(491), each=2),
                           rep(c(1L, 241L), 9L)),
                     cigar=rep("10M", 1000),
                     strand=Rle(strand(rep(c("+", "-"), 500))), 
                     isize=rep(250, 1000) * c(1, -1),
                     flag=rep(c(99, 147), 500))
  names(gal) <- rep(seq.int(500), each=2)
  seqlengths(gal) <- c("chr1"=2000, "chrM"=1000)
  tmpfile <- "test.bam"
  export(gal, tmpfile)
  x <- bamQC(tmpfile)
  exp <- list(totalQNAMEs=500,
              mitochondriaRate=0.01,
              nonRedundantFraction=491/500,
              PCRbottleneckCoefficient_1=491/493,
              PCRbottleneckCoefficient_2=491)
  for(i in names(exp)){
    expect_equal(x[[i]], exp[[i]])
  }
})

#' Take IGV snapshots
#' @description Take IGV snapshots for genomic regions of interest.
#' Prerequisite: Make sure the Integrative Genomics Viewer (IGV) 
#' (http://software.broadinstitute.org/software/igv/) is installed in a 
#' user's computer. Be aware of the MAC OSX security and privacy setting. 
#' To utilize this functionality, be sure that the box for "Enable port", which 
#' can be found under the toolbar (View -> Preference -> Advanced), is checked 
#' to allow communication via port.
#' @param maxMem A character vector of length 1L containing the maximum usable 
#' memory for the IGV to be launched, which is defined as the following: 
#' 'mm' - 1.2 GB , 'lm' - 2 GB, 'hm' - 10 GB, ' - 750 MB. For details, please
#' see the #' parameter memory of function startIGV in the SRAdb package.
#' @param genomeBuild A character vector of length 1L: the genome build version.
#' For example, "hg38" for the human reference genome assembly GRCh38. 
#' Please see IGV manual for supported genomes of species. 
#' @param bamFileFullPathOrURLs A character vector containing the full paths 
#' or ULRs for bam files and matching bam index files. No spaces are allowed 
#' in the paths or URLs.
#' @param geneNames A character vector containing the names of genes or genomic
#' regions for visualization. For human (maybe other mammalian) ATAC-seq data, 
#' names of several house-keeping genes are provided as defaults.
#' @param genomicRegions A character vector containing genomic regions in the
#' form of "chr1:20000-40000".
#' @param sessionFile A character vector of length 1L containing the name of 
#' the IGV session file to be saved.
#' @param outDir A character vector of length 1L containing the output directory.
#' @author Haibo Liu, Siyuan Feng
#' @return None
#' @export
#' @importFrom utils installed.packages
#' @details This function depend on SRAdb startIGV IGVsocket IGVgenome IGVload IGVgoto IGVsnapshot IGVsession
#' @examples
#' if(interactive()){
#' library(SRAdb)
#' exampleBams = file.path(system.file('extdata',package='SRAdb'),
#'              dir(system.file('extdata',package='SRAdb'),pattern='bam$'))
#' IGVSnapshot(maxMem="mm", genomeBuild="hg18", bamFileFullPathOrURLs= exampleBams,
#'      geneNames=NULL, genomicRegions="chr1:1-1000",  sessionFile="IGV.session")
#'}


IGVSnapshot <- function(maxMem, genomeBuild="hg38", bamFileFullPathOrURLs, 
                        geneNames=c("GAPDH", "ACTB", "C1orf43", "CHMP2A", "EMC7", 
                                    "GPI", "PSMB2", "PSMB4", "RAB7A", "REEP5", 
                                    "VCP", "VPS29"), genomicRegions, sessionFile, outDir=getwd())
{
  if(!"SRAdb" %in% installed.packages()[, 1]){
    stop("SRAdb is required for IGVSnapshot.")
  }
    SRAdb::startIGV(maxMem)
    while (TRUE && interactive())
    {
        setupIGV <- readline(prompt="Is IGV starting up and port enabled? Y or N \n")
        if (grepl("Y|y", setupIGV, ignore.case=TRUE, perl=TRUE ))
        {
            break
        }else{
            print("Please set up IGV and enable port! For MAC OSX, please check the
                  security and privacy setting to allow IGV to start up regardless 
                  of the security setting. Please see the IGV manual for details.
                  Please also adjust the IGV window to full screen.")
        }
    }
    
    sock <- SRAdb::IGVsocket()
    SRAdb::IGVgenome(sock, genome=genomeBuild)
    SRAdb::IGVload(sock, bamFileFullPathOrURLs)
    
    if (!missing(genomicRegions))
    {
        genomicRegions <- genomicRegions[grepl("^\\w+:\\d+-\\d+$", genomicRegions, perl=TRUE)]
        geneNames <- c(geneNames, genomicRegions)
    }
    
    if (length(geneNames)>=1)  ## there is at least one gene name or one genomic region in correct forms
    {
        ## Take snapshot for interesting genomic regions
        for (gene in geneNames)
        {
            takeSnapshot(sock=sock, gene=gene, outDir=outDir)
        }
    }else if (interactive()){  ## ask to the user to input gene names or genomic regions
        takeSnapshotOUponInput(sock, outDir)
    }else{
        stop("At least one geneName or genomicRegion should be provided!")
    }
    
    ## save the IGV session file
    if (interactive())
    {
        saveSession <- readline(prompt="Save the IGV sessionfile? Y or N \n")
        if (grepl("Y|y", saveSession, perl=TRUE))
        {
          SRAdb::IGVsession(files=bamFileFullPathOrURLs, sessionFile=sessionFile, 
                       genome=genomeBuild, VisibleAttribute='', destdir=outDir)
        }
    }else{
      SRAdb::IGVsession(files=bamFileFullPathOrURLs, sessionFile=sessionFile, 
                   genome=genomeBuild, VisibleAttribute='', destdir=outDir)
    }
    SRAdb::IGVclear(sock)
}

#### Helper function: interactively get geneNames or genomicRegions from standard input, 
#### and take a snapshot after asking.
takeSnapshotOUponInput <- function(sock, gene, outDir)
{
    while (TRUE)
    {
        input <- readline(prompt="Please input gene a name (such as ACTB), genomic region 
                          (such as chr1:10000-20000) or type 'Y' to quit: \n")
        if (grepl("\\w+|\\w+:\\d+-\\d+", input, perl=TRUE))
        {
            takeSnapshot(sock=sock, gene=gene, outDir=outDir)
        }else if (grepl("Y|y", input, ignore.case=TRUE, perl=TRUE)){
            break
        }else{
            readline(prompt="The input is not valid. Please input gene a name (such as 'ACTB'), 
                     genomic region (such as 'chr1:10000-20000') or type 'Y' to quit: \n")
        }
        }
    }


#### helper function to take a IGV snapshot after asking
takeSnapshot <- function(sock, gene, outDir)
{
  SRAdb::IGVgoto(sock, gene)
    if (interactive())
    {
        takeSnapshot <- readline(prompt="Take a snapshot? Y or N \n")
        if (grepl("Y|y", takeSnapshot, perl =TRUE))
        {
          SRAdb::IGVsnapshot(sock)
        }
    }else{
      SRAdb::IGVsnapshot(sock)
    }
}

#' @title split bams into nucleosome free, mononucleosome,
#' dinucleosome and trinucleosome
#' @description use random forest to split the reads into nucleosome free,
#'              mononucleosome, dinucleosome and trinucleosome. 
#'              The features used in random forest including 
#'              fragment length, GC content, and 
#'              UCSC phastCons conservation scores.
#' @param obj an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}
#' @param txs GRanges of transcripts
#' @param genome an object of BSgenome
#' @param conservation an object of \link[GenomicScores:GScores-class]{GScores}.
#' @param outPath folder to save the splitted alignments. If outPath is setting, 
#' the return of the function will not contain seq and qual fields.
#' @param breaks a numeric vector for fragment size of nucleosome free,
#' mononucleosome, dinucleosome and trinucleosome. The breaks pre-defined
#' here is following the description of Greenleaf's paper (see reference).
#' @param labels a character vector for labels of the levels 
#' of the resulting category.
#' @param labelsOfNucleosomeFree,labelsOfMononucleosome character(1). The label
#' for nucleosome free and mononucleosome.
#' @param trainningSetPercentage numeric(1) between 0 and 1. Percentage of 
#' trainning set from top coverage.
#' @param cutoff numeric(1) between 0 and 1. cutoff value for prediction.
#' @param halfSizeOfNucleosome numeric(1) or integer(1). Thre read length will
#' be adjusted to half of the nucleosome size to enhance the signal-to-noise
#' ratio.
#' @param summaryFun Function to summarize genomic scores when more than one
#' position is retrieved. This will greatly affect the CPU time.
#' @return a list of GAlignments
#' @author Jianhong Ou
#' @import BiocGenerics
#' @import GenomeInfoDb
#' @import GenomicRanges
#' @import IRanges
#' @import S4Vectors
#' @importFrom Biostrings letterFrequency
#' @importFrom BSgenome getSeq
#' @importFrom ChIPpeakAnno annotatePeakInBatch
#' @importFrom GenomicAlignments coverage 
#' @importFrom randomForest randomForest
#' @importFrom stats predict
#' @importFrom GenomicScores gscores populations
#' @export
#' @references Buenrostro, J.D., Giresi, P.G., Zaba, L.C., Chang, H.Y. and 
#' Greenleaf, W.J., 2013. Transposition of native chromatin for fast and 
#' sensitive epigenomic profiling of open chromatin, DNA-binding proteins and 
#' nucleosome position. Nature methods, 10(12), pp.1213-1218.
#' 
#' Chen, K., Xi, Y., Pan, X., Li, Z., Kaestner, K., Tyler, J., Dent, S., 
#' He, X. and Li, W., 2013. DANPOS: dynamic analysis of nucleosome position 
#' and occupancy by sequencing. Genome research, 23(2), pp.341-351.
#' @examples 
#' library(GenomicRanges)
#' bamfile <- system.file("extdata", "GL1.bam", 
#'                        package="ATACseqQC", mustWork=TRUE)
#' tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
#' gal1 <- readBamFile(bamFile=bamfile, tag=tags, 
#'                     which=GRanges("chr1", IRanges(1, 1e6)), 
#'                     asMates=FALSE)
#' names(gal1) <- mcols(gal1)$qname
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' library(phastCons100way.UCSC.hg19)
#' splitGAlignmentsByCut(gal1, txs=txs, genome=Hsapiens, 
#'                       conservation=phastCons100way.UCSC.hg19)
#' 
splitGAlignmentsByCut <- function(obj, txs, genome, conservation,
                                  outPath,
                          breaks=c(0, 100, 180, 247, 315, 473, 558, 615, Inf),
                          labels = c("NucleosomeFree", "inter1",
                                     "mononucleosome", "inter2",
                                     "dinucleosome", "inter3",
                                     "trinucleosome", "others"),
                          labelsOfNucleosomeFree="NucleosomeFree",
                          labelsOfMononucleosome="mononucleosome",
                          trainningSetPercentage=.15,
                          cutoff = .8, halfSizeOfNucleosome=80L,
                          summaryFun=mean){
  stopifnot(length(labels)+1==length(breaks))
  stopifnot(length(labelsOfMononucleosome)==1)
  stopifnot(length(labelsOfNucleosomeFree)==1)
  stopifnot(labelsOfMononucleosome %in% labels)
  stopifnot(labelsOfNucleosomeFree %in% labels)
  stopifnot(is.function(summaryFun))
  conservationFlag <- FALSE
  if(!missing(conservation)){
    if(length(conservation)){
      stopifnot(is(conservation, "GScores"))
      conservationFlag <- TRUE ## conservation is supplied.
    }
  }
  stopifnot(is(obj, "GAlignments"))
  
  if(length(obj)==0 && (!missing(outPath)) && (!conservationFlag)){
    ## big file mode
    meta <- metadata(obj)
    if(!all(c("file", "param") %in% names(meta))){
      stop("length of obj could not be 0.")
    }
    
    ow <- getOption("warn")
    on.exit(options(warn = ow))
    options(warn=-1)
    chunk <- 100000
    index <- ifelse(length(meta$index)>0, meta$index, meta$file)
    if((file.exists(index)&&index!=meta$file) ||
       (index==meta$file && file.exists(paste0(index, ".bai")))){
      bamfile <- BamFile(meta$file, index=index, yieldSize=chunk, asMates = meta$asMates)
    }else{
      bamfile <- BamFile(meta$file, index=NULL, yieldSize=chunk, asMates = meta$asMates)
    }
    outfile <- list()
    mergedfile <- list()
    open(bamfile)
    while (length(chunk0 <- readGAlignments(bamfile, param=meta$param))) {
      if(checkMposTag(meta)){
        mcols(chunk0)$MD <- NULL
        names(chunk0) <- mcols(chunk0)$qname
        chunk0 <- chunk0[order(names(chunk0))]
        chunk0 <- renameMcol(chunk0, meta$mposTag, tagNewName="mpos")
      }
      gal1 <- splitGAlignmentsByCut(chunk0, txs=txs, genome = genome,
                                    breaks = breaks,
                                    labels = labels, labelsOfNucleosomeFree = labelsOfNucleosomeFree,
                                    labelsOfMononucleosome = labelsOfMononucleosome,
                                    trainningSetPercentage = trainningSetPercentage,
                                    cutoff = cutoff, halfSizeOfNucleosome = halfSizeOfNucleosome)
      ## gal1 is a list of GAlignments
      ## save the gal1 to tmpfiles
      for(i in seq_along(gal1)){
        outfile[[names(gal1)[i]]] <- c(tempfile(fileext = ".bam"), outfile[[names(gal1)[i]]])
        gal1_data <- gal1[[i]]
        if(length(meta$header)>0) metadata(gal1_data)$header <- meta$header
        exportBamFile(gal1_data, outfile[[names(gal1)[i]]][1])
      }
      rm(gal1)
    }
    close(bamfile)
    for(i in seq_along(outfile)){
      if(length(outfile[[i]])>1){
        mergedfile[[names(outfile)[i]]] <- mergeBam(outfile[[i]], 
                                                    destination=file.path(outPath, 
                                                                          paste0(names(outfile)[i], ".bam")), 
                                                    indexDestination=TRUE,
                                                    header=meta$file)
        unlink(outfile[[i]])
        unlink(paste0(outfile[[i]], ".bai"))
      }else{
        file.copy(outfile[[i]], 
                  file.path(outPath, paste0(names(outfile)[i], ".bam")))
        file.copy(paste0(outfile[[i]], ".bai"), 
                  file.path(outPath, paste0(names(outfile)[i], ".bam.bai")))
        mergedfile[[names(outfile)[i]]] <- 
          file.path(outPath, paste0(names(outfile)[i], ".bam"))
        unlink(outfile[[i]])
        unlink(paste0(outfile[[i]], ".bai"))
      }
    }
    mposTag <- if(checkMposTag(meta)){
      meta$mposTag
    }else{
      character(0)
    }
    meta$param <- ScanBamParam(flag=meta$param@flag, what=c("qname", "flag", "mapq", "isize"), tag = mposTag)
    objs <- lapply(mergedfile, function(.ele){
      ## read the bam files
      chunk0 <- readGAlignments(.ele, param=meta$param)
      names(chunk0) <- mcols(chunk0)$qname
      chunk0 <- chunk0[order(names(chunk0))]
      if(length(mposTag)>0){
        chunk0 <- renameMcol(chunk0, mposTag, tagNewName="mpos")
      }
      chunk0
    })
    return(objs)
  }
  
  if(length(obj)==0){
    obj <- loadBamFile(obj)
  }
  stopifnot(length(names(obj))==length(obj))
  
  seqlev <- unique(seqlevels(obj))
  seqlev <- seqlev[seqlev %in% unique(seqnames(obj))]
  if(length(seqlev)==0){
    stop("no reads in the obj.")
  }
  objs <- split(obj,
                cut(abs(mcols(obj)$isize),
                    breaks = breaks,
                    labels = labels))
  if(!conservationFlag){
    if(!missing(outPath)){
      writeListOfGAlignments(objs, outPath = outPath)
    }
    return(objs)
  }
  stopifnot(is(txs, "GRanges"))
  stopifnot(is(genome, "BSgenome"))
  nf.old <- objs[[labelsOfNucleosomeFree]]
  nc.old <- objs[[labelsOfMononucleosome]]
  rm(objs)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  nf.cvg <- coverage(nf.old)
  nc.cvg <- coverage(nc.old)
  nf.cvg <- nf.cvg[seqlev]
  nc.cvg <- nc.cvg[seqlev]
  nf.cvg.quantile <- sapply(nf.cvg, function(.ele) {
    .ele <- table(.ele)
    .ele <- .ele[names(.ele)!="0"] ## remove 0
    .x <- cumsum(.ele)/sum(.ele)
    w <- which(.x>=1-trainningSetPercentage)
    if(length(w)==0) return(0)
    as.numeric(names(.x[w[1]]))
  })
  nc.cvg.quantile <- sapply(nc.cvg, function(.ele) {
      .ele <- table(.ele)
      .ele <- .ele[names(.ele)!="0"] ## remove 0
      .x <- cumsum(.ele)/sum(.ele)
      w <- which(.x>=1-trainningSetPercentage)
      if(length(w)==0) return(0)
      as.numeric(names(.x[w[1]]))
  })
  cvg.quantile <- ifelse(nf.cvg.quantile < nc.cvg.quantile,
                         nf.cvg.quantile, nc.cvg.quantile)
  #names(cvg.quantile) <- seqlev
  nf.cvg.view <-
    as(IRangesList(mapply(function(x, y) as(Views(x, x>y), "IRanges"),
                          nf.cvg, cvg.quantile)), "GRanges")
  nc.cvg.view <-
    as(IRangesList(mapply(function(x, y) as(Views(x, x>y), "IRanges"),
                          nc.cvg, cvg.quantile)), "GRanges")
  if(length(nc.cvg.view)<1){
    stop("not enough mononucleosome reads for training! Just try without conservation score.")
  }
  if(length(nf.cvg.view)<1){
    stop("not enough nucleosome free reads for training! Just try without conservation score.")
  }
  #annotation the GRanges to get the strand info
  TSS <- promoters(txs,
                   upstream = 0,
                   downstream = 1)
  rm(txs)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  TSS <- TSS[seqnames(TSS) %in% seqlev]
  seqlev <- seqlev[seqlev %in% unique(seqnames(TSS))]
  seqlevels(TSS) <- seqlev
  seqinfo(TSS) <- Seqinfo(seqlev, seqlengths = seqlengths(TSS))
  TSS <- unique(TSS)
  nf.anno <- annotatePeakInBatch(nf.cvg.view, AnnotationData=TSS,
                                 output="nearestLocation")
  nc.anno <- annotatePeakInBatch(nc.cvg.view, AnnotationData=TSS,
                                 output="nearestLocation")
  nf.anno$feature_strand[is.na(nf.anno$feature_strand)] <- "*"
  nc.anno$feature_strand[is.na(nc.anno$feature_strand)] <- "*"
  strand(nf.anno) <- nf.anno$feature_strand
  strand(nc.anno) <- nc.anno$feature_strand
  mcols(nf.anno) <- DataFrame(score=1)
  mcols(nc.anno) <- DataFrame(score=1)
  nx <- GRoperator(nf.anno, nc.anno, operator = "-")
  nx <- nx[width(nx)>=40]
  nf <- nx[nx$score>0]
  nc <- nx[nx$score<0]
  if(length(nc)<1){
    stop("not enough mononucleosome reads for training! Just try without conservation score.")
  }
  if(length(nf)<1){
    stop("not enough nucleosome free reads for training! Just try without conservation score.")
  }
  block <- 100000
  nf <- reCenterPeaks(nf, width=halfSizeOfNucleosome)
  nc <- reCenterPeaks(nc, width=halfSizeOfNucleosome)
  coverage.nf <-
    Views(nf.cvg[seqlev], split(ranges(nf),
                                as.character(seqnames(nf)))[seqlev])
  coverage.nf <- IRangesList(lapply(coverage.nf, function(.ele){
    ir <- as(.ele, "IRanges")
    mcols(ir)$coverage <- viewMeans(.ele)
    ir
  }))
  nf <- as(coverage.nf, "GRanges")
  nf$score <- unlist(lapply(coverage.nf, function(.ele)
    as.numeric(mcols(.ele)$coverage)))
  nf <- nf[order(nf$score, decreasing=TRUE)]
  nf <- nf[seq_len(min(block, length(nf)))]
  coverage.nc <-
    Views(nc.cvg[seqlev], split(ranges(nc),
                                as.character(seqnames(nc)))[seqlev])
  coverage.nc <- IRangesList(lapply(coverage.nc, function(.ele){
    ir <- as(.ele, "IRanges")
    mcols(ir)$coverage <- viewMeans(.ele)
    ir
  }))
  nc <- as(coverage.nc, "GRanges")
  nc$score <- unlist(lapply(coverage.nc, function(.ele)
    as.numeric(mcols(.ele)$coverage)))
  nc <- nc[order(nc$score, decreasing=TRUE)]
  nc <- nc[seq_len(min(block, length(nc)))]
  obj <- obj[seqnames(obj) %in% seqlev]
  newdata <- split(as(obj, "GRanges"), names(obj))
  newdata <- range(newdata, ignore.strand=TRUE)
  newdata <- unlist(newdata)
  seqlevels(newdata) <- seqlev
  seqinfo(newdata) <- seqinfo(TSS)
  nd <- GenomicRanges::trim(newdata)
  rm(newdata)
  nf.seq <- getSeq(genome, nf)
  nc.seq <- getSeq(genome, nc)
  # gc ratios
  nf.gc <- letterFrequency(nf.seq, letters="CG", as.prob = TRUE)
  nc.gc <- letterFrequency(nc.seq, letters="CG", as.prob = TRUE)
  
  nd.gc <- lapply(split(nd, rep(as.character(seq.int(ceiling(length(nd)/block))),
                                each=block)[seq_along(nd)]), 
                   function(.ele){
                     letterFrequency(getSeq(genome, .ele), letters="CG", as.prob = TRUE)
                   })
  nd.gc <- nd.gc[order(as.numeric(names(nd.gc)))]
  nd.gc <- do.call(rbind, nd.gc)
  rm(nf.seq)
  rm(nc.seq)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  # conservation
  score.colnames <- populations(conservation)[1]
  getScoresFromCons <- function(cons, gr){# this step too slow, and why gscores change their output again and again?
      gr.cons <- lapply(split(gr, rep(as.character(seq.int(ceiling(length(gr)/block))), 
                                      each=block)[seq_along(gr)]),
                        function(.ele){
                          gscores(x=cons, ranges = .ele,
                                  pop=score.colnames,
                                  summaryFun=summaryFun)
                        })
      gr.cons <- gr.cons[order(as.numeric(names(gr.cons)))]
      gr.cons <- unlist(GRangesList(gr.cons), use.names = FALSE)
      A <- unname(ranges(gr))
      B <- unname(ranges(gr.cons))
      stopifnot("gscores does not work as expected."=identical(A, B))
      names(gr.cons) <- names(gr)
      gr.cons
  }
  nf.conservation <- getScoresFromCons(conservation, nf)
  nc.conservation <- getScoresFromCons(conservation, nc)
  nd.conservation <- getScoresFromCons(conservation, nd)
  ## determine the columns to be used for conservation
  nf.conservation <- mcols(nf.conservation)[, score.colnames]
  nc.conservation <- mcols(nc.conservation)[, score.colnames]
  nd.conservation <- mcols(nd.conservation)[, score.colnames]
  nf.conservation[is.na(nf.conservation)] <- 0
  nc.conservation[is.na(nc.conservation)] <- 0
  nd.conservation[is.na(nd.conservation)] <- 0
  # median fragment length
  nf.old <- as(nf.old, "GRanges")
  nc.old <- as(nc.old, "GRanges")
  nf.ol <- findOverlaps(nf, nf.old)
  nc.ol <- findOverlaps(nc, nc.old)
  nf.ol <- split(width(nf.old)[subjectHits(nf.ol)], queryHits(nf.ol))
  nc.ol <- split(width(nc.old)[subjectHits(nc.ol)], queryHits(nc.ol))
  rm(nf.old)
  rm(nc.old)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  stopifnot(length(nf.ol)==length(nf))
  stopifnot(length(nc.ol)==length(nc))
  nf.frag.len <- sapply(nf.ol, median)
  nc.frag.len <- sapply(nc.ol, median)
  nf.frag.len <- nf.frag.len[order(as.numeric(names(nf.frag.len)))]
  nc.frag.len <- nc.frag.len[order(as.numeric(names(nc.frag.len)))]
  nd.frag.len <- width(nd)
  x.nf <- cbind(nf.frag.len, nf.conservation, nf.gc)
  x.nc <- cbind(nc.frag.len, nc.conservation, nc.gc)
  x <- rbind(x.nf, x.nc)
  testdata <- cbind(nd.frag.len, nd.conservation, nd.gc)
  colnames(testdata) <- colnames(x) <- NULL
  y <- as.factor(rep(c("f", "n"), c(length(nf), length(nc))))
  fit <- randomForest(x, y,
                      ntree=2*ceiling(sqrt(length(y))),
                      keep.inbag=TRUE)
  pred <- predict(fit, newdata=testdata, type='prob')
  pred.free <- pred[, "f"]
  pred.bind <- pred[, "n"]
  rm(nd.gc, nf.gc, nc.gc)
  rm(pred)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  nucleosome <- names(obj) %in% names(nd[pred.bind >= cutoff])
  nucleosomefree <- names(obj) %in%
    names(nd[pred.free>= cutoff & pred.bind < cutoff])
  NucleosomeFree <- obj[nucleosomefree]
  Nucleosome <- obj[nucleosome]
  left <- obj[!(nucleosome | nucleosomefree)]
  rm(nd)
  rm(obj)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  objs <- split(left,
                cut(abs(mcols(left)$isize),
                    breaks = breaks,
                    labels = labels))
  rm(left)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  Nucleosome <- split(Nucleosome,
                      cut(abs(mcols(Nucleosome)$isize),
                          breaks = breaks,
                          labels = labels))
  Nucleosome[[labelsOfNucleosomeFree]] <- NucleosomeFree
  rm(NucleosomeFree)
  gc(verbose = FALSE, reset = TRUE, full = TRUE)
  for(i in intersect(names(Nucleosome), names(objs))){
    objs[[i]] <- c(Nucleosome[[i]], objs[[i]])
  }
  if(!missing(outPath)){
    writeListOfGAlignments(objs, outPath = outPath)
  }
  objs
}


GRbin <- function(A, B, col){
    A1 <- B1 <- C <- disjoin(c(A, B), ignore.strand=FALSE)
    ol1 <- findOverlaps(C, A, minoverlap=1L,
                        type="any", ignore.strand=FALSE)
    ol2 <- findOverlaps(C, B, minoverlap=1L,
                        type="any", ignore.strand=FALSE)
    A1$value <- B1$value <- 0
    A1$value[queryHits(ol1)] <- mcols(A)[subjectHits(ol1), col]
    B1$value[queryHits(ol2)] <- mcols(B)[subjectHits(ol2), col]
    GRangesList(A=A1, B=B1)
}
GRoperator <- function(A, B, col="score", 
                       operator=c("+", "-", "*", "/", "^", "%%")){
    if(!is(A, "GRanges") || !is(B, "GRanges")){
        stop("A and B must be objects of GRanges")
    }
    operator <- match.arg(operator)
    if(!(col %in% colnames(mcols(A)))){
        stop("col is not in metadata of A")
    }
    if(!(col %in% colnames(mcols(B)))){
        stop("col is not in metadata of B")
    }
    C <- GRbin(A, B, col)
    A <- C$A
    B <- C$B
    out <- A
    operator <- .Primitive(operator)
    out$value <- operator(A$value, B$value)
    colnames(mcols(out)) <- col
    out
}

test_that("splitGAlignmentsByCut works not correct", {
  gal <- GAlignments(seqnames=Rle("chr1", 6), pos=1:6,
                     cigar=c("50M", "50M", "50M", "50M", "50M", "50M"),
                     strand=Rle(strand(c("+", "-", "+", "-")), c(1, 2, 2, 1)),
                     qname=tail(letters, 6),
                     isize=c(180, -180, -265, 265, 185, -185))
  expect_error(splitGAlignmentsByCut(gal))
  names(gal) <- mcols(gal)$qname
  objs <- splitGAlignmentsByCut(gal)
  expect_equal(unname(lengths(objs)), c(0, 2, 2, 2, 0, 0, 0, 0))
})

#' @title prepare bam files for downstream analysis
#' @description shift the bam files by 5'ends and split the bam files.
#' @param bamfile character(1). File name of bam.
#' @param tags A vector of characters indicates the tags in bam file.
#' @param index The names of the index file of the 'BAM' file being processed;
#'        This is given without the '.bai' extension.
#' @param outPath Output file path.
#' @param txs \link[GenomicRanges:GRanges-class]{GRanges} of transcripts.
#' @param genome An object of \link[BSgenome:BSgenome-class]{BSgenome}
#' @param conservation An object of \link[GenomicScores:GScores-class]{GScores}.
#' @param positive integer(1). the size to be shift for positive strand
#' @param negative integer(1). the size to be shift for negative strand
#' @param breaks A numeric vector for fragment size of nucleosome free,
#' mononucleosome, dinucleosome and trinucleosome
#' @param labels A vector of characters indicates the labels for the levels
#' of the resulting category.
#' The length of labels = length of breaks - 1
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param cutoff numeric(1). Cutoff value for prediction by
#' \link[randomForest]{randomForest}.
#' @param flag An integer(2) vector used to filter reads based on their 
#' 'flag' entry. 
#' @return an invisible list of \link[GenomicAlignments:GAlignments-class]{GAlignments}
#' @author Jianhong Ou
#' @export
#' @import GenomeInfoDb
#' @importFrom Rsamtools scanBamFlag
#' @seealso \link{shiftGAlignmentsList}, \link{splitGAlignmentsByCut}, and 
#' \link{writeListOfGAlignments}
#' @examples
#'if(Sys.getenv("USER")=="jianhongou"){
#' bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
#' tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' library(phastCons100way.UCSC.hg19)
#' objs <- splitBam(bamfile, tags,
#'                  txs=txs, genome=Hsapiens,
#'                  conservation=phastCons100way.UCSC.hg19,
#'                  seqlev="chr1")
#'}

splitBam <- function(bamfile, tags, index=bamfile, outPath=NULL,
                     txs, genome, conservation,
                     positive=4L, negative=5L,
                     breaks=c(0, 100, 180, 247, 315, 473, 558, 615, Inf),
                     labels = c("NucleosomeFree", "inter1",
                                "mononucleosome", "inter2",
                                "dinucleosome", "inter3",
                                "trinucleosome", "others"),
                     seqlev=paste0("chr", c(1:22, "X", "Y")),
                     cutoff = .8, 
                     flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                      isUnmappedQuery=FALSE,
                                      isNotPassingQualityControls = FALSE,
                                      isSupplementaryAlignment = FALSE)){
  stopifnot(length(labels)+1==length(breaks))
  stopifnot(is(txs, "GRanges"))
  conservationFlag <- FALSE
  if(!missing(conservation)){
    if(length(conservation)){
        stopifnot(is(conservation, "GScores"))
        conservationFlag <- TRUE ## conservation is supplied.
    }
  }
  if(!conservationFlag) conservation <- NULL
  stopifnot(is(genome, "BSgenome"))
  stopifnot(length(seqlev)>0)
  stopifnot(is.integer(positive))
  stopifnot(is.integer(negative))
  ## prepare for output
  if(!is.null(outPath)){
    stopifnot(length(outPath)==1)
    if(!file.exists(outPath)){
      dir.create(outPath, showWarnings = FALSE, recursive = TRUE)
    }
    stopifnot(file.exists(outPath))
    shiftPath <- file.path(outPath, "shifted.bam")
    if(file.exists(shiftPath)){
      stop("File ", shiftPath, " exits!")
    }
    for(i in labels){
      if(file.exists(file.path(outPath, paste0(i, ".bam")))){
        stop("File ", file.path(outPath, paste0(i, ".bam")), " exits!")
      }
    }
  }

  ## shift
  which <- as(seqinfo(genome)[seqlev], "GRanges")
  gal <- readBamFile(bamfile, index=index, tag=tags, which=which, 
                     what=c("qname", "flag", "mapq", "isize", 
                            "seq", "qual", "mrnm"),
                     flag=flag,
                     asMates=TRUE, bigFile = TRUE)
  if(!is.null(outPath)){
    gal1 <- shiftGAlignmentsList(gal,
                                 positive=positive, negative=negative,
                                 outbam = file.path(outPath, "shifted.bam"))
    ## split
    objs <- splitGAlignmentsByCut(gal1, breaks=breaks, labels=labels,
                                  txs=txs, genome=genome, conservation=conservation,
                                  outPath = outPath,
                                  cutoff=cutoff)
  }else{
    gal1 <- shiftGAlignmentsList(gal,
                                 positive=positive, negative=negative)
    ## split
    objs <- splitGAlignmentsByCut(gal1, breaks=breaks, labels=labels,
                                  txs=txs, genome=genome, conservation=conservation,
                                  cutoff=cutoff)
  }
  objs$all <- gal1
  return(invisible(objs))
}

#' Promoter/Transcript body (PT) score
#' @description PT score is calculated for coverage of promoter divided by the coverage of transcripts body.
#' PT score will show if the signal is enriched in promoters.
#' @param obj an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}
#' @param txs GRanges of transcripts
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param upstream numeric(1) or integer(1). Start position of promoter. Default is 2000
#' @param downstream numeric(1) or integer(1). End position of promoter. Default is 500
#' @importClassesFrom GenomicAlignments GAlignments
#' @importClassesFrom GenomicRanges GRanges
#' @importFrom GenomicRanges promoters coverage shift
#' @importFrom IRanges viewMeans Views
#' @export
#' @return A object of \link[GenomicRanges:GRanges-class]{GRanges} with PT scores
#' @author Jianhong Ou
#' @examples  
#' library(GenomicRanges)
#' bamfile <- system.file("extdata", "GL1.bam", 
#'                        package="ATACseqQC", mustWork=TRUE)
#' gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
#'                     which=GRanges("chr1", IRanges(1, 1e6)), 
#'                     asMates=FALSE)
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' pt <- PTscore(gal1, txs)
PTscore <- function(obj, txs,
                     seqlev=intersect(seqlevels(obj), seqlevels(txs)),
                     upstream=2000, downstream=500){
  stopifnot(is(obj, "GAlignments"))
  if(length(obj)==0){
    obj <- loadBamFile(obj, minimal=TRUE)
  }
  stopifnot(is(txs, "GRanges"))
  obj <- as(obj, "GRanges")
  mcols(obj) <- NULL
  obj <- promoters(obj, upstream = 0, downstream = 1)
  cvg <- coverage(obj)
  cvg <- cvg[sapply(cvg, mean)>0]
  cvg <- cvg[names(cvg) %in% seqlev]
  seqlev <- seqlev[seqlev %in% names(cvg)]
  cvg <- cvg[seqlev]
  txs <- txs[seqnames(txs) %in% seqlev]
  txs <- unique(txs)
  pro <- promoters(txs, upstream = upstream, downstream = downstream)
  body <- shift(pro, shift = upstream + downstream)
  body[strand(pro)=="-"] <- shift(pro[strand(pro)=="-"], 
                                  shift = -1 * (upstream + downstream))
  pro$source <- "promoter"
  body$source <- "transcript"
  pro$oid <- seq_along(pro)
  body$oid <- seq_along(body)
  
  sel.gr <- c(pro, body)
  sel.gr <- sel.gr[order(sel.gr$oid)]
  
  sel.gr <- split(sel.gr, seqnames(sel.gr))
  seqlev <- seqlev[seqlev %in% names(sel.gr)]
  sel.gr <- sel.gr[seqlev]
  cvg <- cvg[seqlev]
  vws <- Views(cvg, sel.gr)
  vms <- viewMeans(vws)
  sel.gr <- unlist(sel.gr)
  sel.gr$score <- unlist(vms)
  
  pro <- sel.gr[sel.gr$source %in% "promoter"]
  body <- sel.gr[sel.gr$source %in% "transcript"]
  stopifnot(identical(pro$oid, body$oid))
  sel <- txs
  sel$promoterPart <- ranges(pro)
  sel$transcriptPart <- ranges(body)
  sel$promoter <- pro$score
  sel$transcriptBody <- body$score
  smallNumber <- max(c(1e-6, min(pro$score, na.rm = TRUE), 
                       min(body$score, na.rm = TRUE)), na.rm = TRUE)
  sel$log2meanCoverage <- log2(pro$score + smallNumber) + log2(body$score + smallNumber)
  sel$PT_score <- log2(pro$score + smallNumber) - log2(body$score + smallNumber)
  sel <- sel[order(sel$PT_score, decreasing = TRUE)]
  return(sel)
}

#' scan ATAC-seq footprints infer factor occupancy genome wide
#' @description Aggregate ATAC-seq footprint for a bunch of motifs generated
#'              over binding sites within the genome.
#' @param bamExp A vector of characters indicates the file names of experiment bams. 
#' The bam file must be the one with shifted reads.
#' @param bamCtl A vector of characters indicates the file names of control bams. 
#' The bam file must be the one with shifted reads.
#' @param indexExp,indexCtl The names of the index file of the 'BAM' file being processed;
#'        This is given without the '.bai' extension.
#' @param bindingSitesList A object of \link[GenomicRanges:GRangesList-class]{GRangesList} indicates
#' candidate binding sites (eg. the output of fimo).
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param proximal,distal numeric(1) or integer(1).
#'        basepair for open region from binding sites (proximal) and extented region for background (distal) 
#'        of the binding region for aggregate ATAC-seq footprint.
#' @param gap numeric(1) or integer(1). basepair for gaps among binding sites, 
#'            proximal, and distal. default is 5L.
#' @param maximalBindingWidth numeric(1) or integer(1). Maximal binding sites width for
#'                            all the motifs. If setted, all motif binding sites will be 
#'                            re-sized to this value. 
#' @param cutoffLogFC,cutoffPValue numeric(1). Cutoff value for differential bindings.
#' @param correlatedFactorCutoff numeric(1). Cutoff value for correlated factors. 
#' If the overlapping binding site within 100bp is more than cutoff, the TFs will be treated as correlated factors.
#' @importFrom stats p.adjust pnorm
#' @importFrom ChIPpeakAnno estLibSize reCenterPeaks
#' @importFrom GenomicAlignments readGAlignments summarizeOverlaps
#' @importFrom Biostrings matchPWM maxScore
#' @importFrom Rsamtools ScanBamParam
#' @import edgeR
#' @import GenomeInfoDb
#' @import GenomicRanges
#' @import IRanges
#' @import S4Vectors
#' @return a list.
#' It includes:
#'  - bindingSites            GRanges of binding site with hits of reads
#'  - data                    a list with test result for each binding site
#'  - results                 a data.frame with open score and enrichment score of motifs
#' @export
#' @author Jianhong Ou
#' @examples
#'
#'bamfile <- system.file("extdata", "GL1.bam",
#'                        package="ATACseqQC")
#'bsl <- system.file("extdata", "jolma2013.motifs.bindingList.95.rds",
#'                   package="ATACseqQC")
#'bindingSitesList <- readRDS(bsl)
#'footprintsScanner(bamfile, seqlev="chr1", bindingSitesList=bindingSitesList)
#'
footprintsScanner <- function(bamExp, bamCtl, indexExp=bamExp, indexCtl=bamCtl, 
                              bindingSitesList, seqlev=paste0("chr", c(1:25, "X", "Y")),  
                              proximal=40L, distal=proximal, gap=10L, 
                              maximalBindingWidth=NA, 
                              cutoffLogFC=log2(1.5),
                              cutoffPValue=0.05,
                              correlatedFactorCutoff=3/4){
  ## compare signal vs. inputs, negative binomial test
  ## reads must be shifted. 5' end counts
  ## 2 steps: 
  ## Step1: open region counts comparison
  ## Step2: binding region counts comparison
  ## if there is two group, exp vs input,
  ## open region = 50bp from binding site edge
  ## binding region = binding motif width
  ## if there is one one group, proximal (50bp) vs. distal (50bp) or auto
  ## distal is set to control
  ## output motif open score, motif enrichment score, pvalue, p-adjust, 
  ## motifName, footprints curve data for downstream plot.
  ## open score = log2 fold change of open region
  ## enrichment score = log2 fold change of binding site 
  stopifnot(is.numeric(proximal))
  stopifnot(is.numeric(distal))
  stopifnot(is.numeric(gap))
  proximal <- as.integer(proximal)
  distal <- as.integer(distal)
  gap <- as.integer(gap)
  stopifnot(proximal>10 && distal>10)
  if(missing(bamExp)){
    stop("bamExp is required.")
  }
  if(missing(bindingSitesList)){
    stop("bindingSitesList is required.")
  }else{
    mts <- lapply(bindingSitesList, function(bindingSites){
      if(!is(bindingSites, "GRanges")){
        stop("bindingSitesList must be a object of GRangesList")
      }
      if(length(bindingSites)<=1){
        stop("The length of elements in bindingSitesList must be greater than 1.")
      }
      bindingSites[seqnames(bindingSites) %in% seqlev]
    })
  }
  mts <- mts[lengths(mts)>100]
  if(length(mts)<1){
    stop("no enough bindingsites in given seqlev.")
  }
  mts.unlist <- unlist(GRangesList(mts), use.names = FALSE)
  mts.unlist$motif <- rep(names(mts), lengths(mts))
  names(mts.unlist) <- 
    paste0("pos", formatC(seq.int(length(mts.unlist)), 
                          width = nchar(as.character(length(mts.unlist))), 
                          flag = "0"))
  seqlev <- intersect(seqlevels(mts.unlist), seqlev)
  seqlevels(mts.unlist) <- seqlevels(mts.unlist)[seqlevels(mts.unlist) %in% seqlev]
  seqinfo(mts.unlist) <- Seqinfo(seqlev, seqlengths = seqlengths(mts.unlist))
  ## set all binding sites width identical
  if(!is.na(maximalBindingWidth[1])){
    maximalBindingWidth <- maximalBindingWidth[1]
    stopifnot(is.numeric(maximalBindingWidth))
    mts.unlist <- reCenterPeaks(mts.unlist, 
                                width = round(maximalBindingWidth))
  }
  mts.unlist.with.proximal <- mts.unlist.with.distal <- mts.unlist
  mts.unlist.with.proximal.gap <- mts.unlist.with.distal.gap <- mts.unlist
  start(mts.unlist.with.proximal) <- start(mts.unlist) - proximal - gap
  end(mts.unlist.with.proximal) <- end(mts.unlist) + proximal + gap
  start(mts.unlist.with.distal) <- start(mts.unlist) - proximal - 2*gap - distal
  end(mts.unlist.with.distal) <- end(mts.unlist) + proximal + distal + 2*gap
  start(mts.unlist.with.proximal.gap) <- start(mts.unlist) - gap
  end(mts.unlist.with.proximal.gap) <- end(mts.unlist) + gap
  start(mts.unlist.with.distal.gap) <- start(mts.unlist) - proximal - 2*gap
  end(mts.unlist.with.distal.gap) <- end(mts.unlist) + proximal + 2*gap
  ## get total reads counts
  bams <- data.frame(bamfiles = bamExp, index = indexExp, group="Exp", stringsAsFactors = FALSE)
  if(!missing(bamCtl)){
    bams <- rbind(bams, 
                  data.frame(bamfiles = bamCtl, index = indexCtl, group="Ctl", stringsAsFactors = FALSE))
  }
  bams$libSize <- estLibSize(bamfiles = bams$bamfiles, index = bams$index)
  bams$sample <- sub(".bam", "", make.names(basename(bams$bamfiles)))
  ## count reads by 5'ends
  count5ends <- function(bam, index, chunk=100000, binding, pro, dis, pro.gap, dis.gap){
    ## check rowRanges order
    stopifnot(all(distance(binding, pro)==0))
    stopifnot(all(distance(pro, dis)==0))
    bamfile <- BamFile(bam, index=index, yieldSize=chunk)
    open(bamfile)
    counts <- data.frame(bs=rep(0, length(binding)),
                         pro.gap=rep(0, length(pro.gap)),
                         pro=rep(0, length(pro)),
                         dis.gap=rep(0, length(dis.gap)),
                         dis=rep(0, length(dis)))
    while (length(chunk0 <- readGAlignments(bamfile))) {
      ## keep 5' end only
      chunk0 <- as(chunk0, "GRanges")
      chunk0 <- promoters(chunk0, upstream = 0, downstream = 1)
      ## counts of binding sites
      so.bs <- countOverlaps(binding, chunk0, ignore.strand=TRUE)
      ## counts of binding sites + gap
      so.pro.gap <- countOverlaps(pro.gap, chunk0, ignore.strand=TRUE)
      ## counts of binding sites + proximal
      so.pro <- countOverlaps(pro, chunk0, ignore.strand=TRUE)
      ## counts of binding sites + gap + proximal + gap
      so.dis.gap <- countOverlaps(dis.gap, chunk0, ignore.strand=TRUE)
      ## counts of binding sites + proximal + distal
      so.dis <- countOverlaps(dis, chunk0, ignore.strand=TRUE)
      counts <- counts + data.frame(bs=so.bs,
                                    pro.gap=so.pro.gap,
                                    pro=so.pro,
                                    dis.gap=so.dis.gap,
                                    dis=so.dis)
    }
    close(bamfile)
    counts$dis <- counts$dis - counts$dis.gap
    counts$pro <- counts$pro - counts$pro.gap
    counts$pro.gap <- NULL
    counts$dis.gap <- NULL
    stopifnot(all(counts$dis>=0))
    stopifnot(all(counts$pro>=0))
    rownames(counts) <- names(binding)
    counts
  }
  counts <- mapply(function(a, b) count5ends(bam=a, index=b, binding = mts.unlist, 
                                             pro=mts.unlist.with.proximal, 
                                             dis=mts.unlist.with.distal,
                                             pro.gap=mts.unlist.with.proximal.gap,
                                             dis.gap=mts.unlist.with.distal.gap), 
                   bams$bamfiles, bams$index, SIMPLIFY = FALSE)
  names(counts) <- bams$sample
  ## filter 0 counts
  keep <- lapply(counts, function(.ele) rowSums(.ele)>0)
  keep <- do.call(cbind, keep)
  keep <- rowSums(keep) > 0
  counts <- lapply(counts, function(.ele) .ele[keep, , drop=FALSE])
  mts.unlist <- mts.unlist[keep]
  ## normalize counts by width of count region
  ## normalize by width
  wid <- width(mts.unlist)
  names(wid) <- names(mts.unlist)
  norm.counts <- lapply(counts, function(.ele){
    round(.ele*max(c(wid, proximal, distal))/data.frame(bs=wid/2, pro=proximal, dis=distal))
  })
  ## split the reads counts by samples
  groupNames <- colnames(norm.counts[[1]])
  norm.cnt <- lapply(groupNames, function(.ele) {
    x <- do.call(cbind, lapply(norm.counts, `[`, i=.ele))
    colnames(x) <- names(norm.counts)
    x
  })
  names(norm.cnt) <- groupNames
  
  ## calculate the log2 fold change of open score and binding score
  ## open data == log2(proximal in exp) - log2(proximal in ctl)
  ## or            log2(proximal) - log2(distal)
  ## binding data == log2(binding in exp) - log2(binding in ctl)
  ## or               log2(proximal) - log2(binding) ## get positive value
  ## and get p value via edgeR
  if(!missing(bamCtl)){
    data <- list(openData = norm.cnt[["pro"]],
                 bindData = norm.cnt[["bs"]]) ## for binding site, the avoidence is enrichment, so need reverse.
    grp <- bams$group
    libSize <- bams$libSize
  }else{
    data <- list(openData = cbind(norm.cnt[["pro"]], norm.cnt[["dis"]]),
                 bindData = cbind(norm.cnt[["pro"]], norm.cnt[["bs"]]))
    grp <- rep(c("Exp", "Ctl"), each=ncol(norm.cnt[["pro"]]))
    libSize <- rep(bams$libSize, 2)
  }
  res <- lapply(data, DB, libSize=libSize, group=grp)
  ## reveser the enrichment for binding sites
  if(!missing(bamCtl)){
    res[["bindData"]]$logFC <- -1 * res[["bindData"]]$logFC
  }
  ## split the reads counts by factor
  res <- lapply(res, split, f=mts.unlist$motif)
  correlationScore <- function(mts.unlist){
    #if the binding site overlaps within 100bp more than half of the binding sites
    ol <- findOverlaps(mts.unlist, maxgap = 100, drop.self = TRUE, drop.redundant = TRUE)
    qh <- mts.unlist[queryHits(ol)]$motif
    sh <- mts.unlist[subjectHits(ol)]$motif
    keep <- qh!=sh
    qh <- qh[keep]
    sh <- sh[keep]
    tab <- table(data.frame(query=qh, subject=sh))
    tab2 <- table(mts.unlist$motif)
    per <- apply(tab, 2, function(.ele) .ele/tab2[rownames(tab)])
    per <- per[match(colnames(per), rownames(per)), ]
    rownames(per) <- colnames(per)
    per[is.na(per)] <- 0
    per
  }
  cs <- correlationScore(mts.unlist)
  correlatedFactors <- function(cs, cutoff=3/4){
    #hc <- hclust(as.dist(cs), method = "average")
    w <- which(cs>cutoff)
    i <- w - nrow(cs)*floor(w/nrow(cs))
    j <- ceiling(w/nrow(cs))
    g <- split(c(rownames(cs)[i], colnames(cs)[j]), c(colnames(cs)[j], rownames(cs)[i]))
    g <- g[rownames(cs)]
    names(g) <- rownames(cs)
    g <- mapply(c, g, names(g))
    g <- unname(g)
    g <- lapply(g, sort)
    unique(g)
  }
  cf <- correlatedFactors(cs, cutoff = correlatedFactorCutoff)
  ## cutoff the values by logFC > log2(1.5) && FDR < 0.05
  countTable <- function(x, fc=cutoffLogFC, pval=cutoffPValue, alternative=c("greater", "less", "both")){
    alternative <- match.arg(alternative)
    x <- do.call(rbind, lapply(x, function(.ele){
      .ele <- switch(alternative, 
                     "greater"= table(.ele$logFC > fc & .ele$PValue < pval)[c("FALSE", "TRUE")],
                     "less" = table(.ele$logFC < -1*fc & .ele$PValue < pval)[c("FALSE", "TRUE")],
                     "both" = table(abs(.ele$logFC) > fc & .ele$PValue < pval)[c("FALSE", "TRUE")])
      .ele[is.na(.ele)] <- 0
      names(.ele) <- c("FALSE", "TRUE")
      .ele
    }))
    ## get open or binding percentage and then Z-score
    percent <- 100*x[, "TRUE"]/rowSums(x)
    percent[is.infinite(percent)] <- 0
    ## need to remove the correlated factors?
    ## correlated factors, 
    per.clean <- sapply(cf, function(.ele){
      mean(percent[.ele])
    })
    Z <- (percent - mean(per.clean))/sd(per.clean)
    Z[is.na(Z)] <- -Inf
    ## get p-value
    pval <- pnorm(-Z) ## one side, over
    cbind(score=percent, pval)
  }
  enrich.counts <- lapply(res, countTable, alternative="greater")
  enrich.counts <- do.call(cbind, enrich.counts)
  reduce.counts <- lapply(res, countTable, alternative="less")
  reduce.counts <- do.call(cbind, reduce.counts)
  alter.counts <- lapply(res, countTable, alternative="both")
  alter.counts <- do.call(cbind, alter.counts)
  
  colnames(enrich.counts) <- paste(rep(c("proximalSiteOpen", "bindingSiteEnrichment"), 
                                       each=ncol(enrich.counts)/2),
                                   colnames(enrich.counts), sep=".")
  colnames(reduce.counts) <- paste(rep(c("proximalSiteClose", "bindingSiteReduction"), 
                                       each=ncol(reduce.counts)/2),
                                   colnames(reduce.counts), sep=".")
  colnames(alter.counts) <- paste(rep(c("proximalSiteAlter", "bindingSiteAlter"), 
                                       each=ncol(alter.counts)/2),
                                   colnames(alter.counts), sep=".")
  
  stopifnot(identical(rownames(enrich.counts), rownames(reduce.counts)))
  stopifnot(identical(rownames(enrich.counts), rownames(alter.counts)))
  res.counts <- cbind(enrich.counts, reduce.counts, alter.counts)
  return(list(bindingSites=mts.unlist,
              data=res,
              results=res.counts))
}


#' helper function for preparing the binding list
#' @rdname footprintsScanner
#' @param pfms A list of Position frequency Matrix represented as a numeric matrix
#'        with row names A, C, G and T.
#' @param genome An object of \link[BSgenome:BSgenome-class]{BSgenome}.
#' @param expSiteNum numeric(1). Expect number of predicted binding sites.
#'        if predicted binding sites is more than this number, top expSiteNum binding
#'        sites will be used.
#' @importFrom Biostrings matchPWM maxScore
#' @export
#' @examples
#' library(MotifDb)
#' motifs <- query(MotifDb, c("Hsapiens"))
#' motifs <- as.list(motifs)
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' #bindingSitesList <- prepareBindingSitesList(motifs, genome=Hsapiens)
prepareBindingSitesList <- function(pfms, genome, 
                                    seqlev=paste0("chr", c(1:22, "X", "Y")),
                                    expSiteNum=5000){
  mts <- lapply(pfms, function(pfm){
    if(!all(round(colSums(pfm), digits=4)==1)){
      stop("pfms must be list of Position frequency Matrix")
    }
    pwm <- motifStack::pfm2pwm(pfm)
    min.score <- 95
    suppressWarnings({
      mt <- matchPWM(pwm, genome, min.score = paste0(min.score, "%"),
                     with.score=TRUE, exclude=names(genome)[!names(genome) %in% seqlev])
    })
    while(length(mt)<expSiteNum && min.score>80){
      min.score <- min.score - 5
      suppressWarnings({
        mt <- matchPWM(pwm, genome, min.score = paste0(min.score, "%"),
                       with.score=TRUE, exclude=names(genome)[!names(genome) %in% seqlev])
      })
    }
    if(length(mt)>expSiteNum){## subsample
      mt$oid <- seq_along(mt)
      mt <- mt[order(mt$score, decreasing = TRUE)]
      mt <- mt[mt$score>=mt$score[expSiteNum]]
      mt <- mt[order(mt$oid)]
      mt$oid <- NULL
    }
    mt$string <- NULL
    mt
  })
}

#' helper function for differential binding
#' @param counts count table
#' @param libSize library size
#' @param group group design
#' @param default.bcv a reasonable dispersion value 
#' @return topTable
#' @importFrom stats model.matrix
DB <- function(counts, libSize, group, default.bcv=0.3){
  stopifnot(length(libSize)==ncol(counts))
  if(any(duplicated(colnames(counts)))){
    colnames(counts) <- make.names(colnames(counts), unique = TRUE)
  }
  d <- DGEList(counts = counts, lib.size = libSize, 
               group = factor(group, levels = c("Ctl", "Exp")))
  d <- calcNormFactors(d, method = "RLE") ## normalization method
  mm <- model.matrix(~group)
  suppressWarnings(d <- estimateDisp(d, mm))
  if(any(is.na(d$common.dispersion))){
    et <- exactTest(d, dispersion = default.bcv^2)
    res <- et$table
    res$FDR <- p.adjust(res$PValue, method = "BH")
  }else{
    f <- glmFit(d, mm)
    lrt <- glmLRT(f, coef=2)
    res <- topTags(lrt, n = nrow(lrt), sort.by="none")
    res <- as.data.frame(res)
  }
  stopifnot(identical(rownames(counts), rownames(res)))
  stopifnot(all(c("logFC", "FDR") %in% colnames(res)))
  return(res)
}

#' Plots a footprint estimated by Centipede
#'
#' Visualizing the footprint profile
#'
#' @param Profile A vector with the profile estimated by CENTIPEDE
#' @param Mlen Length of the motif for drawing vertical lines delimiting it
#' @param xlab Label of the x axis
#' @param ylab Label for the y axis
#' @param legLabels Labels for legend.
#' @param legTitle Title for one of the plot corners
#' @param xlim xlim
#' @param ylim ylim
#' @param newpage Plot the figure in a new page?
#' @param motif a pfm object.
#' @param segmentation the segmentation position and abundance
#' @param reNormalizeByDistalSig Re-normalized the curver by distal signals.
#' @param ... Not used.
#' @importFrom grid grid.newpage viewport plotViewport pushViewport upViewport
#' gpar grid.xaxis grid.yaxis convertX convertY 
#' unit grid.legend grid.text grid.lines grid.segments
#' @importFrom motifStack plotMotifLogoA
#' @importClassesFrom motifStack pfm
#' @export
#' @return Null.
#' @author Jianhong Ou
#' @examples
#' library(MotifDb)
#' CTCF <- query(MotifDb, c("CTCF"))
#' CTCF <- as.list(CTCF)
#' motif <- new("pfm", mat=CTCF[[1]], name="CTCF")
#' ATACseqQC:::plotFootprints(Profile=sample.int(500), 
#'                         Mlen=ncol(CTCF[[1]]), motif=motif)
plotFootprints <- function (Profile, Mlen = 0,
                            xlab = "Dist. to motif (bp)",
                            ylab = "Cut-site probability",
                            legLabels = c("For. strand", "Rev. strand"),
                            legTitle, xlim, ylim,
                            newpage = TRUE, motif, segmentation,
                            reNormalizeByDistalSig = FALSE,
                            ...)
{
  stopifnot(is(motif, "pfm"))
  if(newpage) grid.newpage()

  S <- length(Profile)
  W <- ((S/2) - Mlen)/2
  if(reNormalizeByDistalSig && !missing(segmentation)){
    if(length(segmentation)==4){
      Prof <- list()
      Prof[[1]] <- Profile[1:(S/2)]
      Prof[[2]] <- Profile[(S/2 + 1):S]
      P_id <- floor(segmentation[1])
      from <- c(1, P_id+1, W+1, W+Mlen+1, S/2-P_id+1)
      to <- c(from[-1]-1, S/2)
      sig_level <- lapply(Prof, function(.ele){
        .ele <- mapply(from, to, FUN=function(f, t){
          .ele[seq(f, t)]
        }, SIMPLIFY = FALSE)
        return(c(
          "distal_abun" = mean(c(.ele[[1]], .ele[[5]]), na.rm=TRUE),
          "proximal_abun" = mean(c(.ele[[2]], .ele[[4]]), na.rm=TRUE),
          "binding" = mean(.ele[[3]], na.rm=TRUE)))
      })
      norm_factor <- vapply(sig_level, FUN = function(.ele) .ele["distal_abun"],
                            FUN.VALUE = numeric(1L))
      norm_factor <- mean(norm_factor)/norm_factor
      Prof <- mapply(Prof, norm_factor, FUN=function(p, f) p*f,
                        SIMPLIFY=FALSE)
      Profile <- c(Prof[[1]], Prof[[2]])
      segmentation[-1] <- apply(do.call(rbind, sig_level), 2, mean, na.rm=TRUE)
    }
  }
  vp <- plotViewport(margins=c(5.1, 5.1, 4.1, 2.1), name="plotRegion")
  pushViewport(vp)
  if(missing(xlim)){
    xlim <- c(0, S/2+1)
  }
  if(missing(ylim)){
    ylim <- c(0, max(Profile) * 1.12)
  }
  vp1 <- viewport(y=.4, height=.8,
                  xscale=xlim,
                  yscale=ylim,
                  name="footprints")
  pushViewport(vp1)
  grid.lines(x=1:(S/2),
             y=Profile[1:(S/2)],
             default.units="native",
             gp=gpar(lwd = 2, col = "darkblue"))
  grid.lines(x=1:(S/2),
             y=Profile[(S/2 + 1):S],
             default.units="native",
             gp=gpar(lwd = 2, col = "darkred"))
  if(!missing(segmentation)){
    if(length(segmentation)==4){
      ## plot the guide line for the segmentation
      grid.segments(x0=c(0, segmentation[1], W, W+Mlen, S/2-segmentation[1]),
                    x1=c(segmentation[1], W, W+Mlen, S/2-segmentation[1], S/2),
                    y0=c(segmentation[2], segmentation[3], segmentation[4], segmentation[3], segmentation[2]),
                    y1=c(segmentation[2], segmentation[3], segmentation[4], segmentation[3], segmentation[2]),
                    default.units = "native",
                    gp=gpar(lwd =2, col = "red", lty = 2))
    }
  }
  grid.xaxis(at = c(seq(1, W, length.out = 3),
                    W + seq(1, Mlen),
                    W + Mlen + seq(1, W, length.out = 3)),
             label = c(-(W + 1 - seq(1, W + 1, length.out = 3)),
                       rep("", Mlen),
                       seq(0, W, len = 3)))
  grid.yaxis()
  grid.lines(x=c(W, W, 0), y=c(0, max(Profile), ylim[2]),
             default.units="native", gp=gpar(lty=2))
  grid.lines(x=c(W + Mlen + 1, W + Mlen + 1, S/2),
             y=c(0, max(Profile), ylim[2]),
             default.units="native", gp=gpar(lty=2))
  upViewport()
  vp2 <- viewport(y=.9, height=.2,
                  xscale=c(0, S/2+1),
                  name="motif")
  pushViewport(vp2)
  motifStack::plotMotifLogoA(motif)
  upViewport()
  upViewport()
  grid.text(xlab, y=unit(1, 'lines'))
  grid.text(ylab, x=unit(1, 'line'), rot = 90)
  if(missing(legTitle)){
    legvp <- viewport(x=unit(1, "npc")-convertX(unit(1, "lines"), unitTo="npc"),
                      y=unit(1, "npc")-convertY(unit(1, "lines"), unitTo="npc"),
                      width=convertX(unit(14, "lines"), unitTo="npc"),
                      height=convertY(unit(3, "lines"), unitTo="npc"),
                      just=c("right", "top"), name="legendWraper")
    pushViewport(legvp)
    grid.legend(labels=legLabels,
                gp=gpar(lwd=2, lty=1, col=c("darkblue", "darkred")))
    upViewport()
  } else {
    grid.text(legTitle,
              y=unit(1, "npc")-convertY(unit(1, "lines"), unitTo="npc"),
              gp=gpar(cex=1.2, fontface="bold"))
  }
  return(invisible())
}

#' @title ATAC-seq Quality Control
#'
#' @description ATAC-seq, an assay for Transposase-Accessible Chromatin using 
#' sequencing, is a rapid and sensitive method for chromatin accessibility 
#' analysis. It was developed as an alternative method to MNase-seq, FAIRE-seq 
#' and DNAse-seq. Comparing to the other methods, ATAC-seq requires less amount 
#' of the biological samples and time to process. In the process of analyzing 
#' several ATAC-seq dataset produced in our labs, we learned some of the unique 
#' aspects of the quality assessment for ATAC-seq data.To help users to quickly 
#' assess whether their ATAC-seq experiment is successful, we developed 
#' ATACseqQC package partially following the guideline published in Nature 
#' Method 2013 (Greenleaf et al.), including diagnostic plot of fragment size 
#' distribution, proportion of mitochondria reads, nucleosome positioning 
#' pattern, and CTCF or other Transcript Factor footprints.
"_PACKAGE"

#' Transcription Start Site (TSS) Enrichment Score
#' @description TSS score is a raio between aggregate distribution of reads centered on TSSs and that flanking 
#' the corresponding TSSs. TSS score = the depth of TSS (each step within 1000 bp each side) / the depth of end flanks (100bp each end).
#' TSSE score = max(mean(TSS score in each window)).
#' @param obj an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}
#' @param txs GRanges of transcripts
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param upstream,downstream numeric(1) or integer(1). upstream and downstream of TSS. Default is 1000
#' @param endSize numeric(1) or integer(1). the size of the end flanks. Default is 100
#' @param width numeric(1) or integer(1). the window size for TSS score. Default is 100.
#' @param step numeric(1) or integer(1). The distance between the start position of the sliding windows.
#' @param pseudocount numeric(1) or integer(1). Pseudocount. Default is 0. 
#' If pseudocount is no greater than 0, the features with ZERO or less than ZERO 
#' counts in flank region will be removed in calculation. 
#' @param ... parameter can be passed to loess.smooth other than 'x', 'y', 'family' and 'evaluation'.
#' @importClassesFrom GenomicAlignments GAlignments
#' @importClassesFrom GenomicRanges GRanges
#' @importFrom GenomicRanges promoters coverage shift
#' @importFrom IRanges viewMeans Views
#' @export
#' @return A object of list with TSS scores
#' @author Jianhong Ou
#' @references https://www.encodeproject.org/data-standards/terms/#enrichment
#' @examples  
#' library(GenomicRanges)
#' bamfile <- system.file("extdata", "GL1.bam", 
#'                        package="ATACseqQC", mustWork=TRUE)
#' gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
#'                     which=GRanges("chr1", IRanges(1, 1e6)), 
#'                     asMates=FALSE)
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' tsse <- TSSEscore(gal1, txs)
TSSEscore <- function(obj, txs,
                      seqlev=intersect(seqlevels(obj), seqlevels(txs)),
                      upstream=1000, downstream=1000, endSize=100, 
                      width=100, step = width, pseudocount=0, 
                      ...){
  stopifnot(is(obj, "GAlignments"))
  if(length(obj)==0){
    obj <- loadBamFile(obj, minimal=TRUE)
  }
  stopifnot(is(txs, "GRanges"))
  obj <- as(obj, "GRanges")
  mcols(obj) <- NULL
  cvg <- coverage(obj)
  cvg <- cvg[sapply(cvg, mean)>0]
  cvg <- cvg[names(cvg) %in% seqlev]
  seqlev <- seqlev[seqlev %in% names(cvg)]
  cvg <- cvg[seqlev]
  if(pseudocount!=0) cvg <- cvg + pseudocount
  txs <- txs[seqnames(txs) %in% seqlev]
  txs <- unique(txs)
  sel.center <- promoters(txs, upstream = upstream, downstream = downstream)
  sel.center$id <- seq_along(sel.center)
  sel.center.sw <- slidingWindows(sel.center, width = width, step = step)
  names(sel.center.sw) <- sel.center$id
  sel.center.s <- unlist(sel.center.sw, use.names = TRUE)
  sel.center.s$idx <- unlist(lapply(lengths(sel.center.sw), seq.int))
  
  sel.center.s <- split(sel.center.s, seqnames(sel.center.s))
  sel.center.s <- sel.center.s[names(cvg)]
  
  vws.center <- Views(cvg, sel.center.s)
  vms.center <- viewMeans(vws.center)
  
  ## do norm  
  #sel.center <- promoters(txs, upstream = upstream - endSize,
  #                        downstream = downstream - endSize
  #)
  sel.left.flank <- flank(sel.center, width=endSize, both=FALSE)
  sel.right.flank <- flank(sel.center, width=endSize, start=FALSE, both = FALSE)
  names(sel.left.flank) <- sel.left.flank$id
  names(sel.right.flank) <- sel.right.flank$id
  
  sel.left.flank <- split(sel.left.flank, seqnames(sel.left.flank))
  sel.left.flank <- sel.left.flank[names(cvg)]
  sel.right.flank <- split(sel.right.flank, seqnames(sel.right.flank))
  sel.right.flank <- sel.right.flank[names(cvg)]
  
  vws.left <- Views(cvg, sel.left.flank)
  vms.left <- viewMeans(vws.left)
  vws.right <- Views(cvg, sel.right.flank)
  vms.right <- viewMeans(vws.right)
  
  vms.m <- mapply(vms.center, sel.center.s, vms.left, vms.right, 
                  FUN = function(v, i, vl, vr){
    i <- i$idx
    id <- sort(union(names(vl), names(vr)))##make sure the left and right paired
    vl <- vl[id]
    vr <- vr[id]
    vl[is.na(vl)] <- vr[is.na(vl)]
    vr[is.na(vr)] <- vl[is.na(vr)]
    vl[is.na(vl)] <- pseudocount
    vr[is.na(vr)] <- pseudocount
    v[is.na(v)] <- pseudocount
    blk <- vl+vr
    names(blk) <- id
    keep <- blk>0 ## in case pseudocount is less than 1
    blk <- blk[keep]
    blk <- blk/2
    keep <- names(v) %in% names(blk)
    v <- v[keep]
    i <- i[keep]
    v <- v*endSize/blk[names(v)]/width
    ## names(v) is index number of sel.center
    ## i is the index number of bins
    tr <- unique(names(v))
    rs <- matrix(v,
                 nrow = length(tr),
                 byrow = TRUE)
    rownames(rs) <- tr
    rs
  }, SIMPLIFY = FALSE)
  
  vms.m.nrow <- vapply(vms.m, nrow, FUN.VALUE = numeric(1L))
  if(all(vms.m.nrow==0)){
    stop("Can not get any signals.")
  }
  tt <- do.call(rbind, vms.m[vms.m.nrow>0])
  vms.m <- colMeans(tt, na.rm = TRUE)
  TSSE <- loess.smooth(
    x=seq_along(vms.m), y=vms.m,
    family = "gaussian", evaluation=length(vms.m),
    ...)
  
  TSSE <- max(TSSE$y[!is.infinite(TSSE$y)], na.rm = TRUE)
  return(list(values=vms.m, TSSEscore=TSSE))
}

require("ATACseqQC") || stop("unable to load Package:ATACseqQC")
require("GenomicAlignments") || stop("unable to load Package:GenomicAlignments")
require("BSgenome") || stop("unable to load Package:BSgenome")
require("rtracklayer") || stop("unable to load Package:rtracklayer")
require("utils") || stop("unable to load Package:utils")
require("testthat") || stop("unable to load testthat")
test_check("ATACseqQC")

#' read in bam files
#'
#' wraper for readGAlignments/readGAlignmentsList to read in bam files.
#'
#' @param bamFile character(1). Bam file name.
#' @param which A \link[GenomicRanges:GRanges-class]{GRanges}, \link[IRanges:IntegerRangesList-class]{IntegerRangesList}, 
#' or any object that can be coerced to a RangesList, or missing object, 
#' from which a IRangesList instance will be constructed. 
#' See \link[Rsamtools:ScanBamParam-class]{ScanBamParam}.
#' @param tag A vector of characters indicates the tag names to be read.
#' See \link[Rsamtools:ScanBamParam-class]{ScanBamParam}.
#' @param what A character vector naming the fields to return. 
#' Fields are described on the \link{Rsamtools}[scanBam] help page.
#' @param flag An integer(2) vector used to filter reads based on their 
#' 'flag' entry. 
#' @param bigFile If the file take too much memory, set it to true to avoid read the reads into memory.
#' \link[Rsamtools:ScanBamParam-class]{scanBamFlag} helper function.
#' @param asMates logical(1). Paired ends or not
#' @param ... parameters used by \link[GenomicAlignments:readGAlignments]{readGAlignmentsList} 
#' or \link[GenomicAlignments]{readGAlignments}
#' @import GenomeInfoDb
#' @import S4Vectors
#' @importFrom GenomicAlignments readGAlignmentsList readGAlignments GAlignmentsList GAlignments
#' @importFrom Rsamtools scanBamFlag ScanBamParam scanBamHeader
#' @export
#' @return A GAlignmentsList object when asMates=TRUE,
#' otherwise A GAlignments object.
#' If bigFile is set to TRUE, no reads will be read into memory at this step and 
#' empty GAlignments/GAlignmentsList will be returned.
#' @author Jianhong Ou
#' @examples 
#' library(BSgenome.Hsapiens.UCSC.hg19)
#' which <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
#' bamfile <- system.file("extdata", "GL1.bam", 
#'                        package="ATACseqQC", mustWork=TRUE)
#' readBamFile(bamfile, which=which, asMates=TRUE)
readBamFile <- function(bamFile, which, tag=character(0),
                        what=c("qname", "flag", "mapq", "isize", 
                               "seq", "qual", "mrnm"),
                        flag=scanBamFlag(isSecondaryAlignment = FALSE,
                                         isUnmappedQuery=FALSE,
                                         isNotPassingQualityControls = FALSE,
                                         isSupplementaryAlignment = FALSE),
                        asMates=FALSE, bigFile=FALSE,
                        ...) {
  stopifnot(length(bamFile)==1)
  if(file.size(bamFile)>1e8 && !bigFile && interactive()){
    if(is.null(getOption('ATACseqQC.bigFile'))){
      bigFile <- readline("This is a big BAM file. Do you want to set bigFile=TRUE to save memory? (Y/n)? ")
      bigFile <- bigFile=="" || bigFile=="Y" || bigFile=="y"
      options(ATACseqQC.bigFile = bigFile)
    }
  }
  if(!bigFile){
    if(!missing(which)){
      which <- keepSeqlevels(which, as.character(unique(seqnames(which))))
      param <-
        ScanBamParam(what=what,
                     tag=tag,
                     which=which,
                     flag=flag)
    }else{
      param <-
        ScanBamParam(what=what,
                     tag=tag,
                     flag=flag)
    }
    if(asMates) {
      gal <- readGAlignmentsList(bamFile, ..., param=param)
    }else{
      gal <- readGAlignments(bamFile, ..., param=param)
    }
  }else{
    if(!missing(which)){
      which <- keepSeqlevels(which, as.character(unique(seqnames(which))))
    }else{
      which <- scanBamHeader(bamFile, what=c("targets"))
      which <- which[[1]]$targets
      if(length(which)<1) stop("No available targets in the given file")
      which <- GRanges(seqnames = names(which), IRanges(1, which))
    }
    if(any(width(which)>2^29)){
      warning("The input contain ranges greater than 536870912.",
              "The range filter will be removed.")
      args <- list(...)
      if(!"index" %in% names(args)){
        stop("index file is required for this bam file.",
             "Please provide the CSI or CRAI index file")
      }
      which <- GRanges()
    }
    param <-
      ScanBamParam(what=what,
                   tag=tag,
                   which=which,
                   flag=flag)
    if(asMates){
      gal <- GAlignmentsList()
    }else{
      gal <- GAlignments()
    }
    metadata(gal) <- list(file=bamFile, param=param, asMates=asMates, which=which, ...)
  }
  header <- scanBamHeader(bamFile, what="text")[[1]]$text
  header <- lapply(header, paste, collapse="\t")
  header <- paste(names(header), unlist(header), sep="\t")
  metadata(gal)$header <- header
  gal
}

checkMaxChrLength <- function(len){
  stopifnot(is.numeric(len))
  len[len>2^29] <- 2^29
  len
} 

renameMcol <- function(gal, tagOldName, tagNewName = "mpos"){
  cn <- colnames(mcols(gal))
  stopifnot('Can not find proper tag!'=tagOldName %in% cn)
  colnames(mcols(gal))[cn==tagOldName] <- tagNewName
  gal
}
#' @importFrom Rsamtools bamTag
checkMposTag <- function(meta){
  return(length(meta$mposTag)==1 && meta$mposTag %in% bamTag(meta$param))
}
readGAlignmentsFromMeta <- function(FUN, meta){
  meta <- meta[names(meta) %in% names(formals(FUN))]
  do.call(FUN, meta)
}
loadBamFile <- function(gal, which=NULL, minimal=FALSE){
  meta <- metadata(gal)
  header <- meta$header
  if(!all(c("file", "param") %in% names(meta))){
    stop("length of gal could not be 0.")
  }
  asMates <- meta$asMates
  if(length(asMates)==0) asMates <- FALSE
  meta$which <- which
  if(minimal){
    meta$param <- ScanBamParam(flag=meta$param@flag, what=("qname"))
  }
  if(asMates){
    gal1 <- readGAlignmentsFromMeta(readGAlignmentsList, meta)
  }else{
    if(checkMposTag(meta)){
      gal1 <- readGAlignmentsFromMeta(readGAlignments, meta)
      mcols(gal1)$MD <- NULL
      names(gal1) <- mcols(gal1)$qname
      gal1 <- gal1[order(names(gal1))]
      gal1 <- renameMcol(gal1, meta$mposTag)
    }else{
      gal1 <- readGAlignmentsFromMeta(readGAlignments, meta)
    }
  }
  if(length(header)) metadata(gal1) <- list(header=header)
  gal1
}

## ----echo=FALSE, results="hide", warning=FALSE, message=FALSE-----------------
suppressPackageStartupMessages({
  library(ATACseqQC)
  library(ChIPpeakAnno)
  library(BSgenome.Hsapiens.UCSC.hg19)
  library(TxDb.Hsapiens.UCSC.hg19.knownGene)
  library(phastCons100way.UCSC.hg19)
  library(MotifDb)
  library(GenomicAlignments)
})
knitr::opts_chunk$set(warning=FALSE, message=FALSE)

## ----eval=FALSE---------------------------------------------------------------
# library(BiocManager)
# BiocManager::install(c("ATACseqQC", "ChIPpeakAnno", "MotifDb", "GenomicAlignments",
#            "BSgenome.Hsapiens.UCSC.hg19", "TxDb.Hsapiens.UCSC.hg19.knownGene",
#            "phastCons100way.UCSC.hg19"))

## -----------------------------------------------------------------------------
## load the library
library(ATACseqQC)
## input the bamFile from the ATACseqQC package 
bamfile <- system.file("extdata", "GL1.bam", 
                        package="ATACseqQC", mustWork=TRUE)
bamfile.labels <- gsub(".bam", "", basename(bamfile))

## ----eval=FALSE---------------------------------------------------------------
# source(system.file("extdata", "IGVSnapshot.R", package = "ATACseqQC"))

## -----------------------------------------------------------------------------
#bamQC(bamfile, outPath=NULL)
estimateLibComplexity(readsDupFreq(bamfile))

## -----------------------------------------------------------------------------
## generate fragement size distribution
fragSize <- fragSizeDist(bamfile, bamfile.labels)

## -----------------------------------------------------------------------------
## bamfile tags to be read in
possibleTag <- list("integer"=c("AM", "AS", "CM", "CP", "FI", "H0", "H1", "H2", 
                                "HI", "IH", "MQ", "NH", "NM", "OP", "PQ", "SM",
                                "TC", "UQ"), 
                 "character"=c("BC", "BQ", "BZ", "CB", "CC", "CO", "CQ", "CR",
                               "CS", "CT", "CY", "E2", "FS", "LB", "MC", "MD",
                               "MI", "OA", "OC", "OQ", "OX", "PG", "PT", "PU",
                               "Q2", "QT", "QX", "R2", "RG", "RX", "SA", "TS",
                               "U2"))
library(Rsamtools)
bamTop100 <- scanBam(BamFile(bamfile, yieldSize = 100),
                     param = ScanBamParam(tag=unlist(possibleTag)))[[1]]$tag
tags <- names(bamTop100)[lengths(bamTop100)>0]
tags
## files will be output into outPath
outPath <- "splited"
dir.create(outPath)
## shift the coordinates of 5'ends of alignments in the bam file
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
## if you don't have an available TxDb, please refer
## GenomicFeatures::makeTxDbFromGFF to create one from gff3 or gtf file.
seqlev <- "chr1" ## subsample data for quick run
seqinformation <- seqinfo(TxDb.Hsapiens.UCSC.hg19.knownGene)
which <- as(seqinformation[seqlev], "GRanges")
gal <- readBamFile(bamfile, tag=tags, which=which, asMates=TRUE, bigFile=TRUE)
shiftedBamfile <- file.path(outPath, "shifted.bam")
gal1 <- shiftGAlignmentsList(gal, outbam=shiftedBamfile)

## -----------------------------------------------------------------------------
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
pt <- PTscore(gal1, txs)
plot(pt$log2meanCoverage, pt$PT_score, 
     xlab="log2 mean coverage",
     ylab="Promoter vs Transcript")

## -----------------------------------------------------------------------------
nfr <- NFRscore(gal1, txs)
plot(nfr$log2meanCoverage, nfr$NFR_score, 
     xlab="log2 mean coverage",
     ylab="Nucleosome Free Regions score",
     main="NFRscore for 200bp flanking TSSs",
     xlim=c(-10, 0), ylim=c(-5, 5))

## -----------------------------------------------------------------------------
tsse <- TSSEscore(gal1, txs)
tsse$TSSEscore
plot(100*(-9:10-.5), tsse$values, type="b", 
     xlab="distance to TSS",
     ylab="aggregate TSS score")

## -----------------------------------------------------------------------------
library(BSgenome.Hsapiens.UCSC.hg19)
library(phastCons100way.UCSC.hg19)
## run program for chromosome 1 only
txs <- txs[seqnames(txs) %in% "chr1"]
genome <- Hsapiens
## split the reads into NucleosomeFree, mononucleosome, 
## dinucleosome and trinucleosome.
## and save the binned alignments into bam files.
objs <- splitGAlignmentsByCut(gal1, txs=txs, genome=genome, outPath = outPath,
                              conservation=phastCons100way.UCSC.hg19)
## list the files generated by splitGAlignmentsByCut.
dir(outPath)

## ----eval=FALSE---------------------------------------------------------------
# objs <- splitBam(bamfile, tags=tags, outPath=outPath,
#                  txs=txs, genome=genome,
#                  conservation=phastCons100way.UCSC.hg19)

## ----eval=FALSE---------------------------------------------------------------
# ## split reads by fragment length
# ## NOT RUN IN THIS example
# objs <- splitGAlignmentsByCut(gal1, txs=txs, outPath = outPath)

## ----fig.height=4, fig.width=4------------------------------------------------
library(ChIPpeakAnno)
bamfiles <- file.path(outPath,
                     c("NucleosomeFree.bam",
                     "mononucleosome.bam",
                     "dinucleosome.bam",
                     "trinucleosome.bam"))
## Plot the cumulative percentage of tag allocation in nucleosome-free 
## and mononucleosome bam files.
cumulativePercentage(bamfiles[1:2], as(seqinformation["chr1"], "GRanges"))

## ----fig.height=8, fig.width=4------------------------------------------------
TSS <- promoters(txs, upstream=0, downstream=1)
TSS <- unique(TSS)
## estimate the library size for normalization
(librarySize <- estLibSize(bamfiles))
## calculate the signals around TSSs.
NTILE <- 101
dws <- ups <- 1010
sigs <- enrichedFragments(gal=objs[c("NucleosomeFree", 
                                     "mononucleosome",
                                     "dinucleosome",
                                     "trinucleosome")], 
                          TSS=TSS,
                          librarySize=librarySize,
                          seqlev=seqlev,
                          TSS.filter=0.5,
                          n.tile = NTILE,
                          upstream = ups,
                          downstream = dws)
## log2 transformed signals
sigs.log2 <- lapply(sigs, function(.ele) log2(.ele+1))
#plot heatmap
featureAlignedHeatmap(sigs.log2, reCenterPeaks(TSS, width=ups+dws),
                      zeroAt=.5, n.tile=NTILE)

## ----fig.show="hide"----------------------------------------------------------
## get signals normalized for nucleosome-free and nucleosome-bound regions.
out <- featureAlignedDistribution(sigs, 
                                  reCenterPeaks(TSS, width=ups+dws),
                                  zeroAt=.5, n.tile=NTILE, type="l", 
                                  ylab="Averaged coverage")

## -----------------------------------------------------------------------------
## rescale the nucleosome-free and nucleosome signals to 0~1
range01 <- function(x){(x-min(x))/(max(x)-min(x))}
out <- apply(out, 2, range01)
matplot(out, type="l", xaxt="n", 
        xlab="Position (bp)", 
        ylab="Fraction of signal")
axis(1, at=seq(0, 100, by=10)+1, 
     labels=c("-1K", seq(-800, 800, by=200), "1K"), las=2)
abline(v=seq(0, 100, by=10)+1, lty=2, col="gray")

## -----------------------------------------------------------------------------
## foot prints
library(MotifDb)
CTCF <- query(MotifDb, c("CTCF"))
CTCF <- as.list(CTCF)
print(CTCF[[1]], digits=2)
sigs <- factorFootprints(shiftedBamfile, pfm=CTCF[[1]], 
                         genome=genome, ## Don't have a genome? ask ?factorFootprints for help
                         min.score="90%", seqlev=seqlev,
                         upstream=100, downstream=100)

## ----fig.height=6, fig.width=6------------------------------------------------
featureAlignedHeatmap(sigs$signal, 
                      feature.gr=reCenterPeaks(sigs$bindingSites,
                                               width=200+width(sigs$bindingSites[1])), 
                      annoMcols="score",
                      sortBy="score",
                      n.tile=ncol(sigs$signal[[1]]))

sigs$spearman.correlation
sigs$Profile.segmentation

## -----------------------------------------------------------------------------
vp <- vPlot(shiftedBamfile, pfm=CTCF[[1]], 
            genome=genome, min.score="90%", seqlev=seqlev,
            upstream=200, downstream=200, 
            ylim=c(30, 250), bandwidth=c(2, 1))

distanceDyad(vp, pch=20, cex=.5)

## -----------------------------------------------------------------------------
path <- system.file("extdata", package="ATACseqQC", mustWork=TRUE)
bamfiles <- dir(path, "*.bam$", full.name=TRUE)
gals <- lapply(bamfiles, function(bamfile){
               readBamFile(bamFile=bamfile, tag=character(0), 
                          which=GRanges("chr1", IRanges(1, 1e6)), 
                          asMates=FALSE)
         })
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(GenomicAlignments)
plotCorrelation(GAlignmentsList(gals), txs, seqlev="chr1")

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Simulation pausing index
#' @description The polII pausing index is the ratio of the reads density at 
#' the 5' end of the gene to that in the gene body. This function will simulate
#' the pausing index by open chromatin coverage instead of PolII signaling.
#' The pausing index is a raio between aggregate distribution of reads in TSS
#' and that elongating gene bodys. The default PI = [average coverage of TSS
#' (+1 to +200bp) - average coverage of avoidance region (+21 to +60bp)] /
#' the average coverage of in transcripts (+401bp to 600bp).
#' @param obj an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}
#' @param txs GRanges of transcripts
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param nascentRegion,pausedRegion,avoidanceRegion,elongationRegion numeric(2)
#'  or integer(2).
#' The start and end position of the pre-initiation complex, paused complex, 
#' paused complex avoidance region and productive elongation.
#' @param pseudocount numeric(1) or integer(1). Pseudocount. Default is 1.
#' @importClassesFrom GenomicAlignments GAlignments
#' @importClassesFrom GenomicRanges GRanges
#' @importFrom GenomicRanges promoters coverage shift
#' @importFrom IRanges viewMeans Views
#' @export
#' @return A object of \link[GenomicRanges:GRanges-class]{GRanges} with pseudo
#' pausing index.
#' @author Jianhong Ou
#' @references https://doi.org/10.1098%2Frsob.210220; 
#' https://www.nature.com/articles/nmeth.2688/figures/3
#' @examples  
#' library(GenomicRanges)
#' bamfile <- system.file("extdata", "GL1.bam", 
#'                        package="ATACseqQC", mustWork=TRUE)
#' gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
#'                     which=GRanges("chr1", IRanges(1, 1e6)), 
#'                     asMates=FALSE)
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' ppi <- pseudoPausingIndex(gal1, txs)
pseudoPausingIndex <- function(obj, txs,
                      seqlev=intersect(seqlevels(obj), seqlevels(txs)),
                      nascentRegion=c(-200, -1),
                      pausedRegion=c(1, 200),
                      avoidanceRegion=c(21, 60),
                      elongationRegion=c(401, 600),
                      pseudocount=1L){
  stopifnot(is(obj, "GAlignments"))
  if(length(obj)==0){
    obj <- loadBamFile(obj, minimal=TRUE)
  }
  stopifnot(is(txs, "GRanges"))
  stopifnot(length(nascentRegion)==2)
  stopifnot(length(pausedRegion)==2)
  stopifnot(length(elongationRegion)==2)
  stopifnot(is.numeric(nascentRegion))
  stopifnot(is.numeric(pausedRegion))
  stopifnot(is.numeric(elongationRegion))
  obj <- as(obj, "GRanges")
  mcols(obj) <- NULL
  cvg <- coverage(obj)
  cvg <- cvg[sapply(cvg, mean)>0]
  cvg <- cvg[names(cvg) %in% seqlev]
  seqlev <- seqlev[seqlev %in% names(cvg)]
  cvg <- cvg[seqlev]
  if(pseudocount!=0) cvg <- cvg + pseudocount
  txs <- txs[seqnames(txs) %in% seqlev]
  txs <- txs[width(txs)>=max(elongationRegion)[1]]
  txs <- unique(txs)
  TSS <- promoters(txs, upstream = 0L, downstream = 1L)
  str_neg <- as.character(strand(TSS))=="-"
  nascentRegionGR <- pausedRegionGR <- elongationRegionGR <- TSS
  getRegion <- function(x, region){
    a <- min(region)[1]
    b <- max(region)[1]
    if(a>0) {
      w <- diff(region)+1
    }else{
      a <- a+1
      w <- diff(region)
    }
    x[!str_neg] <-
      shift(x[!str_neg], shift = a)
    width(x[!str_neg]) <- w
    start(x[str_neg]) <- start(x[str_neg]) - 
      max(region)[1]
    end(x[str_neg]) <- end(x[str_neg]) - 
      a
    x
  }
  nascentRegionGR <- getRegion(TSS, nascentRegion)
  pausedRegionGR <- getRegion(TSS, pausedRegion)
  avoidanceRegionGR <- getRegion(TSS, avoidanceRegion)
  elongationRegionGR <- getRegion(TSS, elongationRegion)
  getCvg <- function(x){
    x <- split(x, seqnames(x))
    x <- x[names(cvg)]
    vws <- Views(cvg, x)
    vms <- viewMeans(vws)
    vws <- mapply(vws, vms, FUN=function(vw, vm){
      ir <- ranges(vw)
      mcols(ir)$score <- vm
      ir
    }, SIMPLIFY = FALSE)
    gr <- unlist(x)
    gr$score <- mcols(unlist(IRangesList(vws)))$score
    gr
  }
  nascentRegionVWS <- getCvg(nascentRegionGR)
  pausedRegionVWS <- getCvg(pausedRegionGR)
  avoidanceRegionVWS <- getCvg(avoidanceRegionGR)
  elongationRegionVWS <- getCvg(elongationRegionGR)
  ppi <- getCvg(txs)
  ppi$score <- NULL
  ppi$nascentRegion <- nascentRegionVWS$score
  ppi$pausedRegion <- pausedRegionVWS$score
  ppi$avoidanceRegion <- avoidanceRegionVWS$score
  ppi$elongationRegion <- elongationRegionVWS$score
  ppi$pseudoPI <- (pausedRegionVWS$score-avoidanceRegionVWS$score+pseudocount)/
    (elongationRegionVWS$score+pseudocount)
  return(ppi)
}

#' @title enrichment for nucleosome-free fragments and nucleosome signals
#' @description Get the enrichment signals for nucleosome-free fagments and
#'              nucleosomes.
#' @param bamfiles A vector of characters indicates the file names of bams.
#' @param index The names of the index file of the 'BAM' file being processed;
#'        This is given without the '.bai' extension.
#' @param gal A GAlignmentsList object or a list of GAlignmentPairs.
#'        If bamfiles is missing, gal is required.
#' @param TSS an object of \link[GenomicRanges:GRanges-class]{GRanges} indicates
#' the transcript start sites. All the width of TSS should equal to 1.
#' Otherwise, TSS will be reset to the center of input TSS.
#' @param librarySize A vector of numeric indicates the library size. Output of
#'        \link[ChIPpeakAnno]{estLibSize}
#' @param upstream,downstream numeric(1) or integer(1).
#'        Upstream and downstream size from each TSS.
#' @param n.tile numeric(1) or integer(1). The number of tiles to generate
#'        for each element of TSS.
#' @param normal.method character(1). Normalization methods,
#'        could be "none" or "quantile".
#'        See \link[limma]{normalizeBetweenArrays}.
#' @param adjustFragmentLength numeric(1) or integer(1).
#'        The size of fragment to be adjusted to.
#'        Default is set to half of the nucleosome size (80)
#' @param TSS.filter numeric(1). The filter for signal strength of each TSS.
#'        Default 0.5 indicates the average signal strength for the TSS
#'        from upstream to downstream bins should be greater than 0.5.
#' @param seqlev A vector of character indicates the sequence names to be
#'        considered.
#' @return A list of matrixes. In each matrix, each row record the signals for
#' corresponding feature.
#' @author Jianhong Ou
#' @export
#' @import GenomeInfoDb
#' @import GenomicRanges
#' @importFrom ChIPpeakAnno featureAlignedExtendSignal reCenterPeaks
#' @importFrom limma normalizeBetweenArrays
#' @importFrom Rsamtools countBam ScanBamParam
#' @examples
#'
#' bamfiles <- system.file("extdata", "splited",
#'                        c("NucleosomeFree.bam",
#'                          "mononucleosome.bam",
#'                          "dinucleosome.bam",
#'                          "trinucleosome.bam"), package="ATACseqQC")
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' TSS <- promoters(txs, upstream=0, downstream=1)
#' library(ChIPpeakAnno)
#' librarySize <- estLibSize(bamfiles)
#' sigs <- enrichedFragments(bamfiles, TSS=TSS, librarySize=librarySize,
#'                           seqlev="chr1", TSS.filter=0)
#' sigs.log2 <- lapply(sigs, function(.ele) log2(.ele+1))
#' featureAlignedHeatmap(sigs.log2, reCenterPeaks(TSS, width=2020),
#'                       zeroAt=.5, n.tile=101, upper.extreme=2)
#' featureAlignedDistribution(sigs, reCenterPeaks(TSS, width=2020),
#'                            zeroAt=.5, n.tile=101, type="l")
#'
enrichedFragments <- function(bamfiles, index=bamfiles, gal, TSS, librarySize,
                              upstream = 1010L,
                              downstream = 1010L,
                              n.tile = 101L,
                              normal.method="quantile",
                              adjustFragmentLength=80L,
                              TSS.filter=0.5,
                              seqlev = paste0("chr", c(1:22, "X", "Y"))){
  if(missing(bamfiles)){
    if(missing(gal)){
      stop("gal is required if missing bamfiles")
    }else{
      if(!is(gal, "GAlignmentsList")){
        galInput <- sapply(gal, function(.ele){
          inherits(.ele, c("GAlignments", "GAlignmentPairs"))
        })
        if(any(!galInput)){
          stop("gal must be a GAlignmentsList object or a list of GAlignmentPairs.")
        }
      }
    }
    galInput <- TRUE
    stopifnot(length(gal)==4)
  }else{
    stopifnot(length(bamfiles)==4)
    stopifnot(length(bamfiles)==length(index))
    galInput <- FALSE
  }
  stopifnot(is(TSS, "GRanges"))
  stopifnot(is.numeric(librarySize))
  librarySize[librarySize==0] <- 1
  #fragmentLength <- estFragmentLength(bamfiles)
  fragmentLength <- 200 #here we suppose all the fragment of nucleosome is 200.
  TSS <- TSS[seqnames(TSS) %in% seqlev]
  seqlev <- intersect(seqlev, seqlevels(TSS))
  if(length(seqlev)==0){
    stop("No intersection between seqlev and seqlevels of TSS")
  }
  seqlevels(TSS) <- seqlev
  seqinfo(TSS) <- Seqinfo(seqlev, seqlengths = seqlengths(TSS))
  TSS <- unique(TSS)
  if(TSS.filter>0){
    ## filter the TSS before count signals
    TSS.expand <- reCenterPeaks(TSS, width=upstream+downstream+1)
    if(galInput){
      cnt <- lapply(gal, function(.ele){
        countOverlaps(query=TSS.expand, 
                      subject=granges(.ele), 
                      ignore.strand=TRUE)
        })
      cnt <- do.call(cbind, cnt)
    }else{
      cnt <- lapply(bamfiles, countBam, param=ScanBamParam(which=TSS.expand))
      cnt <- do.call(cbind, lapply(cnt, function(.ele) .ele$records))
    }
    cnt <- rowMeans(cnt)>0
    TSS <- TSS[cnt]
  }
  ## Dinucleosome reads will be split into two reads,
  ## and trinucleosome reads will be split into three reads.
  if(galInput){
    sig.pe <-
      featureAlignedExtendSignal(gal = gal,
                                 feature.gr = TSS,
                                 upstream = upstream,
                                 downstream = downstream,
                                 n.tile = n.tile,
                                 fragmentLength = fragmentLength,
                                 librarySize = librarySize,
                                 adjustFragmentLength=adjustFragmentLength,
                                 pe="PE")
    sig.se <-
      featureAlignedExtendSignal(gal = gal,
                                 feature.gr = TSS,
                                 upstream = upstream,
                                 downstream = downstream,
                                 n.tile=n.tile,
                                 fragmentLength = fragmentLength,
                                 librarySize = librarySize,
                                 adjustFragmentLength=adjustFragmentLength,
                                 pe="SE")
  }else{
    sig.pe <-
      featureAlignedExtendSignal(bamfiles,
                                 index = index,
                                 feature.gr = TSS,
                                 upstream = upstream,
                                 downstream = downstream,
                                 n.tile = n.tile,
                                 fragmentLength = fragmentLength,
                                 librarySize = librarySize,
                                 adjustFragmentLength=adjustFragmentLength,
                                 pe="PE")
    sig.se <-
      featureAlignedExtendSignal(bamfiles,
                                 index = index,
                                 feature.gr = TSS,
                                 upstream = upstream,
                                 downstream = downstream,
                                 n.tile=n.tile,
                                 fragmentLength = fragmentLength,
                                 librarySize = librarySize,
                                 adjustFragmentLength=adjustFragmentLength,
                                 pe="SE")
  }
  sig.pe <- lapply(sig.pe, function(.ele){
    .ele[is.na(.ele)] <- 0
    .ele}) ## in case of NA
  sig.se <- lapply(sig.se, function(.ele){
    .ele[is.na(.ele)] <- 0
    .ele}) ## in case of NA
  sig <- sig.pe
  sig[[3]] <- sig.se[[3]]
  sig[[4]] <- sig.pe[[4]] + sig.se[[4]]
  sig[[2]] <- Reduce(`+`, sig[-1])
  sig <- sig[1:2]
  if(normal.method=="none"){
    return(sig)
  }
  ## normalization by mean of top bins values
  bins <- ceiling(fragmentLength/floor(upstream + downstream)/n.tile)
  bins <- 2*bins+1
  sig.rowMeans <- lapply(sig, function(.ele)
    apply(.ele, 1, function(.e) mean(sort(.e, decreasing = TRUE)[1:bins])))
  sig.rowMeans <- do.call(cbind, sig.rowMeans) + 1
  sig.adj.rowMeans <- normalizeBetweenArrays(sig.rowMeans,
                                             method = normal.method)
  sig.factors <- sig.adj.rowMeans / sig.rowMeans
  sig.factors <- as.list(as.data.frame(sig.factors))
  sig.1 <- mapply(function(a, b){
    a * b
  }, sig, sig.factors, SIMPLIFY = FALSE)
  sig.1[[2]] <- sig.1[[2]] - sig.1[[1]]
  sig.1[[2]][sig.1[[2]]<0] <- 0
  sig.rowMeans <- rowMeans(sig.1[[2]])
  sig.1 <- lapply(sig.1, function(.ele) .ele[sig.rowMeans>TSS.filter, ])
  sig.1
}

#' Nucleosome Free Regions (NFR) score
#' @description NFR score is a raio between cut signal adjacent to TSS and that flanking 
#' the corresponding TSS. Each TSS window of 400 bp is first seperated into 3 sub-regions: 
#' the most upstream 150 bp (n1), the most downstream of 150 bp (n2), and the middle 100 bp (nf). 
#' Then the number of fragments with 5' ends overlapping each region are calculated for each TSS.
#' The NFR score for each TSS is calculated as NFR-score = log2(nf) - log2((n1+n2)/2). 
#' A plot can be generate with the NFR scores as Y-axis and the average signals of 400 bp window as X-axis,
#' very like a MA plot for gene expression data. 
#' @param obj an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}
#' @param txs GRanges of transcripts
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param nucleosomeSize numeric(1) or integer(1). Default is 150
#' @param nucleosomeFreeSize numeric(1) or integer(1). Default is 100
#' @importClassesFrom GenomicAlignments GAlignments
#' @importClassesFrom GenomicRanges GRanges
#' @importFrom GenomicRanges promoters coverage shift
#' @importFrom IRanges viewMeans Views
#' @export
#' @return A object of \link[GenomicRanges:GRanges-class]{GRanges} with NFR scores
#' @author Jianhong Ou
#' @examples  
#' library(GenomicRanges)
#' bamfile <- system.file("extdata", "GL1.bam", 
#'                        package="ATACseqQC", mustWork=TRUE)
#' gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
#'                     which=GRanges("chr1", IRanges(1, 1e6)), 
#'                     asMates=FALSE)
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' nfr <- NFRscore(gal1, txs)
NFRscore <- function(obj, txs,
                     seqlev=intersect(seqlevels(obj), seqlevels(txs)),
                     nucleosomeSize=150, nucleosomeFreeSize=100){
  stopifnot(is(obj, "GAlignments"))
  if(length(obj)==0){
    obj <- loadBamFile(obj, minimal=TRUE)
  }
  stopifnot(is(txs, "GRanges"))
  obj <- as(obj, "GRanges")
  mcols(obj) <- NULL
  obj <- promoters(obj, upstream = 0, downstream = 1)
  cvg <- coverage(obj)
  cvg <- cvg[sapply(cvg, mean)>0]
  cvg <- cvg[names(cvg) %in% seqlev]
  seqlev <- seqlev[seqlev %in% names(cvg)]
  cvg <- cvg[seqlev]
  txs <- txs[seqnames(txs) %in% seqlev]
  txs <- unique(txs)
  sel <- promoters(txs, upstream = nucleosomeSize + floor(nucleosomeFreeSize/2),
                      downstream = nucleosomeSize + ceiling(nucleosomeFreeSize/2))
  
  n1.gr <- promoters(sel, upstream = 0, downstream = nucleosomeSize)
  n2.gr <- shift(n1.gr, shift = nucleosomeSize + nucleosomeFreeSize)
  n2.gr[strand(n2.gr)=="-"] <- shift(n1.gr[strand(n2.gr)=="-"], 
                                     shift = -1 * (nucleosomeSize + nucleosomeFreeSize))
  nf.gr <- shift(n1.gr, shift = nucleosomeSize)
  width(nf.gr) <- nucleosomeFreeSize
  nf.gr[strand(nf.gr)=="-"] <- shift(n1.gr[strand(nf.gr)=="-"], shift = -1 * nucleosomeSize)
  start(nf.gr[strand(nf.gr)=="-"]) <- end(nf.gr[strand(nf.gr)=="-"]) - nucleosomeFreeSize + 1
  
  n1.gr$source <- "n1"
  n2.gr$source <- "n2"
  nf.gr$source <- "nf"
  n1.gr$oid <- seq_along(n1.gr)
  n2.gr$oid <- seq_along(n2.gr)
  nf.gr$oid <- seq_along(nf.gr)
  
  sel.gr <- c(n1.gr, nf.gr, n2.gr)
  sel.gr <- sel.gr[order(sel.gr$oid)]
  
  sel.gr <- split(sel.gr, seqnames(sel.gr))
  seqlev <- seqlev[seqlev %in% names(sel.gr)]
  sel.gr <- sel.gr[seqlev]
  cvg <- cvg[seqlev]
  vws <- Views(cvg, sel.gr)
  vms <- viewMeans(vws)
  sel.gr <- unlist(sel.gr)
  sel.gr$score <- unlist(vms)
  n1 <- sel.gr[sel.gr$source %in% "n1"]
  n2 <- sel.gr[sel.gr$source %in% "n2"]
  nf <- sel.gr[sel.gr$source %in% "nf"]
  stopifnot(identical(n1$oid, n2$oid))
  stopifnot(identical(n1$oid, nf$oid))
  sel <- sel[n1$oid]
  sel$n1 <- n1$score
  sel$nf <- nf$score
  sel$n2 <- n2$score
  smallNumber <- max(c(1e-6, min(nf$score, na.rm=TRUE), 
                       min(n1$score, na.rm=TRUE), min(n2$score, na.rm=TRUE)), na.rm = TRUE)
  sel$log2meanCoverage <- log2((3 * (n1$score + n2$score) + 2 * nf$score)/8 + smallNumber)
  sel$NFR_score <- log2(nf$score + smallNumber) + 1 - log2(n1$score + n2$score + smallNumber)
  sel <- sel[order(sel$NFR_score, decreasing = TRUE)]
  return(sel)
}

#' Library complexity estimation
#' @description Estimating the library complexity.
#' @param histFile A two-column matrix of integers. The 1st column is the frequency 
#' j = 1,2,3,.... The 2nd column is the number of genomic regions with the same 
#' fequency (j) of duplication. This file should be sorted by the first column 
#' in ascending order. For example, one row of a histogram file:
#' 10    20
#' means there are 10 genomic regions, each of which is covered by 20 identical 
#' fragments at a given sequencing depth of a sequencing library.
#' @param times An positive integer representing the minimum required number of 
#' successful estimation. Default is 100.
#' @param interpolate.sample.sizes A numeric vector with values between (0, 1].
#' @param extrapolate.sample.sizes A numeric vector with values greater than 1.
#' @importFrom preseqR ds.rSAC.bootstrap
#' @export
#' @author Haibo Liu, Feng Yan
#' @return invisible estimates, a data frame of 3 columns: relative sequence depth, 
#' number of distinct fragments, number of putative sequenced reads.
#' @seealso \link{readsDupFreq}
#' @examples 
#' library(preseqR)
#' data(FisherButterfly)
#' estimateLibComplexity(histFile=FisherButterfly, times=100)

estimateLibComplexity <- function(histFile, times=100, 
                                  interpolate.sample.sizes=seq(0.1, 1, by=0.1),
                                  extrapolate.sample.sizes=seq(5, 20, by=5)){
    total <- histFile[,1] %*% histFile[,2]  ## added
    suppressWarnings({result = ds.rSAC.bootstrap(histFile, r=1, times=times)})
    sequences <- c(interpolate.sample.sizes, extrapolate.sample.sizes)
    estimates <- data.frame(relative.size=sequences, values=rep(NA, length(sequences)))
    for ( i in seq_along(sequences))
    {
        estimates$values[i] <- result$f(sequences[i])
    }
    suppressWarnings(estimates$reads <- estimates$relative.size * total) ## added
    plot(x=estimates$reads/10^6, y=estimates$values/10^6,  
         type="o", xlab =expression(Putative~sequenced~fragments~x~10^6), 
         ylab=expression(Distinct~fragments~x~10^6),
         main="Estimation of ATAC-seq\nlibrary complexity")
    return(invisible(estimates))  
}

#' plot Correlations of multiple samples
#' @description plot PCA or heatmap for multiple bamfiles. The correlation is 
#' calculated by the counts in promoter regions.
#' @param objs an object of \link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList}
#' @param txs GRanges of transcripts
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param upstream numeric(1) or integer(1). Start position of promoter. Default is 2000
#' @param downstream numeric(1) or integer(1). End position of promoter. Default is 500
#' @param type Figure type, heatmap or PCA plot.
#' @param ... parameters could be passed to downstream functions such as plot for pca or heatmap for heatmap.
#' @importClassesFrom GenomicAlignments GAlignments GAlignmentsList
#' @importClassesFrom GenomicRanges GRanges
#' @importFrom GenomicAlignments GAlignmentsList
#' @importFrom GenomicRanges promoters coverage shift
#' @importFrom IRanges viewMeans Views
#' @importFrom stats prcomp heatmap
#' @importFrom graphics legend
#' @export
#' @return A invisible object of \link[GenomicRanges:GRanges-class]{GRanges} with counts
#' @author Jianhong Ou
#' @details The correlation will be calculated by the correlation of insertion
#' sites within promoter regions. Even the sequencing is paired-end, 
#' please treat it as single ends.
#' @examples
#' library(GenomicRanges)
#' library(GenomicAlignments)
#' path <- system.file("extdata", package="ATACseqQC", mustWork=TRUE)
#' bamfiles <- dir(path, "*.bam$", full.name=TRUE)
#' gals <- lapply(bamfiles, function(bamfile){
#'                readBamFile(bamFile=bamfile, tag=character(0), 
#'                            which=GRanges("chr1", IRanges(1, 1e6)), 
#'                            asMates=FALSE)
#'         })
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' plotCorrelation(GAlignmentsList(gals), txs, seqlev="chr1")
plotCorrelation <- function(objs, txs,
                            seqlev=intersect(seqlevels(objs[[1]]), seqlevels(txs)),
                            upstream=2000, downstream=500,
                            type=c("heatmap", "PCA"), ...){
  stopifnot(is(objs, "GAlignmentsList"))
  stopifnot(length(objs)>1)
  stopifnot(is(txs, "GRanges"))
  if(length(names(objs))<1){
    names(objs) <- paste0("input", seq_along(objs))
  }
  type <- match.arg(type)
  objs <- lapply(objs, function(obj) {
    obj <- as(obj, "GRanges")
    mcols(obj) <- NULL
    obj <- promoters(obj, upstream = 0, downstream = 1)
    })
  cvgs <- lapply(objs, coverage)
  cvgs <- lapply(cvgs, function(cvg) cvg[names(cvg) %in% seqlev])
  txs <- txs[seqnames(txs) %in% seqlev]
  txs <- unique(txs)
  sel.gr <- promoters(txs, upstream = upstream, downstream = downstream)
  sel.gr <- split(sel.gr, seqnames(sel.gr))
  seqlev <- seqlev[seqlev %in% names(sel.gr)]
  cvgs <- lapply(cvgs, function(cvg) cvg[seqlev])
  sel.gr <- sel.gr[seqlev]
  vms <- lapply(cvgs, function(cvg){
    unlist(viewMeans(Views(cvg, sel.gr)))
  })
  sel.gr <- unlist(sel.gr)
  for(i in seq_along(objs)){
    mcols(sel.gr)[, names(objs)[i]] <- vms[[i]]
  }
  smallNumber <- max(c(1e-6, min(unlist(vms))))
  vms.log2 <- lapply(vms, function(.ele) log2(.ele + smallNumber))
  vms.log2 <- do.call(cbind, vms.log2)
  switch(type,
         PCA={
           vms.pca <- prcomp(vms.log2)
           dots <- list(...)
           if("col" %in% names(dots)){
             col <- dots$col
             plot(vms.pca$rotation, ...)
           }else{
             col <- seq.int(ncol(vms.log2))
             plot(vms.pca$rotation, col=col, ...)
           }
           legend("topright", legend = colnames(vms.log2), box.lwd = NA, col = col, bg=NA, pch=1)
         },
         heatmap={
           vms.cor <- cor(vms.log2, method = "spearman")
           if(all(vms.cor==1)){
             message("all samples are identical in given regions.")
           }else{
             heatmap(vms.cor, scale = "none", ...)
           }
         })
  return(invisible(sel.gr))
}

#' V-plot
#' @description Aggregate ATAC-seq Fragment Midpoint vs. Length for a given motif generated
#'              over binding sites within the genome.
#' @param bamfiles A vector of characters indicates the file names of bams.  
#' All the bamfiles will be pulled together.
#' @param index The names of the index file of the 'BAM' file being processed;
#'        This is given without the '.bai' extension.
#' @param pfm A Position frequency Matrix represented as a numeric matrix
#'        with row names A, C, G and T.
#' @param genome An object of \link[BSgenome:BSgenome-class]{BSgenome}.
#' @param min.score The minimum score for counting a match.
#'                  Can be given as a character string containing a
#'                  percentage (e.g. "95%") of the highest possible
#'                  score or as a single number.
#'                  See \link[Biostrings]{matchPWM}.
#' @param bindingSites A object of \link[GenomicRanges:GRanges-class]{GRanges} indicates
#' candidate binding sites (eg. the output of fimo).
#' @param seqlev A vector of characters indicates the sequence levels.
#' @param upstream,downstream numeric(1) or integer(1).
#'        Upstream and downstream of the binding region for
#'        aggregate ATAC-seq footprint.
#' @param maxSiteNum numeric(1). Maximal number of predicted binding sites.
#'        if predicted binding sites is more than this number, top maxSiteNum binding
#'        sites will be used.
#' @param draw Plot or not. Default TRUE.
#' @param ... parameters could be used by \link[graphics]{smoothScatter}
#' @importFrom ChIPpeakAnno reCenterPeaks
#' @importFrom GenomicAlignments readGAlignmentPairs
#' @importFrom Biostrings matchPWM maxScore
#' @importFrom Rsamtools ScanBamParam
#' @importFrom graphics smoothScatter
#' @importFrom KernSmooth bkde2D
#' @import GenomeInfoDb
#' @import GenomicRanges
#' @import IRanges
#' @import S4Vectors
#' @return an invisible data.frame for plot.
#' @export
#' @references Jorja G. Henikoff, Jason A. Belsky, Kristina Krassovsky, 
#' David M. MacAlpine, and Steven Henikoff.
#' Epigenome characterization at single base-pair resolution.
#' PNAS 2011 108 (45) 18318-18323
#' @author Jianhong Ou
#' @examples
#'
#'bamfile <- system.file("extdata", "GL1.bam",
#'                        package="ATACseqQC")
#'library(MotifDb)
#'CTCF <- query(MotifDb, c("CTCF"))
#'CTCF <- as.list(CTCF)
#'library(BSgenome.Hsapiens.UCSC.hg19)
#'vPlot(bamfile, pfm=CTCF[[1]],
#'      genome=Hsapiens,
#'      min.score="95%", seqlev="chr1",
#'      ylim=c(30, 250))
#'
vPlot <- function(bamfiles, index=bamfiles, pfm, genome, 
                  min.score="95%", bindingSites,
                  seqlev=paste0("chr", c(1:22, "X", "Y")),
                  upstream=200, downstream=200,
                  maxSiteNum=1e6, draw=TRUE, ...){
  if(!missing(genome)) stopifnot(is(genome, "BSgenome"))
  stopifnot(upstream>10 && downstream>10)
  stopifnot(is.numeric(maxSiteNum))
  maxSiteNum <- ceiling(maxSiteNum[1])
  stopifnot(maxSiteNum>1)
  if(missing(bindingSites)){
    stopifnot(all(round(colSums(pfm), digits=4)==1))
    pwm <- motifStack::pfm2pwm(pfm)
    maxS <- maxScore(pwm)
    if(!is.numeric(min.score)){
      if(!is.character(min.score)){
        stop("'min.score' must be a single number or string")
      }else{
        nc <- nchar(min.score)
        if (substr(min.score, nc, nc) == "%"){
          min.score <- substr(min.score, 1L, nc - 1L)
        }else{
          stop("'min.score' can be given as a character string containing a percentage",
               "(e.g. '85%') of the highest possible score")
        }
        min.score <- maxS * as.double(min.score)/100
      }
    }else{
      min.score <- min.score[1]
    }
    predefined.score <- maxS * as.double(0.85)
    suppressWarnings({
      mt <- matchPWM(pwm, genome, min.score = min(predefined.score, min.score), 
                     with.score=TRUE,
                     exclude=names(genome)[!names(genome) %in% seqlev])
    })
    if (min.score <= predefined.score){
      mt$userdefined <- TRUE
    } else {
      mt$userdefined <- FALSE
      mt$userdefined[mt$score >= min.score] <- TRUE
    }
    if(length(mt)>maxSiteNum){## subsample
      mt$oid <- seq_along(mt)
      mt <- mt[order(mt$score, decreasing = TRUE)]
      mt <- mt[seq.int(maxSiteNum)]
      mt <- mt[order(mt$oid)]
      mt$oid <- NULL
    }
    subsampleNum <- min(10000, maxSiteNum)
    if(length(mt)>subsampleNum && sum(mt$userdefined)<subsampleNum){## subsample 
      set.seed(seed = 1)
      mt.keep <- seq_along(mt)[!mt$userdefined]
      n <- subsampleNum-sum(mt$userdefined)
      if(length(mt.keep)>n){
        mt.keep <- mt.keep[order(mt[mt.keep]$score, decreasing = TRUE)]
        mt.keep <- mt.keep[seq.int(n)]
        mt.keep <- sort(mt.keep)
        mt.keep <- seq_along(mt) %in% mt.keep
        mt <- mt[mt$userdefined | mt.keep]
      }
    }
    wid <- ncol(pfm)
  }else{
    stopifnot(is(bindingSites, "GRanges"))
    stopifnot(all(!is.na(seqlengths(bindingSites))))
    stopifnot(length(bindingSites)>1)
    stopifnot(length(bindingSites$score)==length(bindingSites))
    mt <- bindingSites
    mt$userdefined <- TRUE
    wid <- mean(width(mt))
  }
  if(sum(mt$userdefined)<2){
    stop("less than 2 binding sites by input min.score")
  }
  #mt <- mt[seqnames(mt) %in% seqlev]
  seqlevels(mt) <- seqlev
  seqinfo(mt) <- Seqinfo(seqlev, seqlengths = seqlengths(mt))
  ## read in bam file with input seqlev specified by users
  which <- as(seqinfo(mt), "GRanges")
  bamIn <- mapply(function(.b, .i) {
    seqlevelsStyle(which) <- checkBamSeqStyle(.b, .i)[1]
    param <- ScanBamParam(which=which, 
                          flag = scanBamFlag(isProperPair=TRUE, 
                                             isSecondaryAlignment=FALSE, 
                                             isNotPassingQualityControls=FALSE, 
                                             isDuplicate=FALSE))
    readGAlignmentPairs(.b, .i, param = param)
    }, bamfiles, index, SIMPLIFY = FALSE)
  bamIn <- lapply(bamIn, as, Class = "GRanges")
  if(!is(bamIn, "GRangesList")) bamIn <- GRangesList(bamIn)
  bamIn <- unlist(bamIn, use.names = FALSE)
  if(length(bamIn)<1){
    stop("No paired reads. Please double check the inputs.")
  }
  seqlevelsStyle(bamIn) <- seqlevelsStyle(mt)[1]
  mt.ext <- promoters(reCenterPeaks(mt, width=1),
                      upstream=upstream+floor(wid/2),
                      downstream=downstream+ceiling(wid/2))
  
  bamIn$w <- width(bamIn)
  bamIn <- reCenterPeaks(bamIn, width = 1)
  
  ol <- findOverlaps(bamIn, mt.ext)
  bam.query <- bamIn[queryHits(ol)]
  mt.ext.subject <- mt.ext[subjectHits(ol)]
  rel <- getRelationship(bam.query, mt.ext.subject)
  rel$FragmentLength <- bam.query$w
  rel$distanceToBindingSite <- rel$distanceToStart - upstream - floor(wid/2)
  rel <- rel[order(rel$distanceToStart, rel$FragmentLength), c("distanceToBindingSite", "FragmentLength")]
  if(draw) smoothScatter(rel, ...)
  return(invisible(rel))
}



getRelationship <- function(queryHits, subjectHits){
  if(!inherits(queryHits, "GRanges")) 
    stop("queryHits must be an object of GRanges")
  if(!inherits(subjectHits, "GRanges")) 
    stop("subjectHits must be an object of GRanges")
  strand <- strand(subjectHits)=="-"
  FeatureStart <- as.numeric(ifelse(strand, 
                                    end(subjectHits), 
                                    start(subjectHits)))
  FeatureEnd <- as.numeric(ifelse(strand, 
                                  start(subjectHits), 
                                  end(subjectHits)))
  PeakStart <- as.numeric(ifelse(strand, end(queryHits), 
                                 start(queryHits)))
  PeakEnd <- as.numeric(ifelse(strand, start(queryHits), end(queryHits)))
  ss <- PeakStart - FeatureStart
  ee <- PeakEnd - FeatureEnd
  se <- PeakStart - FeatureEnd
  es <- PeakEnd - FeatureStart
  shortestDistance <- apply(cbind(ss, ee, se, es), 1,
                            function(.ele) min(abs(.ele)))
  shortestDistanceToStart <- apply(cbind(ss, es), 1, 
                                   function(.ele) min(abs(.ele)))
  data.frame(shortestDistance=shortestDistance, 
             ss=ss,
             distanceToStart=shortestDistanceToStart)
}

#' export list of GAlignments into bam files
#' @description wraper for \link[BiocIO:export]{export} to export list of 
#' GAlignment into bam files.
#' @param objs A list of \link[GenomicAlignments:GAlignments-class]{GAlignments}.
#' @param outPath character(1). Output file path.
#' @return status of export.
#' @export
#' @importFrom Rsamtools asBam
#' @author Jianhong Ou
#' @examples 
#' library(GenomicAlignments)
#' gal1 <- GAlignments(seqnames=Rle("chr1"), pos=1L, cigar="10M",
#'                     strand=Rle(strand(c("+"))), names="a", score=1)
#' galist <- GAlignmentsList(a=gal1)
#' writeListOfGAlignments(galist)

writeListOfGAlignments <- function(objs, outPath="."){
    stopifnot(inherits(objs, c("list", "GAlignmentsList")))
    null <- sapply(objs, function(.ele){
        if(!is(.ele, "GAlignments")){
            stop("All elements in objs must be GAlignments.")
        }
    })
    if(is.null(outPath)){
        stop("invalid outPath.")
    }
    stopifnot(length(outPath)==1)
    if(!file.exists(outPath)){
        dir.create(outPath, showWarnings = FALSE, recursive = TRUE)
    }
    mapply(function(data, n){
        if(length(data)>0){
          try({
             exportBamFile(data, file.path(outPath, paste0(n, ".bam")))
          })
        }else{
          meta <- metadata(data)
          if("file" %in% names(meta)){
            file.copy(from = meta$file, to = file.path(outPath, paste0(n, ".bam")))
            file.copy(from = paste0(meta$file, ".bai"), 
                      to = file.path(outPath, paste0(n, ".bam.bai")))
          }
        }
    }, objs, names(objs))
}

possibleTag <- 
    list("integer"=c("AM", "AS", "CM", "CP", "FI", "H0", "H1", "H2", 
                     "HI", "IH", "MQ", "NH", "NM", "OP", "PQ", "SM",
                     "TC", "UQ"), 
         "character"=c("BC", "BQ", "BZ", "CB", "CC", "CO", "CQ", "CR",
                       "CS", "CT", "CY", "E2", "FS", "LB", "MC", "MD",
                       "MI", "OA", "OC", "OQ", "OX", "PG", "PT", "PU",
                       "Q2", "QT", "QX", "R2", "RG", "RX", "SA", "TS",
                       "U2"),
         "Metadata"=c("RG", "LB", "PG", "PU", "CO"))
fillColumn <- function(x, filler) {
    if (is.null(x))
        filler
    else if (anyNA(x))
        ifelse(is.na(x), filler, x)
    else x
}
formatInt <- function(x){# handle format 1e5
    sub('^\\s', '', formatC(x, format = 'd'))
}

exportBamFile <- function(object, con){
    stopifnot(is(object, "GAlignments"))
    sam_path <- sub("bam$", "sam", con, ignore.case = TRUE)
    if(sam_path==con){
        sam_path <- paste0(con, ".sam")
    }
    sam_con <- file(sam_path, "w")
    on.exit(close(sam_con))
    si <- seqinfo(object)
    has_info <-
        seqlevels(si)[!is.na(seqlevels(si)) & !is.na(seqlengths(si))]
    si <- si[has_info]
    if (length(si)) {
        header <- paste0("@SQ",
                         "\tSN:", seqlevels(si),
                         "\tLN:", seqlengths(si))
        has_genome <- !is.na(genome(si))
        header[has_genome] <-  paste0(header[has_genome], "\tAS:",
                                      genome(si)[has_genome])
    }
    custom <- mcols(object)[nchar(names(mcols(object))) == 2L]
    if (length(custom) > 0L && nrow(custom)>0) {
        type.map <- c(integer = "i", numeric = "f", character = "Z",
                      factor = "Z")
        custom.class <- vapply(custom, function(.ele) class(.ele)[1], 
                               FUN.VALUE = "character")
        custom.type <- type.map[custom.class]
        custom.type[names(custom) %in% possibleTag$integer] <- "i"
        custom.type[names(custom) %in% possibleTag$character] <- "Z"
        unknown.class <- custom.class[is.na(custom.type)]
        if (length(unknown.class) > 0L) {
            warning("these classes are not yet valid for BAM tag export: ",
                    paste(unknown.class, collapse=", "))
            custom <- custom[!is.na(custom.type)]
            custom.type <- custom.type[!is.na(custom.type)]
        }
        customMD <- custom[names(custom) %in% possibleTag$Metadata]
        if(length(customMD)){
            tag_ids <- lapply(customMD, unique)
            tag_ids <- lapply(tag_ids, function(.ele) .ele[!is.na(.ele)])
            tag_ids <- paste0("@", rep(names(tag_ids), lengths(tag_ids)),
                              "\tID:", unlist(tag_ids))
            header <- c(header, tag_ids)
        }
    }
    if(length(metadata(object)$header)) header <- metadata(object)$header
    writeLines(header, sam_con)
    chunk <- 100000
    for(i in seq.int(ceiling(length(object)/chunk))){
      idx <- seq.int(chunk)+(i-1)*chunk
      thisObj <- object[idx[idx<=length(object)]]
      thisCustom <- custom[idx[idx<=length(object)], , drop=FALSE]
      emd <- mcols(thisObj)
      aln <- paste(fillColumn(names(thisObj), "*"),# QNAME String
                   formatInt(fillColumn(emd[["flag"]],
                                        ifelse(strand(thisObj) == "-",
                                               16, 0))), # FLAG Int
                   seqnames(thisObj),# RNAME String
                   formatInt(start(thisObj)),# POS Int
                   formatInt(fillColumn(emd[["mapq"]], 255)),# MAPQ Int
                   cigar(thisObj), # CIGAR String
                   fillColumn(emd[["mrnm"]], "*"), # RNEXT String
                   formatInt(fillColumn(emd[["mpos"]], 0)), # PNEXT Int
                   formatInt(fillColumn(emd[["isize"]], 0)), # TLEN Int
                   if (is(thisObj, "GappedReads")) thisObj@qseq
                   else fillColumn(emd[["seq"]], "*"), # SEQ String
                   fillColumn(emd[["qual"]], "*"), # QUAL String
                   sep = "\t")
      if (length(thisCustom) > 0L && nrow(thisCustom)>0) {
        tags <- mapply(paste0, names(thisCustom), ":", custom.type, ":",
                       as.list(thisCustom), SIMPLIFY=FALSE)
        tags <- do.call(paste, c(tags, sep = "\t"))
        ## remove the NA values
        tags <- sub("\\t$", "", 
                    sub("..:[ifZ]:NA$", "", 
                        gsub("..:[ifZ]:NA\\t", "", tags)))
        aln <- paste(aln, tags, sep = "\t")
      }
      writeLines(aln, sam_con)
      rm(aln, tags, thisObj, thisCustom)
      gc(verbose = FALSE)
    }
    
    close(sam_con)
    on.exit() ## redefine on.exit
    if(any(seqlengths(si)>536870912)){
        bam <- asBam(sam_path, sub(".bam$", "", con, ignore.case = TRUE),
                     overwrite = TRUE, indexDestination = FALSE)
    }else{
        bam <- asBam(sam_path, sub(".bam$", "", con, ignore.case = TRUE),
                     overwrite = TRUE, indexDestination = TRUE)
    }
    unlink(sam_path)
    invisible(bam)
}

---
title: "ATACseqQC Guide"
author: "Jianhong Ou, Haibo Liu, Jun Yu, Michelle Kelliher, Lucio Castilla, Nathan Lawson, Lihua Julie Zhu"
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('ATACseqQC')`"
bibliography: bibliography.bib
csl: nature.csl
vignette: >
  %\VignetteIndexEntry{ATACseqQC Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  html_document:
    theme: simplex
    toc: true
    toc_float: true
    toc_depth: 4
---

```{r, echo=FALSE, results="hide", warning=FALSE, message=FALSE}
suppressPackageStartupMessages({
  library(ATACseqQC)
  library(ChIPpeakAnno)
  library(BSgenome.Hsapiens.UCSC.hg19)
  library(TxDb.Hsapiens.UCSC.hg19.knownGene)
  library(phastCons100way.UCSC.hg19)
  library(MotifDb)
  library(GenomicAlignments)
})
knitr::opts_chunk$set(warning=FALSE, message=FALSE)
```

# Introduction

Assay for Transposase-Accessible Chromatin using sequencing 
(ATAC-seq) is an alternative or complementary technique to MNase-seq, DNase-seq, 
and FAIRE-seq for chromatin accessibility analysis. The results 
obtained from ATAC-seq are similar to those from DNase-seq and FAIRE-seq. 
ATAC-seq is gaining popularity because it does not require cross-linking, 
has higher signal to noise ratio, requires a much smaller amount of biological 
material and is faster and easier to perform, compared to other techniques [@buenrostro2013transposition]. 

To help researchers quickly assess the quality of  ATAC-seq data, we 
have developed the ATACseqQC package for easily making diagnostic plots 
following the published guidelines [@buenrostro2013transposition]. 
In addition, it has functions to preprocess ATACseq data for 
subsequent peak calling.

# Quick start

Here is an example using ATACseqQC with a subset of published ATAC-seq 
data[@buenrostro2013transposition]. Currently, only bam input file 
format is supported.

First install ATACseqQC and other packages required to run the examples. Please note that the example dataset used here is from human. To run analysis with dataset from a different species or differnt assembly, please install the corresponding BSgenome, TxDb and phastCons. For example, to analyze mouse data aligned to mm10, please install BSgenome.Mmusculus.UCSC.mm10, TxDb.Mmusculus.UCSC.mm10.knownGene and phastCons60way.UCSC.mm10. Please note that phstCons60way.UCSC.mm10 is optional, which can be obtained according to the vignettes of GenomicScores. 

```{r, eval=FALSE}
library(BiocManager)
BiocManager::install(c("ATACseqQC", "ChIPpeakAnno", "MotifDb", "GenomicAlignments",
           "BSgenome.Hsapiens.UCSC.hg19", "TxDb.Hsapiens.UCSC.hg19.knownGene",
           "phastCons100way.UCSC.hg19"))
```

```{r}
## load the library
library(ATACseqQC)
## input the bamFile from the ATACseqQC package 
bamfile <- system.file("extdata", "GL1.bam", 
                        package="ATACseqQC", mustWork=TRUE)
bamfile.labels <- gsub(".bam", "", basename(bamfile))
```

## IGV snapshot

Source code of IGVSnapshot function is available in extdata folder. To call the function, please try

```{r, eval=FALSE}
source(system.file("extdata", "IGVSnapshot.R", package = "ATACseqQC"))
```


## Estimate the library complexity

```{r}
#bamQC(bamfile, outPath=NULL)
estimateLibComplexity(readsDupFreq(bamfile))
```

## Fragment size distribution

First, there should be a large proportion of reads with less 
than 100 bp, which represents the nucleosome-free region. 
Second, the fragment size distribution should have a clear 
periodicity, which is evident in the inset figure, indicative of 
nucleosome occupacy (present in integer multiples).

```{r}
## generate fragement size distribution
fragSize <- fragSizeDist(bamfile, bamfile.labels)
```

## Nucleosome positioning

### Adjust the read start sites

Tn5 transposase has been shown to bind as a dimer and 
inserts two adaptors into accessible DNA locations separated by 9 bp [@adey2010rapid].

Therefore, for downstream analysis, such as peak-calling and footprinting,
all reads in input bamfile need to be shifted. 
The function `shiftGAlignmentsList` can be used to shift the reads. 
By default, all reads aligning to the positive strand are offset by +4bp, 
and all reads aligning to the negative strand are offset by -5bp [@buenrostro2013transposition]. 

The adjusted reads will be written into a new bamfile for peak calling or 
footprinting.

```{r}
## bamfile tags to be read in
possibleTag <- list("integer"=c("AM", "AS", "CM", "CP", "FI", "H0", "H1", "H2", 
                                "HI", "IH", "MQ", "NH", "NM", "OP", "PQ", "SM",
                                "TC", "UQ"), 
                 "character"=c("BC", "BQ", "BZ", "CB", "CC", "CO", "CQ", "CR",
                               "CS", "CT", "CY", "E2", "FS", "LB", "MC", "MD",
                               "MI", "OA", "OC", "OQ", "OX", "PG", "PT", "PU",
                               "Q2", "QT", "QX", "R2", "RG", "RX", "SA", "TS",
                               "U2"))
library(Rsamtools)
bamTop100 <- scanBam(BamFile(bamfile, yieldSize = 100),
                     param = ScanBamParam(tag=unlist(possibleTag)))[[1]]$tag
tags <- names(bamTop100)[lengths(bamTop100)>0]
tags
## files will be output into outPath
outPath <- "splited"
dir.create(outPath)
## shift the coordinates of 5'ends of alignments in the bam file
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
## if you don't have an available TxDb, please refer
## GenomicFeatures::makeTxDbFromGFF to create one from gff3 or gtf file.
seqlev <- "chr1" ## subsample data for quick run
seqinformation <- seqinfo(TxDb.Hsapiens.UCSC.hg19.knownGene)
which <- as(seqinformation[seqlev], "GRanges")
gal <- readBamFile(bamfile, tag=tags, which=which, asMates=TRUE, bigFile=TRUE)
shiftedBamfile <- file.path(outPath, "shifted.bam")
gal1 <- shiftGAlignmentsList(gal, outbam=shiftedBamfile)
```

### Promoter/Transcript body (PT) score

PT score is calculated as the coverage of promoter divided by the coverage of its transcript body.
PT score will show if the signal is enriched in promoters.
```{r}
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
pt <- PTscore(gal1, txs)
plot(pt$log2meanCoverage, pt$PT_score, 
     xlab="log2 mean coverage",
     ylab="Promoter vs Transcript")
```


### Nucleosome Free Regions (NFR) score

NFR score is a ratio between cut signal adjacent to TSS and that flanking the corresponding TSS.
Each TSS window of 400 bp is first divided into 3 sub-regions: the most upstream 150 bp (n1), 
the most downstream of 150 bp (n2), and the middle 100 bp (nf). 
Then the number of fragments with 5' ends overlapping each region are calculated for each TSS.
The NFR score for each TSS is calculated as NFR-score = log2(nf) - log2((n1+n2)/2). 
A plot can be generated with the NFR scores as Y-axis and the average signals of 400 bp window as X-axis, 
very like a MA plot for gene expression data. 

```{r}
nfr <- NFRscore(gal1, txs)
plot(nfr$log2meanCoverage, nfr$NFR_score, 
     xlab="log2 mean coverage",
     ylab="Nucleosome Free Regions score",
     main="NFRscore for 200bp flanking TSSs",
     xlim=c(-10, 0), ylim=c(-5, 5))
```


### Transcription Start Site (TSS) Enrichment Score

TSS enrichment score is a raio between aggregate distribution of reads centered on TSSs and that flanking 
the corresponding TSSs. TSS score = the depth of TSS (each 100bp window within 1000 bp each side) / the depth of end flanks (100bp each end).
TSSE score = max(mean(TSS score in each window)).
TSS enrichment score is calculated according to the definition at [https://www.encodeproject.org/data-standards/terms/#enrichment](https://www.encodeproject.org/data-standards/terms/#enrichment). Transcription start site (TSS) enrichment values are dependent on the reference files used; cutoff values for high quality data are listed in the following table from [https://www.encodeproject.org/atac-seq/](https://www.encodeproject.org/atac-seq/).

```{r}
tsse <- TSSEscore(gal1, txs)
tsse$TSSEscore
plot(100*(-9:10-.5), tsse$values, type="b", 
     xlab="distance to TSS",
     ylab="aggregate TSS score")
```


### Split reads

The shifted reads will be split into different bins, namely
nucleosome free, mononucleosome, dinucleosome, and trinucleosome.
Shifted reads that do not fit into any of the above bins will
be discarded. Splitting reads is a time-consuming step 
because we are using random forest to classify the fragments 
based on fragment length, GC content and conservation scores 
[@chen2013danpos].

By default, we assign the top 10% of short reads (reads below 100_bp) 
as nucleosome-free regions and the top 10% of intermediate length reads
as (reads between 180 and 247 bp) mononucleosome. 
This serves as the training set to classify the rest of the fragments
using random forest. The number of the tree will be set to 2 times 
of square root of the length of the training set.

```{r}
library(BSgenome.Hsapiens.UCSC.hg19)
library(phastCons100way.UCSC.hg19)
## run program for chromosome 1 only
txs <- txs[seqnames(txs) %in% "chr1"]
genome <- Hsapiens
## split the reads into NucleosomeFree, mononucleosome, 
## dinucleosome and trinucleosome.
## and save the binned alignments into bam files.
objs <- splitGAlignmentsByCut(gal1, txs=txs, genome=genome, outPath = outPath,
                              conservation=phastCons100way.UCSC.hg19)
## list the files generated by splitGAlignmentsByCut.
dir(outPath)
```

You can also perform shifting, splitting and saving in one step by calling `splitBam`.

```{r eval=FALSE}
objs <- splitBam(bamfile, tags=tags, outPath=outPath,
                 txs=txs, genome=genome,
                 conservation=phastCons100way.UCSC.hg19)
```

Conservation is an optional parameter. If you do not have the conservation score or 
you would like to simply split the bam files using the fragment length, 
then you will just need to run the command without providing the conservation argument. 
Without setting the conservation parameter, it will run much faster.

```{r eval=FALSE}
## split reads by fragment length
## NOT RUN IN THIS example
objs <- splitGAlignmentsByCut(gal1, txs=txs, outPath = outPath)
```

### Heatmap and coverage curve for nucleosome positions

By averaging the signal across all active TSSs, we should observe that 
nucleosome-free fragments are enriched at the TSSs, 
whereas the nucleosome-bound fragments should be enriched both upstream 
and downstream of the active TSSs and display characteristic phasing of upstream and 
downstream nucleosomes. Because ATAC-seq reads are concentrated at regions of 
open chromatin, users should see a strong nucleosome signal at the +1 
nucleosome, but the signal decreases at the +2, +3 and +4 nucleosomes. 

```{r fig.height=4, fig.width=4}
library(ChIPpeakAnno)
bamfiles <- file.path(outPath,
                     c("NucleosomeFree.bam",
                     "mononucleosome.bam",
                     "dinucleosome.bam",
                     "trinucleosome.bam"))
## Plot the cumulative percentage of tag allocation in nucleosome-free 
## and mononucleosome bam files.
cumulativePercentage(bamfiles[1:2], as(seqinformation["chr1"], "GRanges"))
```
```{r fig.height=8, fig.width=4}
TSS <- promoters(txs, upstream=0, downstream=1)
TSS <- unique(TSS)
## estimate the library size for normalization
(librarySize <- estLibSize(bamfiles))
## calculate the signals around TSSs.
NTILE <- 101
dws <- ups <- 1010
sigs <- enrichedFragments(gal=objs[c("NucleosomeFree", 
                                     "mononucleosome",
                                     "dinucleosome",
                                     "trinucleosome")], 
                          TSS=TSS,
                          librarySize=librarySize,
                          seqlev=seqlev,
                          TSS.filter=0.5,
                          n.tile = NTILE,
                          upstream = ups,
                          downstream = dws)
## log2 transformed signals
sigs.log2 <- lapply(sigs, function(.ele) log2(.ele+1))
#plot heatmap
featureAlignedHeatmap(sigs.log2, reCenterPeaks(TSS, width=ups+dws),
                      zeroAt=.5, n.tile=NTILE)
```
```{r fig.show="hide"}
## get signals normalized for nucleosome-free and nucleosome-bound regions.
out <- featureAlignedDistribution(sigs, 
                                  reCenterPeaks(TSS, width=ups+dws),
                                  zeroAt=.5, n.tile=NTILE, type="l", 
                                  ylab="Averaged coverage")
```
```{r}
## rescale the nucleosome-free and nucleosome signals to 0~1
range01 <- function(x){(x-min(x))/(max(x)-min(x))}
out <- apply(out, 2, range01)
matplot(out, type="l", xaxt="n", 
        xlab="Position (bp)", 
        ylab="Fraction of signal")
axis(1, at=seq(0, 100, by=10)+1, 
     labels=c("-1K", seq(-800, 800, by=200), "1K"), las=2)
abline(v=seq(0, 100, by=10)+1, lty=2, col="gray")
```

## plot Footprints

ATAC-seq footprints infer factor occupancy genome-wide. The `factorFootprints` 
function uses `matchPWM` to predict the binding sites using the input position
weight matrix (PWM). 
Then it calculates and plots the accumulated coverage for those binding sites
to show the status of the occupancy genome-wide.
Unlike CENTIPEDE[@pique2011accurate], the footprints generated here 
do not take the conservation (PhyloP) into consideration. 
`factorFootprints` function could also accept the
binding sites as a GRanges object.

```{r}
## foot prints
library(MotifDb)
CTCF <- query(MotifDb, c("CTCF"))
CTCF <- as.list(CTCF)
print(CTCF[[1]], digits=2)
sigs <- factorFootprints(shiftedBamfile, pfm=CTCF[[1]], 
                         genome=genome, ## Don't have a genome? ask ?factorFootprints for help
                         min.score="90%", seqlev=seqlev,
                         upstream=100, downstream=100)
```
```{r fig.height=6, fig.width=6}
featureAlignedHeatmap(sigs$signal, 
                      feature.gr=reCenterPeaks(sigs$bindingSites,
                                               width=200+width(sigs$bindingSites[1])), 
                      annoMcols="score",
                      sortBy="score",
                      n.tile=ncol(sigs$signal[[1]]))

sigs$spearman.correlation
sigs$Profile.segmentation
```



Here is the CTCF footprints for the full dataset.
![CTCF footprints](CTCFfootprints.png)

### V-plot

V-plot is a plot to visualize fragment midpoint vs length for a given transcription factors.

```{r}
vp <- vPlot(shiftedBamfile, pfm=CTCF[[1]], 
            genome=genome, min.score="90%", seqlev=seqlev,
            upstream=200, downstream=200, 
            ylim=c(30, 250), bandwidth=c(2, 1))

distanceDyad(vp, pch=20, cex=.5)
```

Here is the CTCF vPlot for the full dataset.
![CTCF footprints](CTCFvPlot.png)

# Plot correlations for multiple samples

```{r}
path <- system.file("extdata", package="ATACseqQC", mustWork=TRUE)
bamfiles <- dir(path, "*.bam$", full.name=TRUE)
gals <- lapply(bamfiles, function(bamfile){
               readBamFile(bamFile=bamfile, tag=character(0), 
                          which=GRanges("chr1", IRanges(1, 1e6)), 
                          asMates=FALSE)
         })
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(GenomicAlignments)
plotCorrelation(GAlignmentsList(gals), txs, seqlev="chr1")
```


# Session Info
```{r sessionInfo}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vPlot.R
\name{vPlot}
\alias{vPlot}
\title{V-plot}
\usage{
vPlot(
  bamfiles,
  index = bamfiles,
  pfm,
  genome,
  min.score = "95\%",
  bindingSites,
  seqlev = paste0("chr", c(1:22, "X", "Y")),
  upstream = 200,
  downstream = 200,
  maxSiteNum = 1e+06,
  draw = TRUE,
  ...
)
}
\arguments{
\item{bamfiles}{A vector of characters indicates the file names of bams.
All the bamfiles will be pulled together.}

\item{index}{The names of the index file of the 'BAM' file being processed;
This is given without the '.bai' extension.}

\item{pfm}{A Position frequency Matrix represented as a numeric matrix
with row names A, C, G and T.}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome}.}

\item{min.score}{The minimum score for counting a match.
Can be given as a character string containing a
percentage (e.g. "95%") of the highest possible
score or as a single number.
See \link[Biostrings]{matchPWM}.}

\item{bindingSites}{A object of \link[GenomicRanges:GRanges-class]{GRanges} indicates
candidate binding sites (eg. the output of fimo).}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{upstream, downstream}{numeric(1) or integer(1).
Upstream and downstream of the binding region for
aggregate ATAC-seq footprint.}

\item{maxSiteNum}{numeric(1). Maximal number of predicted binding sites.
if predicted binding sites is more than this number, top maxSiteNum binding
sites will be used.}

\item{draw}{Plot or not. Default TRUE.}

\item{...}{parameters could be used by \link[graphics]{smoothScatter}}
}
\value{
an invisible data.frame for plot.
}
\description{
Aggregate ATAC-seq Fragment Midpoint vs. Length for a given motif generated
             over binding sites within the genome.
}
\examples{

bamfile <- system.file("extdata", "GL1.bam",
                       package="ATACseqQC")
library(MotifDb)
CTCF <- query(MotifDb, c("CTCF"))
CTCF <- as.list(CTCF)
library(BSgenome.Hsapiens.UCSC.hg19)
vPlot(bamfile, pfm=CTCF[[1]],
     genome=Hsapiens,
     min.score="95\%", seqlev="chr1",
     ylim=c(30, 250))

}
\references{
Jorja G. Henikoff, Jason A. Belsky, Kristina Krassovsky, 
David M. MacAlpine, and Steven Henikoff.
Epigenome characterization at single base-pair resolution.
PNAS 2011 108 (45) 18318-18323
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PTscore.R
\name{PTscore}
\alias{PTscore}
\title{Promoter/Transcript body (PT) score}
\usage{
PTscore(
  obj,
  txs,
  seqlev = intersect(seqlevels(obj), seqlevels(txs)),
  upstream = 2000,
  downstream = 500
)
}
\arguments{
\item{obj}{an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}}

\item{txs}{GRanges of transcripts}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{upstream}{numeric(1) or integer(1). Start position of promoter. Default is 2000}

\item{downstream}{numeric(1) or integer(1). End position of promoter. Default is 500}
}
\value{
A object of \link[GenomicRanges:GRanges-class]{GRanges} with PT scores
}
\description{
PT score is calculated for coverage of promoter divided by the coverage of transcripts body.
PT score will show if the signal is enriched in promoters.
}
\examples{
 
library(GenomicRanges)
bamfile <- system.file("extdata", "GL1.bam", 
                       package="ATACseqQC", mustWork=TRUE)
gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
                    which=GRanges("chr1", IRanges(1, 1e6)), 
                    asMates=FALSE)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
pt <- PTscore(gal1, txs)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bamQC.R
\name{bamQC}
\alias{bamQC}
\title{Mapping quality control}
\usage{
bamQC(
  bamfile,
  index = bamfile,
  mitochondria = "chrM",
  outPath = sub(".bam", ".clean.bam", basename(bamfile)),
  doubleCheckDup = FALSE
)
}
\arguments{
\item{bamfile}{character(1). File name of bam.}

\item{index}{character(1). File name of index file.}

\item{mitochondria}{character(1). Sequence name of mitochondria.}

\item{outPath}{character(1). File name of cleaned bam.}

\item{doubleCheckDup}{logical(1). Double check duplicates or not if there is no tags for that.}
}
\value{
A list of quality summary.
}
\description{
Check the mapping rate, PCR duplication rate,
and mitochondria reads contamination.
}
\examples{
bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
bamQC(bamfile, outPath=NULL)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TSSEscore.R
\name{TSSEscore}
\alias{TSSEscore}
\title{Transcription Start Site (TSS) Enrichment Score}
\usage{
TSSEscore(
  obj,
  txs,
  seqlev = intersect(seqlevels(obj), seqlevels(txs)),
  upstream = 1000,
  downstream = 1000,
  endSize = 100,
  width = 100,
  step = width,
  pseudocount = 0,
  ...
)
}
\arguments{
\item{obj}{an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}}

\item{txs}{GRanges of transcripts}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{upstream, downstream}{numeric(1) or integer(1). upstream and downstream of TSS. Default is 1000}

\item{endSize}{numeric(1) or integer(1). the size of the end flanks. Default is 100}

\item{width}{numeric(1) or integer(1). the window size for TSS score. Default is 100.}

\item{step}{numeric(1) or integer(1). The distance between the start position of the sliding windows.}

\item{pseudocount}{numeric(1) or integer(1). Pseudocount. Default is 0. 
If pseudocount is no greater than 0, the features with ZERO or less than ZERO 
counts in flank region will be removed in calculation.}

\item{...}{parameter can be passed to loess.smooth other than 'x', 'y', 'family' and 'evaluation'.}
}
\value{
A object of list with TSS scores
}
\description{
TSS score is a raio between aggregate distribution of reads centered on TSSs and that flanking 
the corresponding TSSs. TSS score = the depth of TSS (each step within 1000 bp each side) / the depth of end flanks (100bp each end).
TSSE score = max(mean(TSS score in each window)).
}
\examples{
 
library(GenomicRanges)
bamfile <- system.file("extdata", "GL1.bam", 
                       package="ATACseqQC", mustWork=TRUE)
gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
                    which=GRanges("chr1", IRanges(1, 1e6)), 
                    asMates=FALSE)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
tsse <- TSSEscore(gal1, txs)
}
\references{
https://www.encodeproject.org/data-standards/terms/#enrichment
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/footprintsScanner.R
\name{DB}
\alias{DB}
\title{helper function for differential binding}
\usage{
DB(counts, libSize, group, default.bcv = 0.3)
}
\arguments{
\item{counts}{count table}

\item{libSize}{library size}

\item{group}{group design}

\item{default.bcv}{a reasonable dispersion value}
}
\value{
topTable
}
\description{
helper function for differential binding
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCorrelation.R
\name{plotCorrelation}
\alias{plotCorrelation}
\title{plot Correlations of multiple samples}
\usage{
plotCorrelation(
  objs,
  txs,
  seqlev = intersect(seqlevels(objs[[1]]), seqlevels(txs)),
  upstream = 2000,
  downstream = 500,
  type = c("heatmap", "PCA"),
  ...
)
}
\arguments{
\item{objs}{an object of \link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList}}

\item{txs}{GRanges of transcripts}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{upstream}{numeric(1) or integer(1). Start position of promoter. Default is 2000}

\item{downstream}{numeric(1) or integer(1). End position of promoter. Default is 500}

\item{type}{Figure type, heatmap or PCA plot.}

\item{...}{parameters could be passed to downstream functions such as plot for pca or heatmap for heatmap.}
}
\value{
A invisible object of \link[GenomicRanges:GRanges-class]{GRanges} with counts
}
\description{
plot PCA or heatmap for multiple bamfiles. The correlation is 
calculated by the counts in promoter regions.
}
\details{
The correlation will be calculated by the correlation of insertion
sites within promoter regions. Even the sequencing is paired-end, 
please treat it as single ends.
}
\examples{
library(GenomicRanges)
library(GenomicAlignments)
path <- system.file("extdata", package="ATACseqQC", mustWork=TRUE)
bamfiles <- dir(path, "*.bam$", full.name=TRUE)
gals <- lapply(bamfiles, function(bamfile){
               readBamFile(bamFile=bamfile, tag=character(0), 
                           which=GRanges("chr1", IRanges(1, 1e6)), 
                           asMates=FALSE)
        })
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
plotCorrelation(GAlignmentsList(gals), txs, seqlev="chr1")
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitBam.R
\name{splitBam}
\alias{splitBam}
\title{prepare bam files for downstream analysis}
\usage{
splitBam(
  bamfile,
  tags,
  index = bamfile,
  outPath = NULL,
  txs,
  genome,
  conservation,
  positive = 4L,
  negative = 5L,
  breaks = c(0, 100, 180, 247, 315, 473, 558, 615, Inf),
  labels = c("NucleosomeFree", "inter1", "mononucleosome", "inter2", "dinucleosome",
    "inter3", "trinucleosome", "others"),
  seqlev = paste0("chr", c(1:22, "X", "Y")),
  cutoff = 0.8,
  flag = scanBamFlag(isSecondaryAlignment = FALSE, isUnmappedQuery = FALSE,
    isNotPassingQualityControls = FALSE, isSupplementaryAlignment = FALSE)
)
}
\arguments{
\item{bamfile}{character(1). File name of bam.}

\item{tags}{A vector of characters indicates the tags in bam file.}

\item{index}{The names of the index file of the 'BAM' file being processed;
This is given without the '.bai' extension.}

\item{outPath}{Output file path.}

\item{txs}{\link[GenomicRanges:GRanges-class]{GRanges} of transcripts.}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome}}

\item{conservation}{An object of \link[GenomicScores:GScores-class]{GScores}.}

\item{positive}{integer(1). the size to be shift for positive strand}

\item{negative}{integer(1). the size to be shift for negative strand}

\item{breaks}{A numeric vector for fragment size of nucleosome free,
mononucleosome, dinucleosome and trinucleosome}

\item{labels}{A vector of characters indicates the labels for the levels
of the resulting category.
The length of labels = length of breaks - 1}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{cutoff}{numeric(1). Cutoff value for prediction by
\link[randomForest]{randomForest}.}

\item{flag}{An integer(2) vector used to filter reads based on their 
'flag' entry.}
}
\value{
an invisible list of \link[GenomicAlignments:GAlignments-class]{GAlignments}
}
\description{
shift the bam files by 5'ends and split the bam files.
}
\examples{
if(Sys.getenv("USER")=="jianhongou"){
bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
library(BSgenome.Hsapiens.UCSC.hg19)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(phastCons100way.UCSC.hg19)
objs <- splitBam(bamfile, tags,
                 txs=txs, genome=Hsapiens,
                 conservation=phastCons100way.UCSC.hg19,
                 seqlev="chr1")
}
}
\seealso{
\link{shiftGAlignmentsList}, \link{splitGAlignmentsByCut}, and 
\link{writeListOfGAlignments}
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimateLibComplexity.R
\name{estimateLibComplexity}
\alias{estimateLibComplexity}
\title{Library complexity estimation}
\usage{
estimateLibComplexity(
  histFile,
  times = 100,
  interpolate.sample.sizes = seq(0.1, 1, by = 0.1),
  extrapolate.sample.sizes = seq(5, 20, by = 5)
)
}
\arguments{
\item{histFile}{A two-column matrix of integers. The 1st column is the frequency 
j = 1,2,3,.... The 2nd column is the number of genomic regions with the same 
fequency (j) of duplication. This file should be sorted by the first column 
in ascending order. For example, one row of a histogram file:
10    20
means there are 10 genomic regions, each of which is covered by 20 identical 
fragments at a given sequencing depth of a sequencing library.}

\item{times}{An positive integer representing the minimum required number of 
successful estimation. Default is 100.}

\item{interpolate.sample.sizes}{A numeric vector with values between (0, 1].}

\item{extrapolate.sample.sizes}{A numeric vector with values greater than 1.}
}
\value{
invisible estimates, a data frame of 3 columns: relative sequence depth, 
number of distinct fragments, number of putative sequenced reads.
}
\description{
Estimating the library complexity.
}
\examples{
library(preseqR)
data(FisherButterfly)
estimateLibComplexity(histFile=FisherButterfly, times=100)
}
\seealso{
\link{readsDupFreq}
}
\author{
Haibo Liu, Feng Yan
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiftReads.R
\name{shiftReads}
\alias{shiftReads}
\title{shift read for 5'end}
\usage{
shiftReads(x, positive = 4L, negative = 5L)
}
\arguments{
\item{x}{an object of GAlignments}

\item{positive}{integer(1). the size to be shift for positive strand}

\item{negative}{integer(1). the size to be shift for negative strand}
}
\value{
an object of GAlignments
}
\description{
shift reads for 5'ends
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiftGAlignments.R
\name{shiftGAlignments}
\alias{shiftGAlignments}
\title{shift 5' ends for single end reads}
\usage{
shiftGAlignments(gal, positive = 4L, negative = 5L, outbam)
}
\arguments{
\item{gal}{An object of 
\link[GenomicAlignments:GAlignments-class]{GAlignments}.}

\item{positive}{integer(1). the size to be shift for positive strand}

\item{negative}{integer(1). the size to be shift for negative strand}

\item{outbam}{file path to save shift reads. 
If missing, no file will be write.}
}
\value{
An object of 
\link[GenomicAlignments:GAlignments-class]{GAlignments} with 5' end 
shifted reads.
}
\description{
shift the GAlignmentsLists by 5' ends. 
All reads aligning to the positive strand will be offset by +4bp, 
and all reads aligning to the negative strand will be offset -5bp by default.
}
\examples{
bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
library(BSgenome.Hsapiens.UCSC.hg19)
which <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
gal <- readBamFile(bamfile, tag=tags, 
                   what=c("qname", "flag", "mapq", "seq", "qual"),
                   which=which, asMates=FALSE, bigFile=TRUE)
objs <- shiftGAlignments(gal)
export(objs, "shift.bam")
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fragSizeDist.R
\name{fragSizeDist}
\alias{fragSizeDist}
\title{fragment size distribution}
\usage{
fragSizeDist(
  bamFiles,
  bamFiles.labels,
  index = bamFiles,
  ylim = NULL,
  logYlim = NULL
)
}
\arguments{
\item{bamFiles}{A vector of characters indicates the file names of bams.}

\item{bamFiles.labels}{labels of the bam files, used for pdf file naming.}

\item{index}{The names of the index file of the 'BAM' file being processed;
This is given without the '.bai' extension.}

\item{ylim}{numeric(2). ylim of the histogram.}

\item{logYlim}{numeric(2). ylim of log-transformed histogram for the insert.}
}
\value{
Invisible fragment length distribution list.
}
\description{
estimate the fragment size of bams
}
\examples{
bamFiles <- dir(system.file("extdata", package="ATACseqQC"), "GL.*.bam$", full.names=TRUE)
bamFiles.labels <- sub(".bam", "", basename(bamFiles))
fragSizeDist(bamFiles, bamFiles.labels)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splitGAlignmentsByCut.R
\name{splitGAlignmentsByCut}
\alias{splitGAlignmentsByCut}
\title{split bams into nucleosome free, mononucleosome,
dinucleosome and trinucleosome}
\usage{
splitGAlignmentsByCut(
  obj,
  txs,
  genome,
  conservation,
  outPath,
  breaks = c(0, 100, 180, 247, 315, 473, 558, 615, Inf),
  labels = c("NucleosomeFree", "inter1", "mononucleosome", "inter2", "dinucleosome",
    "inter3", "trinucleosome", "others"),
  labelsOfNucleosomeFree = "NucleosomeFree",
  labelsOfMononucleosome = "mononucleosome",
  trainningSetPercentage = 0.15,
  cutoff = 0.8,
  halfSizeOfNucleosome = 80L,
  summaryFun = mean
)
}
\arguments{
\item{obj}{an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}}

\item{txs}{GRanges of transcripts}

\item{genome}{an object of BSgenome}

\item{conservation}{an object of \link[GenomicScores:GScores-class]{GScores}.}

\item{outPath}{folder to save the splitted alignments. If outPath is setting, 
the return of the function will not contain seq and qual fields.}

\item{breaks}{a numeric vector for fragment size of nucleosome free,
mononucleosome, dinucleosome and trinucleosome. The breaks pre-defined
here is following the description of Greenleaf's paper (see reference).}

\item{labels}{a character vector for labels of the levels 
of the resulting category.}

\item{labelsOfNucleosomeFree, labelsOfMononucleosome}{character(1). The label
for nucleosome free and mononucleosome.}

\item{trainningSetPercentage}{numeric(1) between 0 and 1. Percentage of 
trainning set from top coverage.}

\item{cutoff}{numeric(1) between 0 and 1. cutoff value for prediction.}

\item{halfSizeOfNucleosome}{numeric(1) or integer(1). Thre read length will
be adjusted to half of the nucleosome size to enhance the signal-to-noise
ratio.}

\item{summaryFun}{Function to summarize genomic scores when more than one
position is retrieved. This will greatly affect the CPU time.}
}
\value{
a list of GAlignments
}
\description{
use random forest to split the reads into nucleosome free,
             mononucleosome, dinucleosome and trinucleosome. 
             The features used in random forest including 
             fragment length, GC content, and 
             UCSC phastCons conservation scores.
}
\examples{
library(GenomicRanges)
bamfile <- system.file("extdata", "GL1.bam", 
                       package="ATACseqQC", mustWork=TRUE)
tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
gal1 <- readBamFile(bamFile=bamfile, tag=tags, 
                    which=GRanges("chr1", IRanges(1, 1e6)), 
                    asMates=FALSE)
names(gal1) <- mcols(gal1)$qname
library(BSgenome.Hsapiens.UCSC.hg19)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(phastCons100way.UCSC.hg19)
splitGAlignmentsByCut(gal1, txs=txs, genome=Hsapiens, 
                      conservation=phastCons100way.UCSC.hg19)

}
\references{
Buenrostro, J.D., Giresi, P.G., Zaba, L.C., Chang, H.Y. and 
Greenleaf, W.J., 2013. Transposition of native chromatin for fast and 
sensitive epigenomic profiling of open chromatin, DNA-binding proteins and 
nucleosome position. Nature methods, 10(12), pp.1213-1218.

Chen, K., Xi, Y., Pan, X., Li, Z., Kaestner, K., Tyler, J., Dent, S., 
He, X. and Li, W., 2013. DANPOS: dynamic analysis of nucleosome position 
and occupancy by sequencing. Genome research, 23(2), pp.341-351.
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotFootprints.R
\name{plotFootprints}
\alias{plotFootprints}
\title{Plots a footprint estimated by Centipede}
\usage{
plotFootprints(
  Profile,
  Mlen = 0,
  xlab = "Dist. to motif (bp)",
  ylab = "Cut-site probability",
  legLabels = c("For. strand", "Rev. strand"),
  legTitle,
  xlim,
  ylim,
  newpage = TRUE,
  motif,
  segmentation,
  reNormalizeByDistalSig = FALSE,
  ...
)
}
\arguments{
\item{Profile}{A vector with the profile estimated by CENTIPEDE}

\item{Mlen}{Length of the motif for drawing vertical lines delimiting it}

\item{xlab}{Label of the x axis}

\item{ylab}{Label for the y axis}

\item{legLabels}{Labels for legend.}

\item{legTitle}{Title for one of the plot corners}

\item{xlim}{xlim}

\item{ylim}{ylim}

\item{newpage}{Plot the figure in a new page?}

\item{motif}{a pfm object.}

\item{segmentation}{the segmentation position and abundance}

\item{reNormalizeByDistalSig}{Re-normalized the curver by distal signals.}

\item{...}{Not used.}
}
\value{
Null.
}
\description{
Visualizing the footprint profile
}
\examples{
library(MotifDb)
CTCF <- query(MotifDb, c("CTCF"))
CTCF <- as.list(CTCF)
motif <- new("pfm", mat=CTCF[[1]], name="CTCF")
ATACseqQC:::plotFootprints(Profile=sample.int(500), 
                        Mlen=ncol(CTCF[[1]]), motif=motif)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/writeListOfGAlignments.R
\name{writeListOfGAlignments}
\alias{writeListOfGAlignments}
\title{export list of GAlignments into bam files}
\usage{
writeListOfGAlignments(objs, outPath = ".")
}
\arguments{
\item{objs}{A list of \link[GenomicAlignments:GAlignments-class]{GAlignments}.}

\item{outPath}{character(1). Output file path.}
}
\value{
status of export.
}
\description{
wraper for \link[BiocIO:export]{export} to export list of 
GAlignment into bam files.
}
\examples{
library(GenomicAlignments)
gal1 <- GAlignments(seqnames=Rle("chr1"), pos=1L, cigar="10M",
                    strand=Rle(strand(c("+"))), names="a", score=1)
galist <- GAlignmentsList(a=gal1)
writeListOfGAlignments(galist)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pwmscores.R
\name{pwmscores}
\alias{pwmscores}
\title{max PWM scores for sequences}
\usage{
pwmscores(pwm, subject)
}
\arguments{
\item{pwm}{A Position Weight Matrix represented as a numeric matrix
with row names A, C, G and T.}

\item{subject}{Typically a \link[Biostrings:DNAString-class]{DNAString} object.
A \link[IRanges:Views-class]{Views} object on
a \link[Biostrings:DNAString-class]{DNAString} subject,
a \link[Biostrings:MaskedXString-class]{MaskedDNAString} object,
or a single character string, are also supported.
IUPAC ambiguity letters in \code{subject} are ignored (i.e.
assigned weight 0) with a warning.}
}
\value{
a numeric vector
}
\description{
calculate the maximal PWM scores for each given sequences
}
\author{
Jianhong
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readsDupFreq.R
\name{readsDupFreq}
\alias{readsDupFreq}
\title{Calculating duplication frequency}
\usage{
readsDupFreq(bamFile, index = bamFile)
}
\arguments{
\item{bamFile}{A character vector of length 1L containing the name of a BAM file.
Only a BAM file with duplication reads are meaningful for estimating the library
complexity. For example, a raw BAM file output by aligners, or a BAM file with 
mitochondrial reads removed.}

\item{index}{A character vector of length 1L containing the name of a BAM index file.}
}
\value{
A two-column matrix of integers. The 1st column is the frequency 
j = 1,2,3,.... The 2nd column is the number of genomic regions with the same 
fequency (j) of duplication. The frequency column is in ascending order.
}
\description{
Calculating the frequency of read duplication based on alignment
status determined by rname, strand, pos, cigar, mrnm, mpos and isize.
}
\examples{
bamFile <- system.file("extdata", "GL1.bam", package = "ATACseqQC")
freq <- readsDupFreq(bamFile)
}
\author{
Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/factorFootprints.R
\name{factorFootprints}
\alias{factorFootprints}
\title{plot ATAC-seq footprints infer factor occupancy genome wide}
\usage{
factorFootprints(
  bamfiles,
  index = bamfiles,
  pfm,
  genome,
  min.score = "95\%",
  bindingSites,
  seqlev = paste0("chr", c(1:22, "X", "Y")),
  upstream = 100,
  downstream = 100,
  maxSiteNum = 1e+06,
  anchor = "cut site",
  group = "strand",
  ...
)
}
\arguments{
\item{bamfiles}{A vector of characters indicates the file names of bams.
All the bamfiles will be pulled together.}

\item{index}{The names of the index file of the 'BAM' file being processed;
This is given without the '.bai' extension.}

\item{pfm}{A Position frequency Matrix represented as a numeric matrix
with row names A, C, G and T.}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome}.}

\item{min.score}{The minimum score for counting a match.
Can be given as a character string containing a
percentage (e.g. "95%") of the highest possible
score or as a single number.
See \link[Biostrings]{matchPWM}.}

\item{bindingSites}{A object of \link[GenomicRanges:GRanges-class]{GRanges} indicates
candidate binding sites (eg. the output of fimo). The GRanges object must have
score column in the metadata column.}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{upstream, downstream}{numeric(1) or integer(1).
Upstream and downstream of the binding region for
aggregate ATAC-seq footprint.}

\item{maxSiteNum}{numeric(1). Maximal number of predicted binding sites.
if predicted binding sites is more than this number, top maxSiteNum binding
sites will be used.}

\item{anchor}{"cut site" or "fragment center". If "fragment center" is used, 
the input bamfiles must be paired-end.}

\item{group}{Group information for the bamfiles. Default by strand. Otherwise,
a factor or vector of characters with same length of bamfiles. The
group is limited to 2 groups.}

\item{...}{xlab, legTitle, xlim or ylim could be used by \link{plotFootprints}}
}
\value{
an invisible list of matrixes with the signals for plot.
It includes:
 - signal    mean values of coverage for positive strand and negative strand
             in feature regions
 - spearman.correlation    spearman correlations of cleavage counts in the 
             highest 10-nucleotide-window and binding prediction score.
 - bindingSites    predicted binding sites.
}
\description{
Aggregate ATAC-seq footprint for a given motif generated
             over binding sites within the genome.
}
\examples{

bamfile <- system.file("extdata", "GL1.bam",
                       package="ATACseqQC")
library(MotifDb)
CTCF <- query(MotifDb, c("CTCF"))
CTCF <- as.list(CTCF)
library(BSgenome.Hsapiens.UCSC.hg19)
factorFootprints(bamfile, pfm=CTCF[[1]],
                genome=Hsapiens,
                min.score="95\%", seqlev="chr1",
                upstream=100, downstream=100)
##### Using user defined binding sites #####
bds <- readRDS(system.file("extdata", "jolma2013.motifs.bindingList.95.rds",
                          package="ATACseqQC"))
bindingSites <- bds[["Hsapiens-jolma2013-CTCF"]]
seqlev <- "chr1" #seqlevels(bindingSites)
ff <- factorFootprints(bamfile, pfm=CTCF[[1]],
                bindingSites=bindingSites,
                seqlev=seqlev,
                upstream=100, downstream=100)
##### normalize the plot by distal signals #####
library(motifStack)
Profile <- lapply(ff$signal, function(.ele) colMeans(.ele, na.rm = TRUE))
pfm <- new('pfm', mat=as.matrix(CTCF[[1]]), name='CTCF')
plotFootprints(Profile=c(Profile[["+"]], Profile[["-"]]),
              Mlen=ff$Mlen,
              motif=pfm,
              segmentation=ff$Profile.segmentation,
              reNormalizeByDistalSig=TRUE)

}
\references{
Chen, K., Xi, Y., Pan, X., Li, Z., Kaestner, K., Tyler, J.,
Dent, S., He, X. and Li, W., 2013.
DANPOS: dynamic analysis of nucleosome position and occupancy by sequencing.
Genome research, 23(2), pp.341-351.
}
\author{
Jianhong Ou, Julie Zhu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distanceDyad.R
\name{distanceDyad}
\alias{distanceDyad}
\title{Distance of potential nucleosome dyad}
\usage{
distanceDyad(vPlotOut, fragLenRanges = c(60, 180, 250), draw = TRUE, ...)
}
\arguments{
\item{vPlotOut}{The output of \link{vPlot}.}

\item{fragLenRanges}{A numeric vector (length=3) for fragment size of nucleosome free and mono-nucleosome.
Default c(60, 180, 250).}

\item{draw}{Plot the results or not. Default TRUE.}

\item{...}{Prameters could be passed to plot.}
}
\value{
an invisible list with distance of nucleosome and the linear model.
}
\description{
Calculate the distance of potential nucleosome dyad and the linear model for V.
}
\examples{
bamfile <- system.file("extdata", "GL1.bam",
                       package="ATACseqQC")
library(MotifDb)
CTCF <- query(MotifDb, c("CTCF"))
CTCF <- as.list(CTCF)
library(BSgenome.Hsapiens.UCSC.hg19)
vp <- vPlot(bamfile, pfm=CTCF[[1]],
     genome=Hsapiens,
     min.score="95\%", seqlev="chr1",
     draw=FALSE)
distanceDyad(vp)
     
}
\seealso{
\link{vPlot}
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peakDet.R
\name{peakdet}
\alias{peakdet}
\title{Detect peak positions}
\usage{
peakdet(y, delta = 0, silence = TRUE)
}
\arguments{
\item{y}{A vector of numeric where to search peaks}

\item{delta}{A numeric of length 1, defining the local threshold
for peak detection. If it is set to 0, the delta will be set to
1/10 of the range of y.}

\item{silence}{logical(1). 
If false, echo the delta value when delta is set as 0.}
}
\value{
A list with peakpos and valleypos. Both peakpos and valleypos are
vectors of numeric which indicate the positions of peak or valley.
}
\description{
Detect the peaks positions and valley positions. The algorithm is modified
from github::dgromer/peakdet
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readBamFile.R
\name{readBamFile}
\alias{readBamFile}
\title{read in bam files}
\usage{
readBamFile(
  bamFile,
  which,
  tag = character(0),
  what = c("qname", "flag", "mapq", "isize", "seq", "qual", "mrnm"),
  flag = scanBamFlag(isSecondaryAlignment = FALSE, isUnmappedQuery = FALSE,
    isNotPassingQualityControls = FALSE, isSupplementaryAlignment = FALSE),
  asMates = FALSE,
  bigFile = FALSE,
  ...
)
}
\arguments{
\item{bamFile}{character(1). Bam file name.}

\item{which}{A \link[GenomicRanges:GRanges-class]{GRanges}, \link[IRanges:IntegerRangesList-class]{IntegerRangesList}, 
or any object that can be coerced to a RangesList, or missing object, 
from which a IRangesList instance will be constructed. 
See \link[Rsamtools:ScanBamParam-class]{ScanBamParam}.}

\item{tag}{A vector of characters indicates the tag names to be read.
See \link[Rsamtools:ScanBamParam-class]{ScanBamParam}.}

\item{what}{A character vector naming the fields to return. 
Fields are described on the \link{Rsamtools}[scanBam] help page.}

\item{flag}{An integer(2) vector used to filter reads based on their 
'flag' entry.}

\item{asMates}{logical(1). Paired ends or not}

\item{bigFile}{If the file take too much memory, set it to true to avoid read the reads into memory.
\link[Rsamtools:ScanBamParam-class]{scanBamFlag} helper function.}

\item{...}{parameters used by \link[GenomicAlignments:readGAlignments]{readGAlignmentsList} 
or \link[GenomicAlignments]{readGAlignments}}
}
\value{
A GAlignmentsList object when asMates=TRUE,
otherwise A GAlignments object.
If bigFile is set to TRUE, no reads will be read into memory at this step and 
empty GAlignments/GAlignmentsList will be returned.
}
\description{
wraper for readGAlignments/readGAlignmentsList to read in bam files.
}
\examples{
library(BSgenome.Hsapiens.UCSC.hg19)
which <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
bamfile <- system.file("extdata", "GL1.bam", 
                       package="ATACseqQC", mustWork=TRUE)
readBamFile(bamfile, which=which, asMates=TRUE)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NFRscore.R
\name{NFRscore}
\alias{NFRscore}
\title{Nucleosome Free Regions (NFR) score}
\usage{
NFRscore(
  obj,
  txs,
  seqlev = intersect(seqlevels(obj), seqlevels(txs)),
  nucleosomeSize = 150,
  nucleosomeFreeSize = 100
)
}
\arguments{
\item{obj}{an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}}

\item{txs}{GRanges of transcripts}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{nucleosomeSize}{numeric(1) or integer(1). Default is 150}

\item{nucleosomeFreeSize}{numeric(1) or integer(1). Default is 100}
}
\value{
A object of \link[GenomicRanges:GRanges-class]{GRanges} with NFR scores
}
\description{
NFR score is a raio between cut signal adjacent to TSS and that flanking 
the corresponding TSS. Each TSS window of 400 bp is first seperated into 3 sub-regions: 
the most upstream 150 bp (n1), the most downstream of 150 bp (n2), and the middle 100 bp (nf). 
Then the number of fragments with 5' ends overlapping each region are calculated for each TSS.
The NFR score for each TSS is calculated as NFR-score = log2(nf) - log2((n1+n2)/2). 
A plot can be generate with the NFR scores as Y-axis and the average signals of 400 bp window as X-axis,
very like a MA plot for gene expression data.
}
\examples{
 
library(GenomicRanges)
bamfile <- system.file("extdata", "GL1.bam", 
                       package="ATACseqQC", mustWork=TRUE)
gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
                    which=GRanges("chr1", IRanges(1, 1e6)), 
                    asMates=FALSE)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
nfr <- NFRscore(gal1, txs)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saturationPlot.R
\name{saturationPlot}
\alias{saturationPlot}
\title{Plotting Saturation curves}
\usage{
saturationPlot(
  subsamplingPeakFiles,
  subsamplingSizes,
  sep = "\\t",
  header = FALSE,
  fdr = 0.05,
  fdrCol = 9,
  startCol = 2,
  endCol = 3,
  skipLines = 1,
  peakCaller = "MACS2",
  outPrefix,
  span = 2,
  degree = 2
)
}
\arguments{
\item{subsamplingPeakFiles}{A character vector containing peak files from peak
calling tools, such as MACS2. Currently only MACS2 output is supported.}

\item{subsamplingSizes}{A named vector of integers, which are the sizes of 
subsamples for peak calling. The names of subsamplingPeakFiles should be identical
to the basenames of subsamplingPeakFiles.}

\item{sep}{A character vector of length 1L, which is the column separator used 
in peak files.}

\item{header}{A boolean (TRUE or FASLE) vector of length 1L, showing whether 
there are column headers in the peak files.}

\item{fdr}{A decimal between 0 and 1, a cutoff of statistical significance of 
peak detection.}

\item{fdrCol}{An integer, column index for fdr.}

\item{startCol}{An integer, column index for start positions of peak regions.}

\item{endCol}{An integer, column index for end positions of peak regions.}

\item{skipLines}{An integer, the number of lines (comments or instruction) to 
skip when peak files are read into R.}

\item{peakCaller}{A character vector of length 1L contatining the name of the 
peak caller used to generate the peak files, such as "MACS2". Currently only 
MACS2 output (XXX.narrowPeak or XXX.broadPeak) is support.}

\item{outPrefix}{A character vector of length 1L, the file prefix for outputting
saturation plots.}

\item{span}{An integer, the span parameter for loess smoothing to fit a smoothed 
saturation curve.}

\item{degree}{An integer, the degree of local polynomial used for loess.}
}
\value{
A data frame of three columns:
subsamplingSizes, the number of subsampled fragments;
numPeaks, the number of peaks with fdr less than a given threshold when a given
number of fragmetns are subsampled;
breadth, the total breadth of peaks with fdr less than a given threshold for 
give subsampling when a given number of fragmetns are subsampled.
}
\description{
Plotting the saturation curves.
}
\examples{
if(interactive()){
}
}
\author{
Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pseudoPausingIndex.R
\name{pseudoPausingIndex}
\alias{pseudoPausingIndex}
\title{Simulation pausing index}
\usage{
pseudoPausingIndex(
  obj,
  txs,
  seqlev = intersect(seqlevels(obj), seqlevels(txs)),
  nascentRegion = c(-200, -1),
  pausedRegion = c(1, 200),
  avoidanceRegion = c(21, 60),
  elongationRegion = c(401, 600),
  pseudocount = 1L
)
}
\arguments{
\item{obj}{an object of \link[GenomicAlignments:GAlignments-class]{GAlignments}}

\item{txs}{GRanges of transcripts}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{nascentRegion, pausedRegion, avoidanceRegion, elongationRegion}{numeric(2)
 or integer(2).
The start and end position of the pre-initiation complex, paused complex, 
paused complex avoidance region and productive elongation.}

\item{pseudocount}{numeric(1) or integer(1). Pseudocount. Default is 1.}
}
\value{
A object of \link[GenomicRanges:GRanges-class]{GRanges} with pseudo
pausing index.
}
\description{
The polII pausing index is the ratio of the reads density at 
the 5' end of the gene to that in the gene body. This function will simulate
the pausing index by open chromatin coverage instead of PolII signaling.
The pausing index is a raio between aggregate distribution of reads in TSS
and that elongating gene bodys. The default PI = [average coverage of TSS
(+1 to +200bp) - average coverage of avoidance region (+21 to +60bp)] /
the average coverage of in transcripts (+401bp to 600bp).
}
\examples{
 
library(GenomicRanges)
bamfile <- system.file("extdata", "GL1.bam", 
                       package="ATACseqQC", mustWork=TRUE)
gal1 <- readBamFile(bamFile=bamfile, tag=character(0), 
                    which=GRanges("chr1", IRanges(1, 1e6)), 
                    asMates=FALSE)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
ppi <- pseudoPausingIndex(gal1, txs)
}
\references{
https://doi.org/10.1098%2Frsob.210220; 
https://www.nature.com/articles/nmeth.2688/figures/3
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichedFragments.R
\name{enrichedFragments}
\alias{enrichedFragments}
\title{enrichment for nucleosome-free fragments and nucleosome signals}
\usage{
enrichedFragments(
  bamfiles,
  index = bamfiles,
  gal,
  TSS,
  librarySize,
  upstream = 1010L,
  downstream = 1010L,
  n.tile = 101L,
  normal.method = "quantile",
  adjustFragmentLength = 80L,
  TSS.filter = 0.5,
  seqlev = paste0("chr", c(1:22, "X", "Y"))
)
}
\arguments{
\item{bamfiles}{A vector of characters indicates the file names of bams.}

\item{index}{The names of the index file of the 'BAM' file being processed;
This is given without the '.bai' extension.}

\item{gal}{A GAlignmentsList object or a list of GAlignmentPairs.
If bamfiles is missing, gal is required.}

\item{TSS}{an object of \link[GenomicRanges:GRanges-class]{GRanges} indicates
the transcript start sites. All the width of TSS should equal to 1.
Otherwise, TSS will be reset to the center of input TSS.}

\item{librarySize}{A vector of numeric indicates the library size. Output of
\link[ChIPpeakAnno]{estLibSize}}

\item{upstream, downstream}{numeric(1) or integer(1).
Upstream and downstream size from each TSS.}

\item{n.tile}{numeric(1) or integer(1). The number of tiles to generate
for each element of TSS.}

\item{normal.method}{character(1). Normalization methods,
could be "none" or "quantile".
See \link[limma]{normalizeBetweenArrays}.}

\item{adjustFragmentLength}{numeric(1) or integer(1).
The size of fragment to be adjusted to.
Default is set to half of the nucleosome size (80)}

\item{TSS.filter}{numeric(1). The filter for signal strength of each TSS.
Default 0.5 indicates the average signal strength for the TSS
from upstream to downstream bins should be greater than 0.5.}

\item{seqlev}{A vector of character indicates the sequence names to be
considered.}
}
\value{
A list of matrixes. In each matrix, each row record the signals for
corresponding feature.
}
\description{
Get the enrichment signals for nucleosome-free fagments and
             nucleosomes.
}
\examples{

bamfiles <- system.file("extdata", "splited",
                       c("NucleosomeFree.bam",
                         "mononucleosome.bam",
                         "dinucleosome.bam",
                         "trinucleosome.bam"), package="ATACseqQC")
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txs <- transcripts(TxDb.Hsapiens.UCSC.hg19.knownGene)
TSS <- promoters(txs, upstream=0, downstream=1)
library(ChIPpeakAnno)
librarySize <- estLibSize(bamfiles)
sigs <- enrichedFragments(bamfiles, TSS=TSS, librarySize=librarySize,
                          seqlev="chr1", TSS.filter=0)
sigs.log2 <- lapply(sigs, function(.ele) log2(.ele+1))
featureAlignedHeatmap(sigs.log2, reCenterPeaks(TSS, width=2020),
                      zeroAt=.5, n.tile=101, upper.extreme=2)
featureAlignedDistribution(sigs, reCenterPeaks(TSS, width=2020),
                           zeroAt=.5, n.tile=101, type="l")

}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/footprintsScanner.R
\name{footprintsScanner}
\alias{footprintsScanner}
\alias{prepareBindingSitesList}
\title{scan ATAC-seq footprints infer factor occupancy genome wide}
\usage{
footprintsScanner(
  bamExp,
  bamCtl,
  indexExp = bamExp,
  indexCtl = bamCtl,
  bindingSitesList,
  seqlev = paste0("chr", c(1:25, "X", "Y")),
  proximal = 40L,
  distal = proximal,
  gap = 10L,
  maximalBindingWidth = NA,
  cutoffLogFC = log2(1.5),
  cutoffPValue = 0.05,
  correlatedFactorCutoff = 3/4
)

prepareBindingSitesList(
  pfms,
  genome,
  seqlev = paste0("chr", c(1:22, "X", "Y")),
  expSiteNum = 5000
)
}
\arguments{
\item{bamExp}{A vector of characters indicates the file names of experiment bams. 
The bam file must be the one with shifted reads.}

\item{bamCtl}{A vector of characters indicates the file names of control bams. 
The bam file must be the one with shifted reads.}

\item{indexExp, indexCtl}{The names of the index file of the 'BAM' file being processed;
This is given without the '.bai' extension.}

\item{bindingSitesList}{A object of \link[GenomicRanges:GRangesList-class]{GRangesList} indicates
candidate binding sites (eg. the output of fimo).}

\item{seqlev}{A vector of characters indicates the sequence levels.}

\item{proximal, distal}{numeric(1) or integer(1).
basepair for open region from binding sites (proximal) and extented region for background (distal) 
of the binding region for aggregate ATAC-seq footprint.}

\item{gap}{numeric(1) or integer(1). basepair for gaps among binding sites, 
proximal, and distal. default is 5L.}

\item{maximalBindingWidth}{numeric(1) or integer(1). Maximal binding sites width for
all the motifs. If setted, all motif binding sites will be 
re-sized to this value.}

\item{cutoffLogFC, cutoffPValue}{numeric(1). Cutoff value for differential bindings.}

\item{correlatedFactorCutoff}{numeric(1). Cutoff value for correlated factors. 
If the overlapping binding site within 100bp is more than cutoff, the TFs will be treated as correlated factors.}

\item{pfms}{A list of Position frequency Matrix represented as a numeric matrix
with row names A, C, G and T.}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome}.}

\item{expSiteNum}{numeric(1). Expect number of predicted binding sites.
if predicted binding sites is more than this number, top expSiteNum binding
sites will be used.}
}
\value{
a list.
It includes:
 - bindingSites            GRanges of binding site with hits of reads
 - data                    a list with test result for each binding site
 - results                 a data.frame with open score and enrichment score of motifs
}
\description{
Aggregate ATAC-seq footprint for a bunch of motifs generated
             over binding sites within the genome.
}
\examples{

bamfile <- system.file("extdata", "GL1.bam",
                       package="ATACseqQC")
bsl <- system.file("extdata", "jolma2013.motifs.bindingList.95.rds",
                  package="ATACseqQC")
bindingSitesList <- readRDS(bsl)
footprintsScanner(bamfile, seqlev="chr1", bindingSitesList=bindingSitesList)

library(MotifDb)
motifs <- query(MotifDb, c("Hsapiens"))
motifs <- as.list(motifs)
library(BSgenome.Hsapiens.UCSC.hg19)
#bindingSitesList <- prepareBindingSitesList(motifs, genome=Hsapiens)
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiftGAlignmentsList.R
\name{shiftGAlignmentsList}
\alias{shiftGAlignmentsList}
\title{shift 5' ends}
\usage{
shiftGAlignmentsList(
  gal,
  positive = 4L,
  negative = 5L,
  outbam,
  BPPARAM = NULL,
  slidingWindowSize = 5e+07
)
}
\arguments{
\item{gal}{An object of \link[GenomicAlignments:GAlignmentsList-class]{GAlignmentsList}.}

\item{positive}{integer(1). the size to be shift for positive strand}

\item{negative}{integer(1). the size to be shift for negative strand}

\item{outbam}{file path to save shift reads. If missing, no file will be write.}

\item{BPPARAM}{The parallel parameters used by BiocParrallel.}

\item{slidingWindowSize}{The width of each tile when the input is big file.
By default 50e6, the memory cost will be about 6GB for each thread for a 5GB bam file.
Increase the value will increase the memory cost but may speed up the process.}
}
\value{
An object of \link[GenomicAlignments:GAlignments-class]{GAlignments} with 5' end 
shifted reads. The PCR duplicated will be removed unless there is metadata
keepDuplicates set to TRUE.
}
\description{
shift the GAlignmentsLists by 5' ends. 
All reads aligning to the positive strand will be offset by +4bp, 
and all reads aligning to the negative strand will be offset -5bp by default.
}
\examples{
bamfile <- system.file("extdata", "GL1.bam", package="ATACseqQC")
tags <- c("AS", "XN", "XM", "XO", "XG", "NM", "MD", "YS", "YT")
library(BSgenome.Hsapiens.UCSC.hg19)
which <- as(seqinfo(Hsapiens)["chr1"], "GRanges")
gal <- readBamFile(bamfile, tag=tags, which=which, asMates=TRUE)
objs <- shiftGAlignmentsList(gal)
export(objs, "shift.bam")
\dontrun{
  bamfile <- 'a.big.file.bam'
  tags <- c("NM", "MD")
  which <- GRanges(c('chr1:1-249250621:*', 'chr2:1-243199373:*'))
  gal <- readBamFile(bamfile, tag=tags, which=which, 
  asMates=TRUE, bigFile=TRUE)
  library(BiocParallel)
  BPPARAM <- MulticoreParam(workers = 2, progress=TRUE)
  objs <- shiftGAlignmentsList(gal, BPPARAM = BPPARAM,
   outbam="shift.bam")
}
}
\author{
Jianhong Ou
}
